.\"=====================================================================
.\"  @Troff-man-file{
.\"     author          = "Nelson H. F. Beebe",
.\"     version         = "1.00",
.\"     date            = "04 December 1997",
.\"     time            = "07:32:58 MST",
.\"     filename        = "htmlpty.man",
.\"     address         = "Center for Scientific Computing
.\"                        University of Utah
.\"                        Department of Mathematics, 105 JWB
.\"                        155 S 1400 E RM 233
.\"                        Salt Lake City, UT 84112-0090
.\"                        USA",
.\"     telephone       = "+1 801 581 5254",
.\"     FAX             = "+1 801 581 4148",
.\"     checksum        = "04560 6414 23292 246670",
.\"     email           = "beebe@math.utah.edu, beebe@acm.org,
.\"                        beebe@ieee.org (Internet)",
.\"     codetable       = "ISO/ASCII",
.\"     keywords        = "HTML, prettyprinter, SGML, WWW, World-Wide
.\"                        Web",
.\"     supported       = "yes",
.\"     docstring       = "This file contains the UNIX manual pages
.\"                        for the html-pretty utility, a program for
.\"                        prettyprinting World-Wide Web HyperText
.\"                        Markup Language (HTML) files.
.\"
.\"                        The checksum field above contains a CRC-16
.\"                        checksum as the first value, followed by the
.\"                        equivalent of the standard UNIX wc (word
.\"                        count) utility output of lines, words, and
.\"                        characters.  This is produced by Robert
.\"                        Solovay's checksum utility.",
.\"  }
.\"=====================================================================
.TH HTML-PRETTY 1 "04 December 1997" "Version 1.00"
.\"=====================================================================
.\"
.if t .ds La L\\h'-0.24m'\\v'-0.15v'\\s-2A\\s0\\h'-0.15m'\\v'0.15v'T\\h'-0.1667m'\\v'0.20v'E\\v'-0.20v'\\h'-0.125m'X
.if n .ds La LaTeX
.\"
.if t .ds Ps P\s-2OST\s0S\s-2CRIPT\s0
.if n .ds Ps PostScript
.\"
.if t .ds Te T\\h'-0.1667m'\\v'0.20v'E\\v'-0.20v'\\h'-0.125m'X
.if n .ds Te TeX
.\"
.\"=====================================================================
.SH NAME
html-pretty \- prettyprint HTML and SGML files
.\"=====================================================================
.SH SYNOPSIS
.B html-pretty
[
.B \-?
]
[
.B \-author
]
[
.B \-blank-line-warning
]
.if n .ti +12n
[
.B \-brief
]
[
.BI \-catalogfile " filename"
]
.if n .ti +12n
.if t .ti +\w'\fBhtml-pretty\fP\ 'u
[
.B \-check-tag-nesting
]
[
.B \-comment-banner
]
.if n .ti +12n
[
.B \-convert-paragraph-breaks
]
.if n .ti +12n
.if t .ti +\w'\fBhtml-pretty\fP\ 'u
[
.B \-copyright
]
[
.BI \-email-address " user" "\&" "@hostname"
.\" NB: NOT "user@hostname": that generates illegal nested anchor in HTML
]
.if n .ti +12n
[
.BI \-extend-style " 'style: TAG TAG .\|.\|.'"
]
.if n .ti +12n
.if t .ti +\w'\fBhtml-pretty\fP\ 'u
[
.BI \-extend-style " 'TAG: TAG TAG .\|.\|.'"
]
.if n .ti +12n
[
.BI \-file " filename"
]
[
.BI \-grammar-level " grammar"
]
.if n .ti +12n
.if t .ti +\w'\fBhtml-pretty\fP\ 'u
[
.B \-help
]
[
.BI \-indent " nnn"
]
[
.B \-keep-format
]
.if n .ti +12n
[
.BI \-logfile " filename"
]
[
.B \-no-blank-line-warning
]
.if n .ti +12n
.if t .ti +\w'\fBhtml-pretty\fP\ 'u
[
.B \-no-brief
]
[
.B \-no-check-tag-nesting
]
.if n .ti +12n
[
.B \-no-comment-banner
]
.if n .ti +12n
.if t .ti +\w'\fBhtml-pretty\fP\ 'u
[
.B \-no-convert-paragraph-breaks
]
.if n .ti +12n
[
.B \-no-keep-format
]
[
.B \-no-print-stylefile
]
.if n .ti +12n
.if t .ti +\w'\fBhtml-pretty\fP\ 'u
[
.B \-no-quiet
]
[
.B \-no-read-stylefiles
]
.if n .ti +12n
[
.B \-no-trace-opens
]
[
.B \-no-unknown-tag-warning
]
.if n .ti +12n
.if t .ti +\w'\fBhtml-pretty\fP\ 'u
[
.BI \-no-warnings-in-comments
]
.if n .ti +12n
[
.BI \-outfile " filename"
]
[
.BI \-personal-name " name"
]
.if n .ti +12n
.if t .ti +\w'\fBhtml-pretty\fP\ 'u
[
.B \-print-stylefile
]
[
.B \-quiet
]
.if n .ti +12n
[
.B \-read-stylefiles
]
[
.BI \-stylefile " filename"
]
.if n .ti +12n
[
.B \-trace-opens
]
.if t .ti +\w'\fBhtml-pretty\fP\ 'u
[
.B \-unknown-tag-warning
]
.if n .ti +12n
[
.B \-version
]
[
.BI \-warnings-in-comments
]
.if n .ti +12n
[
.BI \-width " nnn"
]
.if n .ti +12n
.if t .ti +\w'\fBhtml-pretty\fP\ 'u
[
<
.I infile
or
.I file(s)
]
[
>
.I outfile
]
.\"=====================================================================
.SH DESCRIPTION
.PP
.B html-pretty
filters its HTML or SGML input from
.IR stdin ,
or from one or more named files given on the command line, and
prettyprints it to
.IR stdout ,
standardizing the spacing, and providing indentation to expose
the document structure.
.PP
When its input is just a plain text file in the ASCII or ISO 8859-1
character sets, a major part of the conversion of text to
grammatically-correct HTML can be done automatically, especially if the
.B \-convert-paragraph-breaks
option is used.  Section headings, verbatim, and tabular material will,
however, require manual editing.
.PP
HTML (HyperText Markup Language) is the language used to specify
formatting instructions in text files intended for viewing with
.I "World-Wide Web"
(WWW) client programs (browsers), such as
.BR amaya (1),
.BR arena (1),
.BR chimera (1),
.BR grail (1),
.BR hotjava (1),
.BR jde (1),
.BR lynx (1),
.BR netscape (1),
.BR panorama (1),
and
.BR xmosaic (1).
.PP
The WWW idea began in late 1992, and because viewer programs support
display of text, line drawings, color raster images, hypertext links,
and uniform access to several Internet services, including file
transfer, in the first two years, the number of WWW servers grew from
zero to several hundred thousand, and some of the more popular sites
receive up to twenty-five million accesses a day from all over the
Internet.  Consequently, many Internet computer users are beginning to
write HTML documents for their own home pages, and
.B html-pretty
is written for them.
.PP
The goal of a prettyprinter is to recognize all legal inputs, and
produce output that is indented to reflect the structure, and in which
line lengths have been restricted for improved readability.
Irregularities in coding practice, and outright errors, are more likely
to be detected in the prettyprinted output, than in the input.
.PP
SGML (Standard General Markup Language, ISO 8879), and its particular
document type definition instance, HTML, follow a rigorous grammar for
text markup that makes it possible to clearly identify document parts,
such as headings, sections, subsections, paragraphs, figures, tables,
equations, and so on, and files with such standardized markup are
particularly good candidates for prettyprinting.
.PP
The definition of HTML is still evolving.  Version 2.0 (Fall 1994) is
implemented by almost all browsers.  Version 3.0, informally called
HTML Plus, was introduced in March, 1995, and the
.BR arena (1)
browser was developed at the World-Wide Web Consortium, W3C, to serve
as a testbed for it.
.PP
Although Version 3.0 is a superset of version 2.0, it proved too
difficult for browser implementors to incorporate support for it in a
reasonable time, and it was withdrawn in Fall, 1996.  Version 3.2 was
released on 14 January 1997, but despite its higher version number, it
lacks many of the new features introduced in version 3.0, notably for
mathematical markup, but importantly, it
.I does
include support for figures and tables.  As with version 3.0, there is
also a testbed browser, this time called
.BR amaya (1),
and augmented with the ability to edit HTML files, providing a
(simple-minded) WYSIWYG editor interface that some users may find
convenient for creating and maintaining HTML files.
.PP
At the time of writing in Fall, 1997, only the
.BR amaya (1)
and
.BR netscape (1)
browsers appear to have implemented all, or most, of HTML 3.2.
.PP
Further information about HTML versions 3.0 and 3.2 can be found on
the World-Wide Web at the
.I "Uniform Resource Locators"
(URLs)
.PP
.RS
.nf
\&\fChttp://www.w3.org/MarkUp/Wilbur/\fP
\&\fChttp://www.w3.org/TR/REC-html32.html\fP
.fi
.RE
.PP
The next version of HTML, code-named
.IR Cougar ,
is under development, and will become version 4.0 when it is finally
released.  The first draft public release was on 8 July 1997, and a
second proposed recommendation followed on 7 November 1997.  For
details, visit URLs
.PP
.RS
.nf
\&\fChttp://www.w3.org/MarkUp/Cougar/\fP
\&\fChttp://www.w3.org/TR/WD-html40/\fP
\&\fChttp://www.w3.org/TR/PR-html40/\fP
.fi
.RE
.PP
Interestingly, translations of the version 4.0 specification to at least
18 other human languages are in progress: see URLs
.PP
.RS
.nf
\&\fChttp://www.w3.org/TR/WD-html40/translations.html\fP
\&\fChttp://www.w3.org/TR/PR-html40-971107/translations.html\fP
.fi
.RE
.PP
.B html-pretty
recognizes all HTML tags in the grammars of versions 1.0, 2.0,
3.0, 3.2, and proposed 4.0, plus a few vendor-specific extensions.
.PP
One significant difference between the grammar versions is that the
HTML tag
.I <P>
is a
.I "paragraph separator"
in version 2.0, while it is a
.I "paragraph begin"
in later versions, and consequently expects to have a matching
.I </P>
.I "paragraph end"
tag that is not required in 2.0.
.B html-pretty
will supply missing
.I </P>
tags, and delete empty
.I "<P> .\|.\|. </P>"
environments.  Since HTML translators ignore unknown tags, this is
transparent to HTML version 2.0 implementations, and causes no
problems.
.PP
.B html-pretty
expects that its input is reasonably well-formed. Usually it is
sufficient that the file can be displayed by one or more WWW browsers,
producing the expected form.  However, it would be unwise to write a
large amount of program code without a compiler to check it, and it is
similarly unwise to write documentation in HTML or SGML without at
least a validating parser to ensure that the text is syntactically
correct.
.PP
Fortunately, at least two such programs are publicly available (thanks
to the generosity of their author, James Clark),
.BR nsgmls (1)
and
.BR sgmls (1),
together with UNIX shell scripts,
.BR html-check (1)
and
.BR html-ncheck (1),
to facilitate their use with HTML files.  In addition, the
.BR nsgmls (1)
distribution is accompanied by two SGML tag normalizers,
.BR sgmlnorm (1)
and
.BR spam (1),
and there is a UNIX shell script,
.BR html-spam (1),
for one of them.  You may therefore find it useful to apply
.BR html-spam (1),
and either
.BR html-check (1)
or
.BR html-ncheck (1),
to your HTML files, and fix all of the errors that they detect, before
filtering the files with
.BR html-pretty .
.PP
HTML strictly requires a certain amount of
.I boiler-plate
to be wrapped around the text, and there is ample evidence that most
HTML files omit these wrappers, because WWW browsers are written to be
tolerant of grammatical deviations.
.B html-pretty
will supply the wrappers if they are omitted; indeed, if given an
empty input file,
.B html-pretty
produces output similar to this:
.PP
.RS
.nf
\&\fC<!-- -*-html-*- -->
<!-- Prettyprinted by html-pretty flex version 1.00 [11-Nov-1997] -->
<!-- on Tue Nov 11 16:23:39 1997 -->
<!-- for Nelson H. F. Beebe (beebe@plot79.math.utah.edu) -->

<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">

<HTML>
    <HEAD>
        <TITLE>
            <!-- Please supply a descriptive title here -->
        </TITLE>
        <!-- Please supply a correct e-mail address here -->
        <LINK REV="made" HREF="mailto:beebe@plot79.math.utah.edu">
    </HEAD>
    <BODY>
    </BODY>
</HTML>\fP
.fi
.RE
.PP
This example, minus the comments \&\fC<!-- .\|.\|. -->\fP, shows the
minimal markup that should be expected in an HTML file, although the
grammar permits the HTML, HEAD and BODY environments to be implicitly
assumed if they are omitted.  While most WWW browsers ignore the DOCTYPE
declaration, it is essential for SGML parsers, since it identifies the
grammar rules that apply to what follows.  Two recent WWW browsers,
.BR amaya (1)
and
.BR panorama (1),
are SGML-grammar based, and may require a valid DOCTYPE declaration.
.\"=====================================================================
.SH OPTIONS
Command-line options affect all following filenames.  Option values
are always provided as separate arguments following the option name.
Letter case in option names is
.I not
significant, although it may be in option values.  Option names may be
abbreviated to any unique leading prefix, unless a shorter prefix is
documented.
.PP
Any argument that begins with a hyphen is expected to be an option,
and will raise an error if it is not recognized.  If a filename begins
with a hyphen, you therefore need to disguise it by supplying a
leading directory path.  For example,
.IR ./\-foo
represents the file named
.I \-foo
in the current directory in UNIX.
.PP
GNU- and POSIX-style options of the form
.B \-\|\-name
are also recognized: they begin with two option prefix characters.
.PP
For every option
.B \-xxx
that sets a Boolean flag to be acted upon later, there is a
corresponding
.B \-no-xxx
option to override it.  The negative forms are normally not required,
but are necessary to counteract options set in a style file.
.PP
.\"---------------------------------------------------------------------
.\" In a list of the 38 option names sorted by name length, the median
.\" in the list is -email-address, and it is within 0.29 characters of
.\" the average name length (13.71), so we use it as the indentation
.\" width in the option description tagged paragraphs.
.TP \w'\fB\-email-address\fP'u+3n
.B \-author
Show author information on
.I stderr
and quit after processing any remaining command-line
options that precede the next command-line HTML file.
.\"---------------------------------------------------------------------
.TP
.B \-blank-line-warning
Unlike most word processing and typesetting systems, and ordinary
typewritten text, in HTML and SGML, blank lines do
.I not
imply a paragraph break, except in verbatim environments.  You can
select this option to get warnings about such blank lines.  They will
be reduced to a single blank line, leaving space for later manual
insertion of a <P> tag, if that was indeed what was intended [default:
.BR \-no-blank-line-warning ].
.IP
If you specify the
.B \-convert-paragraph-breaks
option, then this option will have no effect.
.\"---------------------------------------------------------------------
.TP
.B \-brief
Brief mode: exclude the standard boiler-plate wrapper of
.IR !DOCTYPE ,
.IR HTML ,
.IR HEAD ,
and
.I BODY
tags [default:
.BR \-no-brief ].
.IP
This option, in conjunction with
.BR \-no-comment-banner ,
is convenient for prettyprinting small fragments of text, such as
from inside a text editor.  It can also be used for portions of
larger documents (e.g., chapters of a book) that are not in
themselves complete HTML files.
.IP
This option can be abbreviated to
.BR \-b .
.\"---------------------------------------------------------------------
.TP
.BI \-catalogfile " filename"
Specify an alternate catalog file to override the default one.  See
the
.B "CATALOG DIRECTORY"
section for more details.
.IP
This option can be abbreviated to
.BR \-c .
.\"---------------------------------------------------------------------
.TP
.B \-check-tag-nesting
Use built-in tables, or tables from style files, of
tag-is-contained-in and tag-cannot-contain relations to check that
tags are properly nested.  The rules that govern this are very
complex, and depend on the grammar level chosen. The precise relations
are tabulated in the
.B "HTML GRAMMAR CONSTRAINTS"
section, and the way they are provided to
.B html-pretty
is described in the
.B "STYLE FILES"
section.
.IP
Because this option can lead to a large number of warning messages
when optional end tags are omitted, the default is
.BR \-no-check-tag-nesting .
.IP
Nevertheless, when a proper SGML parser, such as
.BR html-check (1)
or
.BR html-ncheck (1),
is not available, this option can be very helpful in diagnosing errors
of tag usage.
.\"---------------------------------------------------------------------
.TP
.B \-comment-banner
Generate a leading comment banner containing the prettyprinter version
number and date, the current date and time, and the personal name and
email address of the user who ran the prettyprinter [default:
.BR \-comment-banner ].
.\"---------------------------------------------------------------------
.TP
.B \-convert-paragraph-breaks
Convert paragraph breaks (sequences of one or more blank or empty
lines) to HTML <P> tags [default:
.BR \-no-convert-paragraph-breaks ].
.IP
This option is intended for converting text files to HTML; it should
not be used when the input file is already HTML, unless the intent
really is to insert explicit paragraph tags.
.IP
This option has no effect on blank lines inside verbatim environments.
.\"---------------------------------------------------------------------
.TP
.B \-copyright
.TP
.B \-copyleft
Show copyright information on
.I stderr
and quit after processing any remaining command-line
options that precede the next command-line HTML file.
.\"---------------------------------------------------------------------
.TP
.BI \-email-address " user" "\&" "@hostname"
.\" NB: NOT "user@hostname": that generates illegal nested anchor in HTML
Supply an alternate electronic mail address to be used in the comment
banner and the LINK tag.  Otherwise, a default address is constructed
from the current user name and host name, when that information is
available from the operating system.
.IP
This option may also be spelled
.BR \-e-mail-address ,
since both e-mail and email are about equally common abbreviations on
the World-Wide Web.
.\"---------------------------------------------------------------------
.TP
.BI \-extend-style " 'style: TAG TAG ...'"
.TP
.BI \-extend-style " 'TAG: TAG TAG ...'"
These options, whose name can be abbreviated to just
.BR \-e ,
provide a quick command-line alternative to the style file
feature of the
.B \-stylefile
option.  They permit you to augment the list of tags associated with a
particular formatting style class, or to add a list of tags to the
same class as an existing tag (to avoid the need to know the style
class names), but only for the duration of the current process.
.IP
Since a tag can belong to only a single style class at one time,
specification of existing tags with these options effectively removes
their old style class association.
.IP
.B html-pretty
distinguishes between the two cases by looking up the first name in
its tag table.  If it is entirely in uppercase, then it might be found
there.  Otherwise, it is a style class name.
.IP
If the style class is not recognized, an error message is issued with
a list of the recognized class names, and execution is terminated
after processing any remaining command-line options that precede the
next command-line HTML file.  Thus, an option
.BI \-extend-style " foo:bar'
or
.BI \-extend-style " help=me'
with obviously incorrect class and tag names can be used to coax
a list of the valid ones from
.BR html-pretty ;
it will respond with something like this:
.IP
.RS
.RS
.nf
\&\fC:1:unknown style [foo] command [BAR] at line 0
in style source [command-line]

The recognized style classes are:
        body doctype font head html
        line-break link list list-header
        list-item markup-declaration math
        math-pair pair paragraph plaintext
        public section short standalone
        standalone-nocheck title verbatim\fP
.fi
.RE
.RE
.IP
The output line width in this list is governed by the
.B \-width
option.
.IP
You can assign tags to the special style class name
.I default
to make them unknown (and also, warned about, if you supply the
.B \-unknown-tag-warning
option), e.g.,
.IR "default:blink" .
.IP
Because some operating systems do not allow embedded spaces in
command-line arguments, you can separate the tags in the value
string with a comma instead of whitespace.  Also, you can use an
equals sign instead of a colon after the first word.  For
example, the value strings
.IP
.RS
.RS
.nf
.IR "font:A,MEDIUM"
.IR "font=A,MEDIUM"
.IR "'font   =   A    MEDIUM'"
.IR "'font :     A,,,,MEDIUM'"
.fi
.RE
.RE
.IP
all assign tags
.I A
and
.I MEDIUM
to the font style class.  Incidentally, some people prefer
.I A
(anchor) tag pairs to be treated this way, rather than their default
of being placed on separate lines, even though long hypertext
references in \fC<A HREF="...">\fP make this style hard to read.
.IP
For more information on this topic, see the
.B "STYLE FILES"
section below.
.\"---------------------------------------------------------------------
.TP
.BI \-file " filename"
Supply an alternate input filename for use in the output comment
banner.  This overrides the actual filename(s), and provides a way to
name the output, even when no named input file is available, because
standard input is redirected, or comes from a pipe.
.\"---------------------------------------------------------------------
.TP
.BI \-grammar-level " grammar"
Select a grammar level that in turn will select a suitable style file.
See the
.B "CATALOG DIRECTORY"
and
.B "STYLE FILES"
sections for more details.
.IP
Lettercase is
.I not
significant in grammar-level names.
.IP
You can use this option, together with the
.B \-unknown-tag-warning
option, to help detect use of HTML tags that are not part of the
grammar.  However, a better, and grammatically rigorous, way to do
this is to use a validating SGML parser, such as those accessible via
the
.BR html-check (1)
and
.BR html-ncheck (1)
scripts.
.IP
The built-in default grammar level is a union of the HTML grammar levels
1.0, 2.0, 3.0, 3.2, and proposed 4.0, plus selected browser-vendor
extensions.
.IP
A properly-installed
.B html-pretty
always supports at least grammar levels
.IR 1.0,
.IR 2.0,
.IR 3.0,
.IR 3.2,
.IR 4.0,
plus one named
.I all
which contains a union of all of the grammar styles in the catalog
directory.  This will be similar to the built-in default style, but
may differ from it in minor details, since it is easier to augment the
style file than it is to rebuild and reinstall the software.
.IP
There is also a `grammar level' named
.IR dtd ;
it augments the normal style rules with additional ones for extra
declarations and tags found in SGML and HTML
.I "Document Type Definition"
(DTD) files.
.IP
If you specify an incorrect grammar level,
.B html-pretty
will display a message showing the available levels, and then quit:
.IP
.RS
.RS
.nf
\&\fChtml-pretty -g foo
:1:could not find grammar level [foo] in
catalog file [/usr/local/share/lib/html-pretty/catalog]:
    levels available:  all dtd 2 2.0 3 3.0 3.2 4 4.0\fP
.fi
.RE
.RE
.IP
If the style file has a
.I public
style class entry, the output DOCTYPE declaration will use its value,
instead of a built-in default; see the
.B "STYLE FILES"
section below for details.
.IP
Tip: if you want to find out the differences in the sets of HTML tags
accepted by two different grammar versions, use this option with the
.B \-print-stylefile
and
.B \-width
options like this:
.IP
.RS
.RS
.nf
\&\fChtml-pretty -w 0 -g 3.2 -p >foo.3.2\fP
\&\fChtml-pretty -w 0 -g 4.0 -p >foo.4.0\fP
\&\fCdiff foo.3.2 foo.4.0\fP
.fi
.RE
.RE
.IP
The difference listing will show just those style classes where the
tag lists differ, since each class will be complete on one (possibly
long) line.
.\"---------------------------------------------------------------------
.TP
.BR \-help " or " \-?
Display brief usage information on
.I stderr
and quit after processing any remaining command-line
options that precede the next command-line HTML file.
.\"---------------------------------------------------------------------
.TP
.BI \-indent " nnn"
Set the number of spaces for each indentation level [default:
.IR 4 ].
.\"---------------------------------------------------------------------
.TP
.B \-keep-format
Treat the input stream as verbatim text whose visual format is to be
exactly preserved.  It will be converted to the body of a preformatted
HTML environment, <PRE> .\|.\|. </PRE>, and all characters will be
output unchanged,
.I except
for the four characters `<', `>', `&', and `"', which will be
translated to SGML entities `&lt;', `&gt;', `&amp;', and either
`&quot;' or `&34;' (depending on the grammar level), respectively.
.IP
This option is useful for converting non-HTML text to HTML when the
linebreaking and indentation are already decided, such as preformatted
tables, samples of computer program input and output, and programming
language fragments.
.IP
Horizontal tab characters are treated like spaces in HTML, but most
Web browsers will display text containing tabs as if each tab caused
blank fill up to, and including, the next column which is a multiple
of eight, which is the conventional behavior on many systems. The
visual appearance is correct if the text is displayed with a
fixed-width font, but is usually wrong with a proportionally-spaced
font.
.IP
However, when asked to save the file as plain text, some browsers will
save text with tabs, and others will save text with tabs expanded to
spaces, thereby preserving the original appearance.  When the same
text is cut with the mouse and pasted into another window, some
browsers preserve tabs, and others convert it to spaces.  And even
more confusingly, a browser that converts tabs to spaces in a saved
file may leave tabs intact in cut-and-pasted text!
.IP
In most cases, tabs are not significant, but they
.I are
for UNIX
.IR Makefile s,
so if your text has significant tabs, you should incorporate a warning
that they will likely be destroyed by the Web browser, and will need
to be restored manually, or with a pass through a filter such as
.BR unexpand (1).
.IP
.B html-pretty
always treats tabs as ordinary characters, but if you want to be sure
of correct display of tabs according to the conventional blank-fill
rule, you should filter the input to
.B html-pretty
using a tab expander such as
.BR expand (1).
.IP
For Fortran code containing tab characters, the meaning of tabs is
context sensitive, and you need to use a Fortran-tab aware converter.
There is no standard UNIX utility to do this, although a local
.BR emacs (1)
editor function
.I "M-x detab-fortran"
will do the job.
.\"---------------------------------------------------------------------
.TP
.BI \-logfile " filename"
Redirect warning and error messages from
.I stderr
to the indicated filename.  This option is provided for user
convenience on poorly-designed operating systems (e.g., IBM
PC DOS) that fail to provide for redirection of
.I stderr
to a specified file.
.IP
This option can also be used for discarding messages, with, e.g.,
on UNIX systems,
.BI \-logfile " /dev/null."
.IP
If the file cannot be opened for output,
.B html-pretty
will terminate silently with a non-zero exit code, because the
internal attempted redirection required the closure of
.IR stderr ,
making it unavailable for printing further error messages.
.\"---------------------------------------------------------------------
.TP
.B \-no-blank-line-warning
Override an earlier
.B \-blank-line-warning
option.  Unlike most word processing and typesetting systems, and
ordinary typewritten text, in HTML and SGML, blank lines do
.I not
imply a paragraph break, except in verbatim environments.
.B html-pretty
will therefore normally silently reduce such blank lines to a single
space [default:
.BR \-no-blank-line-warning ].
.IP
If you specify the
.B \-convert-paragraph-breaks
option, then this option will have no effect.
.\"---------------------------------------------------------------------
.TP
.B \-no-brief
Override an earlier
.B \-brief
option, so that the standard wrapper
.IR !DOCTYPE ,
.IR HTML ,
.IR HEAD ,
and
.I BODY
tags are generated  [default:
.BR \-no-brief ].
.\"---------------------------------------------------------------------
.TP
.B \-no-check-tag-nesting
Suppress checks for correct tag nesting [default:
.BR \-no-check-tag-nesting ].
.\"---------------------------------------------------------------------
.TP
.B \-no-comment-banner
Suppress generation of the default leading comment banner.
.IP
This option can be abbreviated to
.BR \-n ,
since it may be used frequently [default:
.BR \-comment-banner ].
.\"---------------------------------------------------------------------
.TP
.B \-no-convert-paragraph-breaks
Do not convert paragraph breaks (sequences of one or more blank or
empty lines) to HTML <P> tags [default:
.BR \-no-convert-paragraph-breaks ].
Instead, unless the
.B \-blank-line-warning
option has been given, the empty lines will be reduced to a single
space.
.\"---------------------------------------------------------------------
.TP
.B \-no-keep-format
Override an earlier
.B \-keep-format
option, and thus permit reformatting of the input stream [default:
.B \-no-keep-format ].
.\"---------------------------------------------------------------------
.TP
.B \-no-print-stylefile
Override an earlier
.B \-print-stylefile
option, and therefore, do not terminate execution before processing
style files [default:
.BR \-no-print-stylefile ].
.\"---------------------------------------------------------------------
.TP
.B \-no-quiet
Override an earlier
.B \-quiet
option, to restore output of warning messages on
.I stderr
[default:
.BR \-no-quiet ].
.\"---------------------------------------------------------------------
.TP
.B \-no-read-stylefiles
Suppress reading of the three default style files (see the
.B "STYLE FILES"
section below) [default:
.BR \-read-stylefiles ].
.IP
Style files implicitly specified with
.B \-grammar-level
options, or explicitly specified with
.B \-stylefile
options, will still be processed.
.\"---------------------------------------------------------------------
.TP
.B \-no-trace-opens
Override an earlier
.B \-trace-opens
option, so that file opening attempts are not traced on
.I stderr
[default:
.BR \-no-trace-opens ].
.\"---------------------------------------------------------------------
.TP
.B \-no-unknown-tag-warning
Override an earlier
.B \-unknown-tag-warning
option, so that unknown HTML tags will not elicit a warning
message [default:
.BR \-no-unknown-tag-warning ].
.\"---------------------------------------------------------------------
.TP
.B \-no-warnings-in-comments
Override an earlier
.B \-warnings-in-comments
option, so that warning and error messages are written only
to
.I stderr
(which might have been redirected with the
.B \-logfile
option) [default:
.BR \-no-warnings-in-comments ].
.\"---------------------------------------------------------------------
.TP
.BI \-outfile " filename"
Redirect output from
.I stdout
to the indicated filename.  This option is provided for user convenience
on operating systems that fail to provide for redirection of
.I stdout
to a specified file.
.\"---------------------------------------------------------------------
.TP
.BI \-personal-name " name"
Supply an alternate personal name string to be used in the comment
banner.  Normally, the personal name is determined via the current
user name, when that information is available from the operating
system.
.\"---------------------------------------------------------------------
.TP
.B \-print-stylefile
Print a style file on
.I stdout
and quit after processing any remaining command-line options that
precede the next command-line HTML file.
.IP
This option can be abbreviated to
.BR \-p .
.IP
The output line width in the style file is governed by the
.B \-width
option described later.
.IP
Startup option files, and any preceding
.BR \-extend-style ,
.BR \-grammar-level ,
and
.B \-stylefile
options will already have been processed, and their changes will be
reflected in the output produced by this option.
.IP
Use this option to find out how each recognized tag is processed,
and also to get a template style file that you can customize.
The style class names and tag lists are ordered alphabetically
for improved readability.  For more details, see the
.B "STYLE FILES"
section below.
.\"---------------------------------------------------------------------
.TP
.B \-quiet
Suppress output of warning messages on
.IR stderr .
Error messages will, however,
.I not
be suppressed.
.IP
If you really want to discard error messages too, then use the
.BI \-logfile " /dev/null"
option instead.
.\"---------------------------------------------------------------------
.TP
.B \-read-stylefiles
Override an earlier
.B \-no-read-stylefiles
option, so that the three standard style files (see the
.B "STYLE FILES"
section below) are read [default:
.BR \-read-stylefiles ].
.\"---------------------------------------------------------------------
.TP
.BI \-stylefile " filename"
Name a style file (see the
.B "STYLE FILES"
section below) to augment
.BR html-pretty 's
built-in knowledge of HTML tags.  This option may be given more than
once, if multiple initialization files are needed.
.\"---------------------------------------------------------------------
.TP
.B \-trace-opens
Trace all file-opening attempts, with a one-line message on
.I stderr
for each [default:
.BR \-no-trace-opens ].
.IP
This option can be helpful in analyzing file access failures, and in
uncovering the location of default style files and the catalog
directory.
.\"---------------------------------------------------------------------
.TP
.B \-unknown-tag-warning
Unknown HTML tags are always treated as ordinary text, but with this
option, you can request that a warning be raised for each of them
[default:
.BR \-no-unknown-tag-warning  ].
.IP
While this option is not a substitute for a validating HTML parser,
such as
.BR html-check (1)
or
.BR html-ncheck (1),
it does provide a simple way to catch use of non-standard tags.
See the
.B \-extend-style
option for a way to catch specific tags.
.\"---------------------------------------------------------------------
.TP
.B \-version
Show version information on
.I stderr
and quit after processing any remaining command-line
options that precede the next command-line HTML file.
.\"---------------------------------------------------------------------
.TP
.B \-warnings-in-comments
Write warning and error messages as easily-identifiable single-line
HTML comments on
.I stdout
[default:
.BR \-no-warnings-in-comments ].
This may facilitate correction of problems in the output file, since
the messages can be located by context, rather than by line number in
the input file.
.IP
Messages are always written to
.I stderr
as well (which might have been redirected with the
.B \-logfile
option, or suppressed with the
.B \-quiet
option).
.\"---------------------------------------------------------------------
.TP
.BI \-width " nnn"
Set the maximum output line width [default:
.IR 72 ].
This limit may be exceeded if an excessively long string without
embedded spaces is encountered, and it is ignored completely inside
preformatted or verbatim text.
.IP
If you set the line width to 0, it will be treated as `infinite'
(i.e., the largest representable integer).  If you set it to a very
small value, e.g., 1, then the output will have one word per line,
which might actually be useful on occasion!
.IP
This option can be abbreviated to
.BR \-w .
.\"=====================================================================
.SH "FORMATTING CONVENTIONS"
.B html-pretty
groups HTML tags into collections of
.IR "style classes" .
Tags within a single style class receive similar formatting.  The
built-in style-class tag-membership lists recognize a large collection
of tags from multiple grammar levels, and multiple browser vendor
extensions, but
.I all
of the built-in lists can be modified by the user, as
described in the
.B \-extend-style
and
.B \-stylefile
options above, and the
.B "STYLE FILES"
section below.
.PP
The subsections which follow catalog the origins of the recognized
tags, and then describe the available style classes in alphabetical
order, listing their default tag members, and briefly sketching how
the tags are formatted.
.PP
Tags that are not explicitly named in these subsections, or in style
files that are read at run time, are treated as normal text, and have
no effect on the indentation or line breaking, other than their
contribution toward the line length limit.
.PP
Tags in the style classes
.IR doctype ,
.IR line-break ,
.IR math ,
.IR plaintext ,
.IR short ,
.IR standalone ,
and
.IR standalone-nocheck
make up the set of HTML tags with SGML content
.IR EMPTY ,
which means that end tags for them are
.IR forbidden .
.B html-pretty
will issue warnings about such end tags, but will leave their deletion
to a human.
.\"---------------------------------------------------------------------
.SS "Recognized HTML Tags"
HTML 2.0 contains the following 49 tags:
.IR A ,
.IR ADDRESS ,
.IR B ,
.IR BASE ,
.IR BLOCKQUOTE ,
.IR BODY ,
.IR BR ,
.IR CITE ,
.IR CODE ,
.IR DD ,
.IR DIR ,
.IR DL ,
.IR DT ,
.IR EM ,
.IR FORM ,
.IR H1 ,
.IR H2 ,
.IR H3 ,
.IR H4 ,
.IR H5 ,
.IR H6 ,
.IR HEAD ,
.IR HR ,
.IR HTML ,
.IR I ,
.IR IMG ,
.IR INPUT ,
.IR ISINDEX ,
.IR KBD ,
.IR LI ,
.IR LINK ,
.IR LISTING ,
.IR MENU ,
.IR META ,
.IR NEXTID ,
.IR OL ,
.IR OPTION ,
.IR P ,
.IR PLAINTEXT ,
.IR PRE ,
.IR SAMP ,
.IR SELECT ,
.IR STRONG ,
.IR TEXTAREA ,
.IR TITLE ,
.IR TT ,
.IR UL ,
.IR VAR ,
and
.IR XMP .
.PP
HTML 3.0 augments the 2.0 grammar with 53 additional tags:
.IR ABBREV ,
.IR ABOVE ,
.IR ACRONYM ,
.IR ARRAY ,
.IR ATOP ,
.IR AU ,
.IR BAR ,
.IR BELOW ,
.IR BIG ,
.IR BOX ,
.IR BQ ,
.IR BT ,
.IR CAPTION ,
.IR CHOOSE ,
.IR CREDIT ,
.IR DDOT ,
.IR DEL ,
.IR DFN ,
.IR DIV ,
.IR DOT ,
.IR FIG ,
.IR HAT ,
.IR INS ,
.IR ITEM ,
.IR LANG ,
.IR LEFT ,
.IR LH ,
.IR MATH ,
.IR NOTE ,
.IR OF ,
.IR OVER ,
.IR OVERLAY ,
.IR PERSON ,
.IR PRE ,
.IR Q ,
.IR RIGHT ,
.IR ROOT ,
.IR ROW ,
.IR S ,
.IR SMALL ,
.IR SQRT ,
.IR STYLE ,
.IR SUB ,
.IR SUP ,
.IR T ,
.IR TAB ,
.IR TABLE ,
.IR TD ,
.IR TH ,
.IR TILDE ,
.IR TR ,
.IR U ,
and
.IR VEC .
.PP
These tags are identified by their occurrence in the
.I html.dtd
and
.I html-3.dtd
document type definition files in lines like these:
.PP
.RS
.nf
\&\fC<!ENTITY % font " TT | B | I ">
<!ENTITY % phrase "EM | STRONG | CODE | SAMP | KBD | VAR | CITE ">
<!ELEMENT (%font;|%phrase) - - (%text)+>
<!ELEMENT XMP - -  %literal>\fP
.fi
.RE
.PP
ENTITY declarations define text string substitutions, and ELEMENT
declarations define the tags recognized by the grammar.
.PP
HTML 3.2 introduced these 21 new tags:
.IR APPLET ,
.IR AREA ,
.IR BASEFONT ,
.IR BIG ,
.IR CAPTION ,
.IR CENTER ,
.IR DFN ,
.IR DIV ,
.IR FILE ,
.IR FONT ,
.IR MAP ,
.IR NUMBER ,
.IR PARAM ,
.IR SCRIPT ,
.IR SMALL ,
.IR STRIKE ,
.IR STYLE ,
.IR SUB ,
.IR SUP ,
.IR TABLE ,
and
.IR U .
.PP
Proposed HTML 4.0 introduces these 15 new tags:
.IR BDO ,
.IR BUTTON ,
.IR COL ,
.IR COLGROUP ,
.IR FIELDSET ,
.IR FRAMESET ,
.IR IFRAME ,
.IR LABEL ,
.IR NOFRAMES ,
.IR NOSCRIPT ,
.IR OBJECT ,
.IR SPAN ,
.IR TBODY ,
.IR TFOOT ,
and
.IR THEAD .
.\"---------------------------------------------------------------------
.SS "HTML Tag Omission"
The HTML grammar permits certain end tags to be omitted, when their
implied position can be determined from the grammatical context.  In
HTML 3.0, this includes the following tags:
.IR DD ,
.IR DT ,
.IR ITEM ,
.IR LH ,
.IR LI ,
.IR OF ,
.IR OPTION ,
.IR P ,
.IR ROW ,
.IR STYLE ,
and
.IR TR .
.PP
The HTML 3.2 grammar permits these end tags to be omitted:
.IR DD ,
.IR DT ,
.IR INPUT ,
.IR LI ,
.IR OPTION ,
and
.IR P .
.PP
The HTML proposed 4.0 grammars permit these end tags to be omitted:
.IR COLGROUP ,
.IR DD ,
.IR DT ,
.IR LI ,
.IR OPTION ,
.IR P ,
.IR PARAM ,
.IR TFOOT ,
.IR THEAD ,
and
.IR TR .
.PP
In all grammar versions, these tags
.I never
have end tags:
.IR AREA ,
.IR BASE ,
.IR BR ,
.IR FRAME ,
.IR HR ,
.IR IMG ,
.IR INPUT ,
.IR ISINDEX ,
.IR LINK ,
.IR META ,
.IR NEXTID ,
.IR PARAM ,
and
.IR PLAINTEXT .
.PP
In version 3.0,
.I BASEFONT
takes an optional end tag,
but in succeeding versions, it must
.I not
have an end tag.
.PP
In version 3.0,
.I STYLE
takes an optional end tag,
but in succeeding versions, it
.I must
have an end tag.
.PP
Supporting the tag-omission feature requires the ability to parse a
complete SGML grammar, which requires a great deal more code than
.B html-pretty
provides.  Consequently,
.B html-pretty
does not support optional end tags; based on typical usage, they are
expected to be always present, or always absent, according to the
rules given below.  Omitted end tags can be automatically supplied by
an SGML tag normalizer, such as
.BR sgmlnorm (1),
.BR spam (1),
or
.BR html-spam (1).
.PP
.B html-pretty
will warn about end tags that should not be present, based on the tags'
membership in those style classes that are known not to have end tags.
However, it will not delete them from the output stream, because human
judgment may be called for.  See the
.B "HTML GRAMMAR CONSTRAINTS"
section below for further details.
.\"---------------------------------------------------------------------
.SS "Style Class: body"
The following HTML tag name must occur only once, with a begin/end
pair, often with substantial amounts of intervening text:
.IR BODY .
The begin/end tags are prettyprinted on separate lines, with their
enclosed text indented one level.  However, the BODY environment must
occur after the HEAD environment, and one level inside the HTML
environment.
.B html-pretty
will supply this environment if needed, unless the
.B \-brief
option has suppressed it.
.\"---------------------------------------------------------------------
.SS "Style Class: comment"
Short HTML comments are output inline, like normal text.  Long ones,
and ones with embedded angle brackets, are prettyprinted on separate
lines.  Their internal form is preserved exactly, without any line
wrapping, since they will often contain specially-formatted material.
Any whitespace between the final "--" and the closing angle bracket
will be eliminated, when possible.
.\"---------------------------------------------------------------------
.SS "Style Class: doctype"
.PP
The following HTML tag name occurs only once, and should normally be
the first non-comment tag in a file:
.IR !DOCTYPE .
.B html-pretty
will supply this tag if needed, unless the
.B \-brief
option has suppressed it.  Strictly, this is not a tag, but rather a
markup declaration, but
.B html-pretty
treats it as a special tag, and outputs it verbatim while checking for
proper embedded comment balance.  For more details, see the
.B "COMMENTS IN HTML AND SGML"
section below.
.\"---------------------------------------------------------------------
.SS "Style Class: font"
These HTML tag names occur in begin/end pairs, usually with smaller
amounts of enclosed material.  They appear inline in the running text,
and do not alter indentation:
.IR ACRONYM ,
.IR B ,
.IR BIG ,
.IR BLINK ,
.IR BT ,
.IR CODE ,
.IR DFN ,
.IR EM ,
.IR I ,
.IR KBD ,
.IR Q ,
.IR REV ,
.IR S ,
.IR SAMP ,
.IR SMALL ,
.IR STRIKE ,
.IR STRONG ,
.IR T ,
.IR TT ,
.IR U ,
and
.IR VAR .
.\"---------------------------------------------------------------------
.SS "Style Class: head"
This HTML tag occurs in begin/end pairs, which are prettyprinted on
separate lines with enclosing text indented one level:
.IR HEAD .
However, this tag pair must occur only once in a file, and then only
inside an HTML environment, and before the BODY environment.
.B html-pretty
will supply this environment if needed, unless the
.B \-brief
option has suppressed it.
.\"---------------------------------------------------------------------
.SS "Style Class: html"
This HTML tag occurs in begin/end pairs, which are prettyprinted on
separate lines with enclosing text indented one level:
.IR HTML .
However, this tag pair must occur only once in a file, and then only
at the outermost level.
.B html-pretty
will supply this environment if needed, unless the
.B \-brief
option has suppressed it.
.\"---------------------------------------------------------------------
.SS "Style Class: inline"
Tags in this class are treated as ordinary text, with no additional
spacing requirements, or checks for enclosing environments.
.PP
Neither the default built-in style, nor any of the standard
grammar-level-specific style files, use this class.  It is provided to
permit transparent handling of tags that may be added in future
versions of the HTML grammars.
.PP
There is a difference in the handling of a member of this class,
compared to that for a tag which is not defined in any class.  The
latter may result in warnings if the
.B \-unknown-tag-warning
option has been selected, is allowed only in the BODY environment,
and may cause a paragraph to end.  A tag in the
.I inline
style class may occur in either the HEAD or BODY environments, never
raises unknown-tag warnings, and does not end a paragraph.
.\"---------------------------------------------------------------------
.SS "Style Class: line-break"
This HTML tag marks an explicit line break, and has no matching end
tag; preceding space is deleted, and a newline follows:
.IR BR .
.\"---------------------------------------------------------------------
.SS "Style Class: link"
This HTML tag has no matching end tag; it appears alone on
a separate line:
.IR LINK .
There is normally at least one LINK tag, in the HEAD environment, and
.B html-pretty
will supply one automatically if none is present in the input stream.
.\"---------------------------------------------------------------------
.SS "Style Class: list"
These HTML tags names occur in begin/end pairs, and delimit lists.
They appear on separate lines, with their enclosed text indented two
levels:
.IR DIR ,
.IR DL ,
.IR MENU ,
.IR OL ,
and
.IR UL .
.\"---------------------------------------------------------------------
.SS "Style Class: list-header"
This HTML tag marks the title of a list:
.IR LH .
The begin/end tags are output on separate lines, indented one level from
the enclosing list.
.\"---------------------------------------------------------------------
.SS "Style Class: list-item"
These HTML tags mark the beginning of list items, and have matching
end tags which are supplied if they are absent.  They are output on
separate lines, indented one level from the enclosing list:
.IR DD ,
.IR DT ,
and
.IR LI .
.\"---------------------------------------------------------------------
.SS "Style Class: markup-declaration"
The following SGML markup declarations are also treated like special
tags, and output verbatim while checking for proper embedded comment
balance:
.IR !ATTLIST ,
.IR !ELEMENT,
.IR !ENTITY,
.IR !NOTATION,
.IR !SGML,
.IR !SHORTREF,
and
.IR !USEMAP .
However,
.B html-pretty
does no further checking about where these `tags' are legal.
Generally, they do not occur in HTML files, but are found mainly in
DTD files.
.\"---------------------------------------------------------------------
.SS "Style Class: math"
These HTML tag names occur only inside a
.I MATH
environment, and appear inline, without end tags, and without
affecting indentation:
.IR ATOP ,
.IR CHOOSE ,
.IR LEFT ,
.IR OF ,
.IR OVER ,
.IR RIGHT ,
and
.IR TAB .
.\"---------------------------------------------------------------------
.SS "Style Class: math-pair"
These HTML tag names occur only inside a
.I MATH
environment, with begin/end pairs, and appear inline, without
affecting indentation:
.IR ABOVE ,
.IR BAR ,
.IR BELOW ,
.IR BOX ,
.IR DDOT ,
.IR DOT ,
.IR HAT ,
.IR ROOT ,
.IR ROW ,
.IR SQRT ,
.IR SUB ,
.IR SUP ,
.IR TILDE ,
and
.IR VEC .
.\"---------------------------------------------------------------------
.SS "Style Class: pair"
The following HTML tag names occur in begin/end pairs
.RI ( <TAG> and </TAG> ),
often with substantial amounts of intervening text:
.IR A ,
.IR ABBREV ,
.IR ABSTRACT ,
.IR ADDED ,
.IR ADDRESS ,
.IR APPLET ,
.IR ARG ,
.IR AROW ,
.IR ARRAY ,
.IR AU ,
.IR BDO ,
.IR BLOCKQUOTE ,
.IR BQ ,
.IR BUTTON ,
.IR CAPTION ,
.IR CENTER ,
.IR CITE ,
.IR CMD ,
.IR COLGROUP ,
.IR CREDIT ,
.IR DEL ,
.IR DIV ,
.IR DIV1 ,
.IR DIV2 ,
.IR DIV3 ,
.IR DIV4 ,
.IR DIV5 ,
.IR DIV6 ,
.IR FIELDSET ,
.IR FIG ,
.IR FN ,
.IR FONT ,
.IR FOOTNOTE ,
.IR FORM ,
.IR FRAMESET ,
.IR HIDE ,
.IR IFRAME ,
.IR INS ,
.IR LABEL ,
.IR LANG ,
.IR MAP ,
.IR MARGIN ,
.IR MATH ,
.IR MESSAGE ,
.IR NOFRAMES ,
.IR NOSCRIPT ,
.IR NOTE ,
.IR OBJECT ,
.IR OPTION ,
.IR PERSON ,
.IR QUOTE ,
.IR REMOVED ,
.IR SELECT ,
.IR SPAN ,
.IR STYLE ,
.IR TABLE ,
.IR TBODY ,
.IR TD ,
.IR TEXTAREA ,
.IR TFOOT ,
.IR TH ,
.IR THEAD ,
and
.IR TR .
They are prettyprinted on separate lines, with their enclosed text
indented one level.
.\"---------------------------------------------------------------------
.SS "Style Class: paragraph"
This HTML tag occurs in begin/end pairs, which are prettyprinted on
separate lines with enclosing text indented one level:
.IR P .
However, paragraphing is tracked, empty paragraphs are discarded, and
when new tags are encountered which are known to be illegal inside a
paragraph, any open paragraph is automatically closed.  Thus,
old-style HTML files with omitted </P> tags will usually get them
added.  Unlike most word processors and many typesetting systems,
blank lines in the SGML and HTML input stream do
.I not
imply a paragraph break; only the
.I <P>
tag does.
.\"---------------------------------------------------------------------
.SS "Style Class: plaintext"
The HTML tag
.I PLAINTEXT
marks the beginning of verbatim text that continues to end-of-file; it
appears on a separate line.  Although some HTML viewers will terminate
the plaintext environment on reaching a matching end tag,
\&\fI<\fP\fI/PLAINTEXT>\fP, that practice is now considered erroneous.
.PP
.B html-pretty
will warn about this abberant environment, and recommend using
.I "<PRE> .\|.\|. </PRE>"
instead.
.\"---------------------------------------------------------------------
.SS "Style Class: section"
These HTML tags occur in begin/end pairs, which are prettyprinted on
separate lines with enclosing text indented one level:
.IR H1 ,
.IR H2 ,
.IR H3 ,
.IR H4 ,
.IR H5 ,
and
.IR H6 .
However, they must be logically ordered: H1 before H2 .\|.\|. before H6,
with no intermediate header levels omitted, and they must appear
at the first level inside the BODY environment.
.\"---------------------------------------------------------------------
.SS "Style Class: short"
This HTML tag has no matching end tag; it appears alone on a separate
line:
.IR ITEM .
However, tags in this class can be used only inside a BODY
environment, and consequently,
.B html-pretty
will automatically end any open HEAD environment, and start a BODY
environment, if needed.
.\"---------------------------------------------------------------------
.SS "Style Class: standalone"
These HTML tags have no matching end tag; they appear alone on
separate lines:
.IR CHANGED ,
.IR HR ,
.IR IMG ,
.IR INPUT ,
.IR RENDER ,
.IR STYLES ,
and
.IR WBR .
However, they may appear only inside the BODY environment, and outside
a paragraph, and consequently,
.B html-pretty
will automatically end any open HEAD and P environments, and start a
BODY environment, if needed.
.\"---------------------------------------------------------------------
.SS "Style Class: standalone-nocheck"
These HTML tags have no matching end tag; they may appear in either
the HEAD or the BODY environment, and they appear alone on separate
lines:
.IR BASE ,
.IR ISINDEX ,
.IR META ,
and
.IR NEXTID .
.PP
As the class name implies, they are not checked against rules that
might restrict their placement with respect to other environments.
.\"---------------------------------------------------------------------
.SS "Style Class: title"
This HTML tag occurs in begin/end pairs, which are prettyprinted on
separate lines with enclosing text indented one level:
.IR TITLE .
However, this tag pair is restricted to occurring only in the HEAD
environment, and should normally only be given once.
.B html-pretty
will supply this environment if needed, unless the
.B \-brief
option has suppressed it, and will warn about multiple occurrences.
.\"---------------------------------------------------------------------
.SS "Style Class: verbatim"
These HTML tags appear in begin/end pairs, delimit preformatted, or
verbatim, text, and may occur only in the BODY environment:
.IR LISTING ,
.IR NOBR ,
.IR PRE ,
and
.IR XMP .
The beginning and ending tags are output on separate lines, with no
indentation, and with the enclosed material copied exactly as it
appeared in the input stream.
.\"---------------------------------------------------------------------
.SS "Style Class: verbatim-nocheck"
These HTML tags appear in begin/end pairs, delimit preformatted, or
verbatim, text, and may occur in either HEAD or BODY environments:
.I SCRIPT
and
.IR STYLE .
The beginning and ending tags are output on separate lines, with no
indentation, and with the enclosed material copied exactly as it
appeared in the input stream.
.PP
The
.I SCRIPT
and
.I STYLE
environments are not strictly verbatim environments, but since they
contain material in one of several different scripting (Java,
JavaScript, Tcl, VBScript, .\|.\|.) or style-sheet (CSS, .\|.\|.)
languages, there is no reasonable way for
.B html-pretty
to reformat their contents, so they are included in this style class
to prevent such reformatting.
.\"=====================================================================
.SH "STYLE FILES"
In order to allow the user to control the formatting of particular
HTML tags,
.B html-pretty
supports a powerful style file mechanism.  At startup, it processes a
style file in the directory where the executable program was found, a
second style file in the user's home directory, and a third style file
in the current directory.  None of these need exist.  Next, during
command-line argument processing, additional style files can be
provided with the
.B \-stylefile
option.  These style files support system-specific, user-specific,
directory-specific, and job- or file-specific prettyprinting control.
.PP
The default name of the first three style files is system dependent:
.I .html-prettyrc
(UNIX),
.I htmlpty.ini
(IBM PC DOS), and
.I html-pretty.ini
(DEC VMS and OpenVMS).  The exact names depend on the name of the
executable program, which is used to construct the style file names.
If you renamed it to
.IR sgmlpretty.exe ,
the names would be
.I .sgmlprettyrc
on UNIX, and
.I sgmlpretty.ini
on other systems.
.PP
More precisely, the program name passed to the prettyprinter as its
zeroth argument is filtered by discarding any trailing version number
and extension, then keeping the last consecutive string of characters
that are letters, digits, hyphens, or underscores.  If the zeroth
argument is empty, implying that the program name is unknown, then the
name
.I htmlpty
is used; it is short enough to be acceptable to any reasonable file
system.
.PP
Automatic association of the style file names with the program name
makes it easy to support multiple versions, e.g.,
.BR html-pretty-2-0 ,
.BR html-pretty-3-0 ,
.BR html-pretty-3-2 ,
and
.B html-pretty-4-0
could select different HTML grammar versions, and on UNIX,
and a few other operating systems, those programs could all
be links to the same physical file, avoiding wasteful
duplication of disk space.
.PP
In the current implementation of
.BR html-pretty ,
all of the standard HTML tags defined in HTML grammar levels up to the
proposed 4.0, plus a few browser vendor extensions, are hard-coded into
the program as members of over twenty formatting-style classes, so
that no external style files need exist for the program to run.
However, the
.BR \-extend-style ,
.BR \-grammar-level ,
and
.B \-stylefile
options allow the built-in rules to be completely replaced, if desired.
.PP
The
.B \-print-stylefile
command displays the built-in style rules as a set of style class
names, each followed by a colon and a list of HTML tags in that style
class.  Its output may be used without further modification as a style
file, and looks something like this:
.PP
.RS
.nf
\&\fC%% html-pretty version 1.00 date [29-Nov-1997]
%% User-modifiable style file generated on Wed Dec  3 08:34:39 1997

%% Uncomment the next line to clear all existing rules,
%% or leave it as a comment to preserve them:
% default :

body :                    BODY

doctype :                 !DOCTYPE

font :                    ACRONYM B BIG BLINK BT CODE \e
                          DFN EM I KBD Q REV S SAMP \e
                          SMALL STRIKE STRONG T TT U \e
                          VAR

head :                    HEAD

html :                    HTML

inline :

line-break :              BR

link :                    LINK

list :                    DIR DL MENU OL UL

list-header :             LH

list-item :               DD DT LI

markup-declaration :      !ATTLIST !ELEMENT !ENTITY \e
                          !NOTATION !SGML !SHORTREF \e
                          !USEMAP

math :                    ATOP CHOOSE LEFT OF OVER \e
                          RIGHT TAB

math-pair :               ABOVE BAR BELOW BOX DDOT \e
                          DOT HAT ROOT ROW SQRT SUB \e
                          SUP TILDE VEC

pair :                    A ABBREV ABSTRACT ADDED \e
                          ADDRESS APPLET ARG AROW \e
                          ARRAY AU BDO BLOCKQUOTE BQ \e
                          BUTTON CAPTION CENTER CITE \e
                          CMD COLGROUP CREDIT DEL DIV \e
                          DIV1 DIV2 DIV3 DIV4 DIV5 \e
                          DIV6 FIELDSET FIG FN FONT \e
                          FOOTNOTE FORM FRAMESET HIDE \e
                          IFRAME INS LABEL LANG MAP \e
                          MARGIN MATH MESSAGE \e
                          NOFRAMES NOSCRIPT NOTE \e
                          OBJECT OPTION PERSON QUOTE \e
                          REMOVED SELECT SPAN TABLE \e
                          TBODY TD TEXTAREA TFOOT TH \e
                          THEAD TR

paragraph :               P

plaintext :               PLAINTEXT

public :                  "-//IETF//DTD HTML//EN"

section :                 H1 H2 H3 H4 H5 H6

short :                   ITEM

standalone :              CHANGED HR IMG INPUT RENDER \e
                          STYLES WBR

standalone-nocheck :      AREA BASE BASEFONT COL \e
                          FRAME ISINDEX META NEXTID \e
                          OVERLAY PARAM

title :                   TITLE

verbatim :                LISTING NOBR PRE XMP

verbatim-nocheck :        SCRIPT STYLE\fP
.fi
.RE
.PP
There will be additional data at the end of this output, in the form
of the tag relationships discussed below, but we omit it here because
of its length.
.PP
Notice that long lines can be continued on multiple physical lines,
for improved readability, by terminating them with a backslash
immediately before the newline.  The output line width in this file is
governed by the
.B \-width
option.
.PP
As with the command-line
.B \-extend-style
option, you can replace the colon with an equal sign, and the spaces
between tags with commas, if you prefer.
.PP
In addition to the style classes listed above, the special style class
.I default
can be used to force an HTML tag to revert to the default rule for
unknown tags: just treat it as ordinary text, although if the
.B \-unknown-tag-warning
option was specified, a warning will be issued for this now unknown
tag.  You can use this to override earlier style file settings, and
most of the built-in ones.
.PP
The special style class
.I public
is associated with the SGML DOCTYPE identifier string, rather than
with a list of HTML tags.  That string determines which grammar file
is to be used for the document, and the value above corresponds to the
most generic grammar level (2.0) recognized by almost all browsers,
even though the style file includes tags from higher grammar levels.
The
.I public
style class is the only class whose value is a quoted string.
.PP
If the tag list to the right of the colon (or equals sign) is empty,
then all existing tags for that class are forgotten.  If an empty tag
list is used with the
.I default
style class, then all tags for all classes are forgotten.  These two
uses allow you to eliminate all built-in rules, or just certain style
classes, so that your style file can start from a known rule base.
.PP
Style class names are
.IR "case sensitive" ,
and all of the ones recognized by
.B html-pretty
must be spelled with lowercase letters.
.PP
The style file is expected to contain lines of the forms:
.RS
.PP
.nf
\&\fCstyle-class : TAG1 TAG2 .\|.\|.
\&
TAG : TAG1 TAG2 .\|.\|.
\&
relationship[TAG] : TAG1 TAG2 .\|.\|.
\&
-option
-option -option .\|.\|.
-option value
-option value -option value  .\|.\|.\fP
.fi
.RE
.PP
In the second form, the style class of the first tag is looked up
and assigned to the remaining tags.  That first tag
.I must
be entirely UPPERCASE in order to distinguish it from a style class.
The remaining tag names can be in either lettercase, or in mixed case;
they will be converted to uppercase internally.
.PP
The third form specifies a relationship between a tag, and one or more
other tags.  The two currently-recognized relationships are
\&\fCContainedIn\fP and \&\fCCannotContain\fP; any others that are
specified will simply be ignored, although they will take up memory
space.  For example, the lines
.RS
.PP
.nf
\&\fCCannotContain[TITLE]      : LINK META SCRIPT STYLE
ContainedIn[LH]           : DL OL UL\fP
.fi
.RE
.PP
mean that a
.I TITLE
environment cannot contain
.IR LINK ,
.IR META ,
.IR SCRIPT ,
or
.I STYLE
tags, and that an
.I LH
tag can only be contained in a
.IR DL ,
.IR OL ,
or
.I UL
environment.   Unlike style class definitions, relationships
are
.I not
cumulative; only the last one of each relationship type encountered
for a particular tag will be used.
.PP
Because of the complexity of SGML grammars, tag relationships cannot
be reliably determined manually.  Instead, relationship tables are
derived from the grammar files by software developed especially for,
and included with, the
.B html-pretty
distribution, and then inserted into the standard style files.  Thus,
it is not anticipated that users will provide tag relationship data in
their personal style files, although they are free to do so.
.PP
The built-in relationship tables are derived from a merger of the
major grammar levels, so that they match tags in the built-in style
classes, which are also derived from that merger.
.PP
Tag relationships are only checked when the
.B \-check-tag-nesting
option is specified, and since that is not a default option, omitting
tag relationships will normally not have a visible effect on the
output of
.BR html-pretty .
.PP
In the remaining forms, command-line options appear, and any of the
documented options may be used this way.  You can use this facility to
collect preferred option settings in one place, such as in directory-
or user-specific initialization files.  Observe that a
.B \-stylefile
option here can be used to chain temporarily to another file, and this
can go on recursively to a depth which is limited only by the run-time
stack depth and the maximum number of simultaneously open files.
.PP
Blank lines, leading and trailing whitespace, and text from a percent
(%) comment character to end of line, are ignored.  To get a literal
percent or quotation mark into a value, prefix it with a backslash;
the backslash will be removed when the value is collected.
.PP
Whitespace separates items, and can be omitted around the colon.
There is no significance to the order of items on a line, or lines in
the file, except that later settings can override earlier ones.  The
same style class name may occur on multiple lines, and the tag lists
will be accumulated, discarding duplicates.
.PP
The line length limit in style files is system-dependent, but
guaranteed to be at least 2048 characters.
.PP
Here is an example of a small style file to add the new tags
introduced in the HTML proposed 4.0 grammar (even though they are
actually already present in the built-in rules):
.PP
.RS
.nf
\&\fC% HTML proposed 4.0 additions
font : Acronym s

pair : BdO Button col colgroup Fieldset FrameSet IFrame \e
       laBel NoFrames NoScript Object span TBody TFoot thEAD

public : "-//W3C//DTD HTML 4.0 Transitional//EN"\fP
.fi
.RE
.PP
The last style class attached to command or environment name is
the one that is used, so specifications in command-line
.BR \-extend-style ,
.BR \-grammar-level ,
or
.B \-stylefile
options can override those in the current directory style file, those
in turn override settings from the home directory style file, and
those override system-wide style file settings.
.\"=====================================================================
.SH "CATALOG DIRECTORY"
The built-in style rules in
.BR html-pretty ,
together with the three default startup style files, and the
.BI \-extend-style " class: taglist"
and
.BI \-stylefile " stylefile"
options suffice for most uses of the prettyprinter.
.PP
However, it may be useful to offer a simpler interface that only
requires the user to specify the desired grammar level with the
.BI \-grammar-level " grammar"
option, and have
.B html-pretty
automatically find the style files.  Thus, when the
.B \-grammar-level
option is used,
.B html-pretty
looks for a catalog directory that contains a file named
.IR catalog ,
and one or more style files.
.PP
The catalog directory is searched for in the same path as the executable
file, but in a path starting one level higher.  On UNIX, it is usually
called
.IR share/lib/<programname> ,
so if the executable program was
.IR /usr/local/bin/html-pretty ,
the catalog directory is
.IR /usr/local/share/lib/html-pretty .
[Conventionally, on UNIX systems, directories in the
.I share
directory tree are shared across multiple O/S releases and vendor
architectures.]
.PP
On other operating systems, the
.IR share
portion of the path may be omitted.  However, the quickest way to find
out where the catalog directory resides on your system is to run
.B html-pretty
with the
.B \-grammar-level
and
.B \-trace-opens
options, to trace the file-opening attempts.
.PP
The
.I catalog
file has a simple format: each non-empty line contains a grammar
level, and a corresponding filename in that directory.  As with style
files, comments run from percent (%) to end-of-line, but there is no
support for line continuation, since the lines are all very short.  To
get a literal percent or quotation mark into a value, prefix it with a
backslash; the backslash will be removed when the value is collected.
.PP
This indirect mapping of grammar level to style file means that end
users need not know the style file names, and thus, that the names can
be changed to meet local requirements.
.PP
SGML parsers and other SGML software use a similar catalog file to map
DTD descriptor strings to local filenames.
.PP
Lettercase is
.I not
significant in grammar-level names, although it may be for filenames.
The standard style files are all named in a single lettercase, so that
the catalog entries work on all file systems.
.PP
If you are developing a new set of styles, you probably do not want
them put in the system-wide catalog directory until they have been
completed and debugged. In such a case, you can use the
.B \-catalogfile
option to specify an alternate catalog file location.  Once they are
ready for wider release, you (or your system manager) can merge your
.I catalog
file with the system one, and copy your style files into the system
catalog directory.
.\"=====================================================================
.SH "COMMENTS IN HTML AND SGML"
The SGML (and thus, HTML) comment syntax confuses many users,
including browser programmers, and book writers, who either get it
wrong, or fail to explain it properly.
.PP
SGML has a command called
.IR "markup declaration open" ,
or
.I mdo
for short, which defaults to the two-character sequence
.IR <! ,
and is matched by a
.IR "markup declaration close" ,
or
.IR mdc ,
which defaults to the one-character sequence
.IR > .
The
.I mdo
must be immediately followed either by a keyword, such as
.IR ATTLIST ,
.IR DOCTYPE ,
.IR ELEMENT ,
.IR ENTITY ,
.IR NOTATION ,
.IR SGML ,
.IR SHORTREF ,
or
.IR USEMAP ,
or else by a comment start, which is the two-character sequence
.IR \-\|\- .
In the latter case, there must later be a second
.I \-\|\-
pair to signal a comment end.  Anything after that second pair is
non-comment text to be parsed.  However, additional comments can appear,
provided that they are surrounded by
.I \-\|\-
pairs. Eventually, the markup declaration is ended by an
.I mdc
command, although whitespace may follow the last comment.
Thus,
.PP
.RS
.nf
\&\fC<!--one-- --two-- --three-->\fP
\&\fC<!-- one -- -- two -- -- three -- >\fP
\&\fC<!-- one --
  -- two --
  -- three --
>\fP
.fi
.RE
.PP
are all legal markup declarations, each of which consists of
three comments. However, these are in error:
.PP
.RS
.nf
\&\fC<! --one-- --two-- --three-- >\fP
\&\fC<!-- one -- two -- three -- >\fP
\&\fC<!--
         one --
      -- two --
      - - three - -
>\fP
.fi
.RE
.PP
The first has an illegal space after the
.IR mdo ,
the second has the word \fCtwo\fP outside a comment, and the
third has the text \fC- - three - -\fP outside the comment.
.PP
Given these rules, can SGML comments be nested?  It might appear that
they can, since
.PP
.RS
.nf
\&\fC<!-- <!-- --> -->\fP
\&\fC<!-- <!-- --> <!-- --> -->\fP
.fi
.RE
.PP
are both accepted by an SGML parser.  However, the nesting is
illusory, since the first has two comments, containing the
text \fC<!\fP and \fC>\fP, and the third has three comments:
\&\fC<!\fP and \fC> <!\fP and \fC>\fP.  As soon as we put words
between the hyphen pairs, such as
.PP
.RS
.nf
\&\fC<!-- one <!-- two --> three -->\fP
\&\fC<!-- one <!-- two --> <!-- three --> four -->\fP
.fi
.RE
.PP
the word \fCtwo\fP lies outside the comment in the first, and
\&\fCtwo\fP and \fCthree\fP are outside the comment in the second.
Therefore, SGML and HTML comments cannot in general be nested.
.PP
Finally, because of the special significance of
.I \-\|\-
as both a comment start and a comment end inside a markup declaration,
you must be careful about using adjacent hyphens in the comment text.
In particular, if you use a line of hyphens to set off one block of
text from another, the number of hyphens must be a multiple of 4, such
as this 60-hyphen example:
.PP
.RS
.nf
\&\fC<!------------------------------------------------------------>\fP
.fi
.RE
.PP
Having 57, 58, 59, 61, 62, or 63 hyphens won't do!
.PP
.B html-pretty
does not distinguish
.IR "markup declarations" ,
beginning with
.IR <! ,
from
.IR "tags" ,
beginning with
.IR < ,
except for comments, which have to be parsed separately anyway to
handle the pairs-of-pairs-of-hyphens balance requirement.  Thus, it
considers
.I !DOCTYPE
to be a tag name, when strictly speaking, the
.I !
is part of the
.IR "markup declaration open" .
However, since the closing character
.I >
can always be represented by an SGML entity,
.IR &lt; ,
.B html-pretty
can safely assume that anything between angle brackets is a `tag'.
That is why the style files have a rule
.PP
.RS
.nf
\&\fCdoctype :            !DOCTYPE\fP
.fi
.RE
.PP
with the exclamation mark prefixed to the word \fCDOCTYPE\fP.
.\"=====================================================================
.SH "HTML GRAMMAR CONSTRAINTS"
It is not immediately obvious from the HTML grammars just which tags
can be contained in, or by, other tag environments.  The list below
was automatically extracted from the HTML grammar files by software
developed especially for, and included with, the
.B html-pretty
distribution.
.PP
The grammar rules for some environments explicitly forbid certain tags
from appearing in those environments; this is indicated in the lists
below by the prefix
.IR "cannot contain:" .
.PP
Because the HTML definition is evolving, many tags are defined only in
certain grammar files. In such a case, the grammar level is indicated
by a suffix with a colon and a sorted list of one or more levels:
\s-32\s0, \s-33\s0, \s-33.2\s0, \s-34C\s0 (4-Cougar), \s-34L\s0
(4-loose), and \s-3M\s0 (Mosaic and Netscape).  [The level 4-strict
from July and November, 1997, is excluded because the grammar file
omits many heavily-used tags, in anticipation that their features will
be provided by style sheets.]
.PP
Although there are other HTML grammar versions, these are the major
ones that are important for current browsers.  If no grammar level
list is present, then the tag is available in
.I all
of the levels listed at the start of this paragraph.
.PP
The `tag'
.B #PCDATA
means
.IR "parsed character data" ,
an SGML term for text of zero or more ordinary characters and/or SGML
named and numeric entities, such as
.I &quot;
and
.IR &#34; .
.PP
The `tag'
.B ANY
is a catch-all that means
.BR #PCDATA ,
or any SGML tag defined in the grammar.  It should not be used in SGML
grammars, but it is present in the Mosaic/Netscape grammar file,
.IR html-mcom.dtd .
.PP
The `tag'
.B CDATA
means
.IR "character data" ,
an SGML term for zero or more characters that are not further
examined, except for the purposes of scanning for an end tag.  This
corresponds to verbatim text in typesetting and word-processing
systems.
.PP
The special `tag'
.B EMPTY
means that the environment is empty, and further, that a matching end
tag is
.IR forbidden .
.PP
If no end tag is shown in the paragraph heading, then it
.I must
be omitted in HTML files.
.PP
Unless suffixed by \s-3optional\s0, all tags listed in the remainder
of this section are required.  However, if a grammar level list is
attached to \s-3optional\s0 or \s-3required\s0, then the tag is
defined only in those grammar levels.
.PP
Use these lists as a
.IR "portability guide" :
if a tag is implemented in only specified grammar levels, then
documents which use it are more likely to be displayed improperly by
Web browsers.
.PP
.na
.nh
.\"*********************************************************************
.\" WARNING: This section, up to the next asterisked comment line, is
.\" produced automatically by mrgtable.awk into the file
.\" Entities/merged-table.tab according to rules given in the Makefile.
.\" NO hand modifications are required, or desirable!
.\"---------------------------------------------------------------------
.B #PCDATA
.\"
.RS
.I "contained in:"
A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ABOVE:\s-33\s0\& ACRONYM:\s-33\s0\&
ADDRESS APPLET:\s-33.2,4L\s0\& AU:\s-33\s0\& B BAR:\s-33\s0\&
BDO:\s-34C,4L\s0\& BELOW:\s-33\s0\& BIG:\s-33,3.2,4C,4L\s0\&
BLINK:\s-3M\s0\& BLOCKQUOTE BODY BOX:\s-33\s0\& BQ:\s-33\s0\&
BT:\s-33\s0\& BUTTON:\s-34L\s0\& CAPTION:\s-33,3.2,4C,4L\s0\&
CENTER:\s-33.2,4C,4L,M\s0\& CITE CODE CREDIT:\s-33\s0\& DD
DDOT:\s-33\s0\& DEL:\s-33,4L\s0\& DFN:\s-33,3.2,4C,4L\s0\&
DIV:\s-33,3.2,4C,4L\s0\& DOT:\s-33\s0\& DT EM FIELDSET:\s-34C,4L\s0\&
FIG:\s-33\s0\& FONT:\s-33.2,4C,4L,M\s0\& FORM H1 H2 H3 H4 H5 H6
HAT:\s-33\s0\& I IFRAME:\s-34L\s0\& INS:\s-33,4L\s0\& ITEM:\s-33\s0\&
KBD LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& LEGEND:\s-34L\s0\&
LH:\s-33\s0\& LI MATH:\s-33\s0\& NOBR:\s-3M\s0\& NOSCRIPT:\s-34L\s0\&
NOTE:\s-33\s0\& OBJECT:\s-34C,4L\s0\& OF:\s-33\s0\& OPTION P
PERSON:\s-33\s0\& PRE Q:\s-33,4C,4L\s0\& ROOT:\s-33\s0\&
S:\s-33,4C,4L\s0\& SAMP SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
SQRT:\s-33\s0\& STRIKE:\s-33.2,4L\s0\& STRONG STYLE:\s-33\s0\&
SUB:\s-33,3.2,4C,4L\s0\& SUP:\s-33,3.2,4C,4L\s0\& T:\s-33\s0\&
TD:\s-33,3.2,4C,4L\s0\& TEXTAREA TEXTFLOW:\s-34C\s0\&
TH:\s-33,3.2,4C,4L\s0\& TILDE:\s-33\s0\& TITLE TT U:\s-33,3.2,4C,4L\s0\&
VAR VEC:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<A>" "\&" " .\|.\|. </A>" "\&"
.\"
.RS
.I "contained in:"
ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& ADDRESS
APPLET:\s-33.2,4L\s0\& AU:\s-33\s0\& B BDO:\s-34C,4L\s0\&
BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BLOCKQUOTE BODY BQ:\s-33\s0\&
CAPTION:\s-33,3.2,4C,4L\s0\& CENTER:\s-33.2,4C,4L,M\s0\& CITE CODE
CREDIT:\s-33\s0\& DD DEL:\s-33,4L\s0\& DFN:\s-33,3.2,4C,4L\s0\&
DIV:\s-33,3.2,4C,4L\s0\& DT EM FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\&
FONT:\s-33.2,4C,4L,M\s0\& FORM H1 H2 H3 H4 H5 H6 I IFRAME:\s-34L\s0\&
INS:\s-33,4L\s0\& KBD LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\&
LEGEND:\s-34L\s0\& LH:\s-33\s0\& LI NOBR:\s-3M\s0\& NOSCRIPT:\s-34L\s0\&
NOTE:\s-33\s0\& OBJECT:\s-34C,4L\s0\& P PERSON:\s-33\s0\& PRE
Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\& SAMP SMALL:\s-33,3.2,4C,4L\s0\&
SPAN:\s-34C,4L\s0\& STRIKE:\s-33.2,4L\s0\& STRONG
SUB:\s-33,3.2,4C,4L\s0\& SUP:\s-33,3.2,4C,4L\s0\&
TD:\s-33,3.2,4C,4L\s0\& TEXTFLOW:\s-34C\s0\& TH:\s-33,3.2,4C,4L\s0\& TT
U:\s-33,3.2,4C,4L\s0\& VAR
.RE
.\"
.RS
.I "contains:"
#PCDATA ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
APPLET:\s-33.2,4C,4L\s0\& AU:\s-33\s0\& B BASEFONT:\s-33.2,4C,4L,M\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BR
BUTTON:\s-34L\s0\& CENTER:\s-3M\s0\& CITE CODE DEL:\s-33\s0\&
DFN:\s-33,3.2,4C,4L\s0\& EM FONT:\s-33.2,4C,4L,M\s0\& H1:\s-32,3,M\s0\&
H2:\s-32,3,M\s0\& H3:\s-32,3,M\s0\& H4:\s-32,3,M\s0\& H5:\s-32,3,M\s0\&
H6:\s-32,3,M\s0\& I IFRAME:\s-34L\s0\& IMG INPUT:\s-33.2,4C,4L\s0\&
INS:\s-33\s0\& KBD LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\&
MAP:\s-33.2,4C,4L\s0\& MATH:\s-33\s0\& NOBR:\s-3M\s0\&
OBJECT:\s-34C,4L\s0\& PERSON:\s-33\s0\& Q:\s-33,4C,4L\s0\&
S:\s-33,4C,4L\s0\& SAMP SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG STYLE:\s-34C\s0\& SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\& TEXTAREA:\s-33.2,4C,4L\s0\& TT
U:\s-33,3.2,4C,4L\s0\& VAR WBR:\s-3M\s0\&
.RE
.\"
.RS
.I "cannot contain:"
A
.RE
.\"---------------------------------------------------------------------
.BR "<ABBR>" " \s-3required:4L\s0\&" " .\|.\|. </ABBR>" " \s-3required:4L\s0\&"
.\"
.RS
.I "contained in:"
A:\s-34L\s0\& ABBR:\s-34L\s0\& ADDRESS:\s-34L\s0\& APPLET:\s-34L\s0\&
B:\s-34L\s0\& BDO:\s-34L\s0\& BIG:\s-34L\s0\& BLOCKQUOTE:\s-34L\s0\&
BODY:\s-34L\s0\& BUTTON:\s-34L\s0\& CAPTION:\s-34L\s0\&
CENTER:\s-34L\s0\& CITE:\s-34L\s0\& CODE:\s-34L\s0\& DD:\s-34L\s0\&
DEL:\s-34L\s0\& DFN:\s-34L\s0\& DIV:\s-34L\s0\& DT:\s-34L\s0\&
EM:\s-34L\s0\& FIELDSET:\s-34L\s0\& FONT:\s-34L\s0\& FORM:\s-34L\s0\&
H1:\s-34L\s0\& H2:\s-34L\s0\& H3:\s-34L\s0\& H4:\s-34L\s0\&
H5:\s-34L\s0\& H6:\s-34L\s0\& I:\s-34L\s0\& IFRAME:\s-34L\s0\&
INS:\s-34L\s0\& KBD:\s-34L\s0\& LABEL:\s-34L\s0\& LEGEND:\s-34L\s0\&
LI:\s-34L\s0\& NOSCRIPT:\s-34L\s0\& OBJECT:\s-34L\s0\& P:\s-34L\s0\&
PRE:\s-34L\s0\& Q:\s-34L\s0\& S:\s-34L\s0\& SAMP:\s-34L\s0\&
SMALL:\s-34L\s0\& SPAN:\s-34L\s0\& STRIKE:\s-34L\s0\& STRONG:\s-34L\s0\&
SUB:\s-34L\s0\& SUP:\s-34L\s0\& TD:\s-34L\s0\& TH:\s-34L\s0\&
TT:\s-34L\s0\& U:\s-34L\s0\& VAR:\s-34L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-34L\s0\& A:\s-34L\s0\& ABBR:\s-34L\s0\& APPLET:\s-34L\s0\&
B:\s-34L\s0\& BASEFONT:\s-34L\s0\& BDO:\s-34L\s0\& BIG:\s-34L\s0\&
BR:\s-34L\s0\& BUTTON:\s-34L\s0\& CITE:\s-34L\s0\& CODE:\s-34L\s0\&
DFN:\s-34L\s0\& EM:\s-34L\s0\& FONT:\s-34L\s0\& I:\s-34L\s0\&
IFRAME:\s-34L\s0\& IMG:\s-34L\s0\& INPUT:\s-34L\s0\& KBD:\s-34L\s0\&
LABEL:\s-34L\s0\& MAP:\s-34L\s0\& OBJECT:\s-34L\s0\& Q:\s-34L\s0\&
S:\s-34L\s0\& SAMP:\s-34L\s0\& SCRIPT:\s-34L\s0\& SELECT:\s-34L\s0\&
SMALL:\s-34L\s0\& SPAN:\s-34L\s0\& STRIKE:\s-34L\s0\& STRONG:\s-34L\s0\&
SUB:\s-34L\s0\& SUP:\s-34L\s0\& TEXTAREA:\s-34L\s0\& TT:\s-34L\s0\&
U:\s-34L\s0\& VAR:\s-34L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<ABBREV>" " \s-3required:3\s0\&" " .\|.\|. </ABBREV>" " \s-3required:3\s0\&"
.\"
.RS
.I "contained in:"
A:\s-33\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& ADDRESS:\s-33\s0\&
AU:\s-33\s0\& B:\s-33\s0\& BIG:\s-33\s0\& BLOCKQUOTE:\s-33\s0\&
BODY:\s-33\s0\& BQ:\s-33\s0\& CAPTION:\s-33\s0\& CITE:\s-33\s0\&
CODE:\s-33\s0\& CREDIT:\s-33\s0\& DD:\s-33\s0\& DEL:\s-33\s0\&
DFN:\s-33\s0\& DIV:\s-33\s0\& DT:\s-33\s0\& EM:\s-33\s0\& FIG:\s-33\s0\&
FORM:\s-33\s0\& H1:\s-33\s0\& H2:\s-33\s0\& H3:\s-33\s0\& H4:\s-33\s0\&
H5:\s-33\s0\& H6:\s-33\s0\& I:\s-33\s0\& INS:\s-33\s0\& KBD:\s-33\s0\&
LANG:\s-33\s0\& LH:\s-33\s0\& LI:\s-33\s0\& NOTE:\s-33\s0\& P:\s-33\s0\&
PERSON:\s-33\s0\& PRE:\s-33\s0\& Q:\s-33\s0\& S:\s-33\s0\&
SAMP:\s-33\s0\& SMALL:\s-33\s0\& STRONG:\s-33\s0\& SUB:\s-33\s0\&
SUP:\s-33\s0\& TD:\s-33\s0\& TH:\s-33\s0\& TT:\s-33\s0\& U:\s-33\s0\&
VAR:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33\s0\& A:\s-33\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
AU:\s-33\s0\& B:\s-33\s0\& BIG:\s-33\s0\& BR:\s-33\s0\& CITE:\s-33\s0\&
CODE:\s-33\s0\& DEL:\s-33\s0\& DFN:\s-33\s0\& EM:\s-33\s0\& I:\s-33\s0\&
IMG:\s-33\s0\& INS:\s-33\s0\& KBD:\s-33\s0\& LANG:\s-33\s0\&
MATH:\s-33\s0\& PERSON:\s-33\s0\& Q:\s-33\s0\& S:\s-33\s0\&
SAMP:\s-33\s0\& SMALL:\s-33\s0\& STRONG:\s-33\s0\& SUB:\s-33\s0\&
SUP:\s-33\s0\& TAB:\s-33\s0\& TT:\s-33\s0\& U:\s-33\s0\& VAR:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<ABOVE>" " \s-3required:3\s0\&" " .\|.\|. </ABOVE>" " \s-3required:3\s0\&"
.\"
.RS
.I "contained in:"
ABOVE:\s-33\s0\& BAR:\s-33\s0\& BELOW:\s-33\s0\& BOX:\s-33\s0\&
BT:\s-33\s0\& DDOT:\s-33\s0\& DOT:\s-33\s0\& HAT:\s-33\s0\&
ITEM:\s-33\s0\& MATH:\s-33\s0\& OF:\s-33\s0\& ROOT:\s-33\s0\&
SQRT:\s-33\s0\& T:\s-33\s0\& TILDE:\s-33\s0\& VEC:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33\s0\& ABOVE:\s-33\s0\& ARRAY:\s-33\s0\& B:\s-33\s0\&
BAR:\s-33\s0\& BELOW:\s-33\s0\& BOX:\s-33\s0\& BT:\s-33\s0\&
DDOT:\s-33\s0\& DOT:\s-33\s0\& HAT:\s-33\s0\& ROOT:\s-33\s0\&
SQRT:\s-33\s0\& SUB:\s-33\s0\& SUP:\s-33\s0\& T:\s-33\s0\&
TILDE:\s-33\s0\& VEC:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<ACRONYM>" " \s-3required:3\s0\&" " .\|.\|. </ACRONYM>" " \s-3required:3\s0\&"
.\"
.RS
.I "contained in:"
A:\s-33\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& ADDRESS:\s-33\s0\&
AU:\s-33\s0\& B:\s-33\s0\& BIG:\s-33\s0\& BLOCKQUOTE:\s-33\s0\&
BODY:\s-33\s0\& BQ:\s-33\s0\& CAPTION:\s-33\s0\& CITE:\s-33\s0\&
CODE:\s-33\s0\& CREDIT:\s-33\s0\& DD:\s-33\s0\& DEL:\s-33\s0\&
DFN:\s-33\s0\& DIV:\s-33\s0\& DT:\s-33\s0\& EM:\s-33\s0\& FIG:\s-33\s0\&
FORM:\s-33\s0\& H1:\s-33\s0\& H2:\s-33\s0\& H3:\s-33\s0\& H4:\s-33\s0\&
H5:\s-33\s0\& H6:\s-33\s0\& I:\s-33\s0\& INS:\s-33\s0\& KBD:\s-33\s0\&
LANG:\s-33\s0\& LH:\s-33\s0\& LI:\s-33\s0\& NOTE:\s-33\s0\& P:\s-33\s0\&
PERSON:\s-33\s0\& PRE:\s-33\s0\& Q:\s-33\s0\& S:\s-33\s0\&
SAMP:\s-33\s0\& SMALL:\s-33\s0\& STRONG:\s-33\s0\& SUB:\s-33\s0\&
SUP:\s-33\s0\& TD:\s-33\s0\& TH:\s-33\s0\& TT:\s-33\s0\& U:\s-33\s0\&
VAR:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33\s0\& A:\s-33\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
AU:\s-33\s0\& B:\s-33\s0\& BIG:\s-33\s0\& BR:\s-33\s0\& CITE:\s-33\s0\&
CODE:\s-33\s0\& DEL:\s-33\s0\& DFN:\s-33\s0\& EM:\s-33\s0\& I:\s-33\s0\&
IMG:\s-33\s0\& INS:\s-33\s0\& KBD:\s-33\s0\& LANG:\s-33\s0\&
MATH:\s-33\s0\& PERSON:\s-33\s0\& Q:\s-33\s0\& S:\s-33\s0\&
SAMP:\s-33\s0\& SMALL:\s-33\s0\& STRONG:\s-33\s0\& SUB:\s-33\s0\&
SUP:\s-33\s0\& TAB:\s-33\s0\& TT:\s-33\s0\& U:\s-33\s0\& VAR:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<ADDRESS>" "\&" " .\|.\|. </ADDRESS>" "\&"
.\"
.RS
.I "contained in:"
APPLET:\s-34L\s0\& BLOCKQUOTE BODY BQ:\s-33\s0\& BUTTON:\s-34L\s0\&
CENTER:\s-33.2,4C,4L,M\s0\& DD:\s-34L\s0\& DEL:\s-34L\s0\&
DIV:\s-33,3.2,4C,4L\s0\& FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\& FORM
IFRAME:\s-34L\s0\& INS:\s-34L\s0\& LI:\s-34L\s0\& NOSCRIPT:\s-34L\s0\&
NOTE:\s-33\s0\& OBJECT:\s-34C,4L\s0\& TD:\s-33,3.2,4C,4L\s0\&
TH:\s-33,3.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
APPLET:\s-33.2,4C,4L\s0\& AU:\s-33\s0\& B BASEFONT:\s-33.2,4C,4L,M\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BR
BUTTON:\s-34L\s0\& CENTER:\s-3M\s0\& CITE CODE DEL:\s-33\s0\&
DFN:\s-33,3.2,4C,4L\s0\& EM FONT:\s-33.2,4C,4L,M\s0\& I
IFRAME:\s-34L\s0\& IMG INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\& KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& MAP:\s-33.2,4C,4L\s0\&
MATH:\s-33\s0\& NOBR:\s-3M\s0\& OBJECT:\s-34C,4L\s0\& P
PERSON:\s-33\s0\& Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\& SAMP
SCRIPT:\s-33.2,4C,4L\s0\& SELECT:\s-33.2,4C,4L\s0\&
SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\& STRIKE:\s-33.2,4L\s0\&
STRONG STYLE:\s-34C\s0\& SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\& TEXTAREA:\s-33.2,4C,4L\s0\& TT
U:\s-33,3.2,4C,4L\s0\& VAR WBR:\s-3M\s0\&
.RE
.\"---------------------------------------------------------------------
.B ANY
.\"
.RS
.I "contained in:"
BASEFONT:\s-3M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<APPLET>" " \s-3required:3.2,4C,4L\s0\&" " .\|.\|. </APPLET>" " \s-3required:3.2,4C,4L\s0\&"
.\"
.RS
.I "contained in:"
A:\s-33.2,4C,4L\s0\& ABBR:\s-34L\s0\& ADDRESS:\s-33.2,4C,4L\s0\&
APPLET:\s-33.2,4L\s0\& B:\s-33.2,4C,4L\s0\& BDO:\s-34C,4L\s0\&
BIG:\s-33.2,4C,4L\s0\& BLOCKQUOTE:\s-33.2,4C,4L\s0\&
BODY:\s-33.2,4C,4L\s0\& BUTTON:\s-34L\s0\& CAPTION:\s-33.2,4C,4L\s0\&
CENTER:\s-33.2,4C,4L\s0\& CITE:\s-33.2,4C,4L\s0\&
CODE:\s-33.2,4C,4L\s0\& DD:\s-33.2,4C,4L\s0\& DEL:\s-34L\s0\&
DFN:\s-33.2,4C,4L\s0\& DIV:\s-33.2,4C,4L\s0\& DT:\s-33.2,4C,4L\s0\&
EM:\s-33.2,4C,4L\s0\& FIELDSET:\s-34C,4L\s0\& FONT:\s-33.2,4C,4L\s0\&
FORM:\s-33.2,4C,4L\s0\& H1:\s-33.2,4C,4L\s0\& H2:\s-33.2,4C,4L\s0\&
H3:\s-33.2,4C,4L\s0\& H4:\s-33.2,4C,4L\s0\& H5:\s-33.2,4C,4L\s0\&
H6:\s-33.2,4C,4L\s0\& I:\s-33.2,4C,4L\s0\& IFRAME:\s-34L\s0\&
INS:\s-34L\s0\& KBD:\s-33.2,4C,4L\s0\& LABEL:\s-34C,4L\s0\&
LEGEND:\s-34L\s0\& LI:\s-33.2,4C,4L\s0\& NOSCRIPT:\s-34L\s0\&
OBJECT:\s-34C,4L\s0\& P:\s-33.2,4C,4L\s0\& PRE:\s-33.2,4C\s0\&
Q:\s-34C,4L\s0\& S:\s-34C,4L\s0\& SAMP:\s-33.2,4C,4L\s0\&
SMALL:\s-33.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\& STRIKE:\s-33.2,4L\s0\&
STRONG:\s-33.2,4C,4L\s0\& SUB:\s-33.2,4C,4L\s0\& SUP:\s-33.2,4C,4L\s0\&
TD:\s-33.2,4C,4L\s0\& TEXTFLOW:\s-34C\s0\& TH:\s-33.2,4C,4L\s0\&
TT:\s-33.2,4C,4L\s0\& U:\s-33.2,4C,4L\s0\& VAR:\s-33.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33.2,4L\s0\& A:\s-33.2,4L\s0\& ABBR:\s-34L\s0\&
ADDRESS:\s-34L\s0\& APPLET:\s-33.2,4L\s0\& B:\s-33.2,4L\s0\&
BASEFONT:\s-33.2,4L\s0\& BDO:\s-34L\s0\& BIG:\s-33.2,4L\s0\&
BLOCKQUOTE:\s-34L\s0\& BR:\s-33.2,4L\s0\& BUTTON:\s-34L\s0\&
CENTER:\s-34L\s0\& CITE:\s-33.2,4L\s0\& CODE:\s-33.2,4L\s0\&
DFN:\s-33.2,4L\s0\& DIR:\s-34L\s0\& DIV:\s-34L\s0\& DL:\s-34L\s0\&
EM:\s-33.2,4L\s0\& FIELDSET:\s-34L\s0\& FONT:\s-33.2,4L\s0\&
FORM:\s-34L\s0\& H1:\s-34L\s0\& H2:\s-34L\s0\& H3:\s-34L\s0\&
H4:\s-34L\s0\& H5:\s-34L\s0\& H6:\s-34L\s0\& HR:\s-34L\s0\&
I:\s-33.2,4L\s0\& IFRAME:\s-34L\s0\& IMG:\s-33.2,4L\s0\&
INPUT:\s-33.2,4L\s0\& ISINDEX:\s-34L\s0\& KBD:\s-33.2,4L\s0\&
LABEL:\s-34L\s0\& MAP:\s-33.2,4L\s0\& MENU:\s-34L\s0\&
NOFRAMES:\s-34L\s0\& NOSCRIPT:\s-34L\s0\& OBJECT:\s-34L\s0\&
OL:\s-34L\s0\& P:\s-34L\s0\& PARAM:\s-33.2,4C,4L\s0\& PRE:\s-34L\s0\&
Q:\s-34L\s0\& S:\s-34L\s0\& SAMP:\s-33.2,4L\s0\& SCRIPT:\s-33.2,4L\s0\&
SELECT:\s-33.2,4L\s0\& SMALL:\s-33.2,4L\s0\& SPAN:\s-34L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG:\s-33.2,4L\s0\& SUB:\s-33.2,4L\s0\&
SUP:\s-33.2,4L\s0\& TABLE:\s-34L\s0\& TEXTAREA:\s-33.2,4L\s0\&
TEXTFLOW:\s-34C\s0\& TT:\s-33.2,4L\s0\& U:\s-33.2,4L\s0\& UL:\s-34L\s0\&
VAR:\s-33.2,4L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<AREA>" " \s-3required:3.2,4C,4L\s0\&"
.\"
.RS
.I "contained in:"
MAP:\s-33.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
EMPTY:\s-33.2,4C,4L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<ARRAY>" " \s-3required:3\s0\&" " .\|.\|. </ARRAY>" " \s-3required:3\s0\&"
.\"
.RS
.I "contained in:"
ABOVE:\s-33\s0\& BAR:\s-33\s0\& BELOW:\s-33\s0\& BOX:\s-33\s0\&
BT:\s-33\s0\& DDOT:\s-33\s0\& DOT:\s-33\s0\& HAT:\s-33\s0\&
ITEM:\s-33\s0\& MATH:\s-33\s0\& OF:\s-33\s0\& ROOT:\s-33\s0\&
SQRT:\s-33\s0\& T:\s-33\s0\& TILDE:\s-33\s0\& VEC:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
ROW:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<ATOP>" " \s-3required:3\s0\&"
.\"
.RS
.I "contained in:"
BOX:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
EMPTY:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<AU>" " \s-3required:3\s0\&" " .\|.\|. </AU>" " \s-3required:3\s0\&"
.\"
.RS
.I "contained in:"
A:\s-33\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& ADDRESS:\s-33\s0\&
AU:\s-33\s0\& B:\s-33\s0\& BIG:\s-33\s0\& BLOCKQUOTE:\s-33\s0\&
BODY:\s-33\s0\& BQ:\s-33\s0\& CAPTION:\s-33\s0\& CITE:\s-33\s0\&
CODE:\s-33\s0\& CREDIT:\s-33\s0\& DD:\s-33\s0\& DEL:\s-33\s0\&
DFN:\s-33\s0\& DIV:\s-33\s0\& DT:\s-33\s0\& EM:\s-33\s0\& FIG:\s-33\s0\&
FORM:\s-33\s0\& H1:\s-33\s0\& H2:\s-33\s0\& H3:\s-33\s0\& H4:\s-33\s0\&
H5:\s-33\s0\& H6:\s-33\s0\& I:\s-33\s0\& INS:\s-33\s0\& KBD:\s-33\s0\&
LANG:\s-33\s0\& LH:\s-33\s0\& LI:\s-33\s0\& NOTE:\s-33\s0\& P:\s-33\s0\&
PERSON:\s-33\s0\& PRE:\s-33\s0\& Q:\s-33\s0\& S:\s-33\s0\&
SAMP:\s-33\s0\& SMALL:\s-33\s0\& STRONG:\s-33\s0\& SUB:\s-33\s0\&
SUP:\s-33\s0\& TD:\s-33\s0\& TH:\s-33\s0\& TT:\s-33\s0\& U:\s-33\s0\&
VAR:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33\s0\& A:\s-33\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
AU:\s-33\s0\& B:\s-33\s0\& BIG:\s-33\s0\& BR:\s-33\s0\& CITE:\s-33\s0\&
CODE:\s-33\s0\& DEL:\s-33\s0\& DFN:\s-33\s0\& EM:\s-33\s0\& I:\s-33\s0\&
IMG:\s-33\s0\& INS:\s-33\s0\& KBD:\s-33\s0\& LANG:\s-33\s0\&
MATH:\s-33\s0\& PERSON:\s-33\s0\& Q:\s-33\s0\& S:\s-33\s0\&
SAMP:\s-33\s0\& SMALL:\s-33\s0\& STRONG:\s-33\s0\& SUB:\s-33\s0\&
SUP:\s-33\s0\& TAB:\s-33\s0\& TT:\s-33\s0\& U:\s-33\s0\& VAR:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<B>" "\&" " .\|.\|. </B>" "\&"
.\"
.RS
.I "contained in:"
A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ABOVE:\s-33\s0\& ACRONYM:\s-33\s0\&
ADDRESS APPLET:\s-33.2,4L\s0\& AU:\s-33\s0\& B BAR:\s-33\s0\&
BDO:\s-34C,4L\s0\& BELOW:\s-33\s0\& BIG:\s-33,3.2,4C,4L\s0\&
BLINK:\s-3M\s0\& BLOCKQUOTE BODY BOX:\s-33\s0\& BQ:\s-33\s0\&
BT:\s-33\s0\& BUTTON:\s-34L\s0\& CAPTION:\s-33,3.2,4C,4L\s0\&
CENTER:\s-33.2,4C,4L,M\s0\& CITE CODE CREDIT:\s-33\s0\& DD
DDOT:\s-33\s0\& DEL:\s-33,4L\s0\& DFN:\s-33,3.2,4C,4L\s0\&
DIV:\s-33,3.2,4C,4L\s0\& DOT:\s-33\s0\& DT EM FIELDSET:\s-34C,4L\s0\&
FIG:\s-33\s0\& FONT:\s-33.2,4C,4L,M\s0\& FORM H1 H2 H3 H4 H5 H6
HAT:\s-33\s0\& I IFRAME:\s-34L\s0\& INS:\s-33,4L\s0\& ITEM:\s-33\s0\&
KBD LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& LEGEND:\s-34L\s0\&
LH:\s-33\s0\& LI MATH:\s-33\s0\& NOBR:\s-3M\s0\& NOSCRIPT:\s-34L\s0\&
NOTE:\s-33\s0\& OBJECT:\s-34C,4L\s0\& OF:\s-33\s0\& P PERSON:\s-33\s0\&
PRE Q:\s-33,4C,4L\s0\& ROOT:\s-33\s0\& S:\s-33,4C,4L\s0\& SAMP
SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\& SQRT:\s-33\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& T:\s-33\s0\& TD:\s-33,3.2,4C,4L\s0\&
TEXTFLOW:\s-34C\s0\& TH:\s-33,3.2,4C,4L\s0\& TILDE:\s-33\s0\& TT
U:\s-33,3.2,4C,4L\s0\& VAR VEC:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
APPLET:\s-33.2,4C,4L\s0\& AU:\s-33\s0\& B BASEFONT:\s-33.2,4C,4L,M\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BR
BUTTON:\s-34L\s0\& CENTER:\s-3M\s0\& CITE CODE DEL:\s-33\s0\&
DFN:\s-33,3.2,4C,4L\s0\& EM FONT:\s-33.2,4C,4L,M\s0\& I
IFRAME:\s-34L\s0\& IMG INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\& KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& MAP:\s-33.2,4C,4L\s0\&
MATH:\s-33\s0\& NOBR:\s-3M\s0\& OBJECT:\s-34C,4L\s0\& PERSON:\s-33\s0\&
Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\& SAMP SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG STYLE:\s-34C\s0\& SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\& TEXTAREA:\s-33.2,4C,4L\s0\& TT
U:\s-33,3.2,4C,4L\s0\& VAR WBR:\s-3M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<BAR>" " \s-3required:3\s0\&" " .\|.\|. </BAR>" " \s-3required:3\s0\&"
.\"
.RS
.I "contained in:"
ABOVE:\s-33\s0\& BAR:\s-33\s0\& BELOW:\s-33\s0\& BOX:\s-33\s0\&
BT:\s-33\s0\& DDOT:\s-33\s0\& DOT:\s-33\s0\& HAT:\s-33\s0\&
ITEM:\s-33\s0\& MATH:\s-33\s0\& OF:\s-33\s0\& ROOT:\s-33\s0\&
SQRT:\s-33\s0\& T:\s-33\s0\& TILDE:\s-33\s0\& VEC:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33\s0\& ABOVE:\s-33\s0\& ARRAY:\s-33\s0\& B:\s-33\s0\&
BAR:\s-33\s0\& BELOW:\s-33\s0\& BOX:\s-33\s0\& BT:\s-33\s0\&
DDOT:\s-33\s0\& DOT:\s-33\s0\& HAT:\s-33\s0\& ROOT:\s-33\s0\&
SQRT:\s-33\s0\& SUB:\s-33\s0\& SUP:\s-33\s0\& T:\s-33\s0\&
TILDE:\s-33\s0\& VEC:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<BASE>" "\&"
.\"
.RS
.I "contained in:"
HEAD
.RE
.\"
.RS
.I "contains:"
EMPTY
.RE
.\"---------------------------------------------------------------------
.BR "<BASEFONT>" " \s-3required:3.2,4C,4L,M\s0\&"
.\"
.RS
.I "contained in:"
A:\s-33.2,4C,4L,M\s0\& ABBR:\s-34L\s0\& ADDRESS:\s-33.2,4C,4L,M\s0\&
APPLET:\s-33.2,4L\s0\& B:\s-33.2,4C,4L,M\s0\& BDO:\s-34C,4L\s0\&
BIG:\s-33.2,4C,4L\s0\& BLINK:\s-3M\s0\& BLOCKQUOTE:\s-33.2,4C,4L,M\s0\&
BODY:\s-33.2,4C,4L,M\s0\& BUTTON:\s-34L\s0\& CAPTION:\s-33.2,4C,4L\s0\&
CENTER:\s-33.2,4C,4L,M\s0\& CITE:\s-33.2,4C,4L,M\s0\&
CODE:\s-33.2,4C,4L,M\s0\& DD:\s-33.2,4C,4L,M\s0\& DEL:\s-34L\s0\&
DFN:\s-33.2,4C,4L\s0\& DIV:\s-33.2,4C,4L\s0\& DT:\s-33.2,4C,4L,M\s0\&
EM:\s-33.2,4C,4L,M\s0\& FIELDSET:\s-34C,4L\s0\&
FONT:\s-33.2,4C,4L,M\s0\& FORM:\s-33.2,4C,4L,M\s0\&
H1:\s-33.2,4C,4L,M\s0\& H2:\s-33.2,4C,4L,M\s0\& H3:\s-33.2,4C,4L,M\s0\&
H4:\s-33.2,4C,4L,M\s0\& H5:\s-33.2,4C,4L,M\s0\& H6:\s-33.2,4C,4L,M\s0\&
I:\s-33.2,4C,4L,M\s0\& IFRAME:\s-34L\s0\& INS:\s-34L\s0\&
KBD:\s-33.2,4C,4L,M\s0\& LABEL:\s-34C,4L\s0\& LEGEND:\s-34L\s0\&
LI:\s-33.2,4C,4L,M\s0\& NOBR:\s-3M\s0\& NOSCRIPT:\s-34L\s0\&
OBJECT:\s-34C,4L\s0\& P:\s-33.2,4C,4L,M\s0\& PRE:\s-33.2,4C\s0\&
Q:\s-34C,4L\s0\& S:\s-34C,4L\s0\& SAMP:\s-33.2,4C,4L,M\s0\&
SMALL:\s-33.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\& STRIKE:\s-33.2,4L\s0\&
STRONG:\s-33.2,4C,4L,M\s0\& SUB:\s-33.2,4C,4L\s0\&
SUP:\s-33.2,4C,4L\s0\& TD:\s-33.2,4C,4L\s0\& TEXTFLOW:\s-34C\s0\&
TH:\s-33.2,4C,4L\s0\& TT:\s-33.2,4C,4L,M\s0\& U:\s-33.2,4C,4L\s0\&
VAR:\s-33.2,4C,4L,M\s0\&
.RE
.\"
.RS
.I "contains:"
ANY:\s-3M\s0\& EMPTY:\s-33.2,4C,4L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<BDO>" " \s-3required:4C,4L\s0\&" " .\|.\|. </BDO>" " \s-3required:4C,4L\s0\&"
.\"
.RS
.I "contained in:"
A:\s-34C,4L\s0\& ABBR:\s-34L\s0\& ADDRESS:\s-34C,4L\s0\&
APPLET:\s-34L\s0\& B:\s-34C,4L\s0\& BDO:\s-34C,4L\s0\&
BIG:\s-34C,4L\s0\& BLOCKQUOTE:\s-34C,4L\s0\& BODY:\s-34C,4L\s0\&
BUTTON:\s-34L\s0\& CAPTION:\s-34C,4L\s0\& CENTER:\s-34C,4L\s0\&
CITE:\s-34C,4L\s0\& CODE:\s-34C,4L\s0\& DD:\s-34C,4L\s0\&
DEL:\s-34L\s0\& DFN:\s-34C,4L\s0\& DIV:\s-34C,4L\s0\& DT:\s-34C,4L\s0\&
EM:\s-34C,4L\s0\& FIELDSET:\s-34C,4L\s0\& FONT:\s-34C,4L\s0\&
FORM:\s-34C,4L\s0\& H1:\s-34C,4L\s0\& H2:\s-34C,4L\s0\&
H3:\s-34C,4L\s0\& H4:\s-34C,4L\s0\& H5:\s-34C,4L\s0\& H6:\s-34C,4L\s0\&
I:\s-34C,4L\s0\& IFRAME:\s-34L\s0\& INS:\s-34L\s0\& KBD:\s-34C,4L\s0\&
LABEL:\s-34C,4L\s0\& LEGEND:\s-34L\s0\& LI:\s-34C,4L\s0\&
NOSCRIPT:\s-34L\s0\& OBJECT:\s-34C,4L\s0\& P:\s-34C,4L\s0\&
PRE:\s-34C,4L\s0\& Q:\s-34C,4L\s0\& S:\s-34C,4L\s0\& SAMP:\s-34C,4L\s0\&
SMALL:\s-34C,4L\s0\& SPAN:\s-34C,4L\s0\& STRIKE:\s-34L\s0\&
STRONG:\s-34C,4L\s0\& SUB:\s-34C,4L\s0\& SUP:\s-34C,4L\s0\&
TD:\s-34C,4L\s0\& TEXTFLOW:\s-34C\s0\& TH:\s-34C,4L\s0\&
TT:\s-34C,4L\s0\& U:\s-34C,4L\s0\& VAR:\s-34C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-34C,4L\s0\& A:\s-34C,4L\s0\& ABBR:\s-34L\s0\&
APPLET:\s-34C,4L\s0\& B:\s-34C,4L\s0\& BASEFONT:\s-34C,4L\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-34C,4L\s0\& BR:\s-34C,4L\s0\&
BUTTON:\s-34L\s0\& CITE:\s-34C,4L\s0\& CODE:\s-34C,4L\s0\&
DFN:\s-34C,4L\s0\& EM:\s-34C,4L\s0\& FONT:\s-34C,4L\s0\&
I:\s-34C,4L\s0\& IFRAME:\s-34L\s0\& IMG:\s-34C,4L\s0\&
INPUT:\s-34C,4L\s0\& KBD:\s-34C,4L\s0\& LABEL:\s-34C,4L\s0\&
MAP:\s-34C,4L\s0\& OBJECT:\s-34C,4L\s0\& Q:\s-34C,4L\s0\&
S:\s-34C,4L\s0\& SAMP:\s-34C,4L\s0\& SCRIPT:\s-34C,4L\s0\&
SELECT:\s-34C,4L\s0\& SMALL:\s-34C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-34L\s0\& STRONG:\s-34C,4L\s0\& STYLE:\s-34C\s0\&
SUB:\s-34C,4L\s0\& SUP:\s-34C,4L\s0\& TEXTAREA:\s-34C,4L\s0\&
TT:\s-34C,4L\s0\& U:\s-34C,4L\s0\& VAR:\s-34C,4L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<BELOW>" " \s-3required:3\s0\&" " .\|.\|. </BELOW>" " \s-3required:3\s0\&"
.\"
.RS
.I "contained in:"
ABOVE:\s-33\s0\& BAR:\s-33\s0\& BELOW:\s-33\s0\& BOX:\s-33\s0\&
BT:\s-33\s0\& DDOT:\s-33\s0\& DOT:\s-33\s0\& HAT:\s-33\s0\&
ITEM:\s-33\s0\& MATH:\s-33\s0\& OF:\s-33\s0\& ROOT:\s-33\s0\&
SQRT:\s-33\s0\& T:\s-33\s0\& TILDE:\s-33\s0\& VEC:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33\s0\& ABOVE:\s-33\s0\& ARRAY:\s-33\s0\& B:\s-33\s0\&
BAR:\s-33\s0\& BELOW:\s-33\s0\& BOX:\s-33\s0\& BT:\s-33\s0\&
DDOT:\s-33\s0\& DOT:\s-33\s0\& HAT:\s-33\s0\& ROOT:\s-33\s0\&
SQRT:\s-33\s0\& SUB:\s-33\s0\& SUP:\s-33\s0\& T:\s-33\s0\&
TILDE:\s-33\s0\& VEC:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<BIG>" " \s-3required:3,3.2,4C,4L\s0\&" " .\|.\|. </BIG>" " \s-3required:3,3.2,4C,4L\s0\&"
.\"
.RS
.I "contained in:"
A:\s-33,3.2,4C,4L\s0\& ABBR:\s-34L\s0\& ABBREV:\s-33\s0\&
ACRONYM:\s-33\s0\& ADDRESS:\s-33,3.2,4C,4L\s0\& APPLET:\s-33.2,4L\s0\&
AU:\s-33\s0\& B:\s-33,3.2,4C,4L\s0\& BDO:\s-34C,4L\s0\&
BIG:\s-33,3.2,4C,4L\s0\& BLOCKQUOTE:\s-33,3.2,4C,4L\s0\&
BODY:\s-33,3.2,4C,4L\s0\& BQ:\s-33\s0\& BUTTON:\s-34L\s0\&
CAPTION:\s-33,3.2,4C,4L\s0\& CENTER:\s-33.2,4C,4L\s0\&
CITE:\s-33,3.2,4C,4L\s0\& CODE:\s-33,3.2,4C,4L\s0\& CREDIT:\s-33\s0\&
DD:\s-33,3.2,4C,4L\s0\& DEL:\s-33,4L\s0\& DFN:\s-33,3.2,4C,4L\s0\&
DIV:\s-33,3.2,4C,4L\s0\& DT:\s-33,3.2,4C,4L\s0\& EM:\s-33,3.2,4C,4L\s0\&
FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\& FONT:\s-33.2,4C,4L\s0\&
FORM:\s-33,3.2,4C,4L\s0\& H1:\s-33,3.2,4C,4L\s0\&
H2:\s-33,3.2,4C,4L\s0\& H3:\s-33,3.2,4C,4L\s0\& H4:\s-33,3.2,4C,4L\s0\&
H5:\s-33,3.2,4C,4L\s0\& H6:\s-33,3.2,4C,4L\s0\& I:\s-33,3.2,4C,4L\s0\&
IFRAME:\s-34L\s0\& INS:\s-33,4L\s0\& KBD:\s-33,3.2,4C,4L\s0\&
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& LEGEND:\s-34L\s0\& LH:\s-33\s0\&
LI:\s-33,3.2,4C,4L\s0\& NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& P:\s-33,3.2,4C,4L\s0\& PERSON:\s-33\s0\&
Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\& SAMP:\s-33,3.2,4C,4L\s0\&
SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\& STRIKE:\s-33.2,4L\s0\&
STRONG:\s-33,3.2,4C,4L\s0\& SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TD:\s-33,3.2,4C,4L\s0\& TEXTFLOW:\s-34C\s0\&
TH:\s-33,3.2,4C,4L\s0\& TT:\s-33,3.2,4C,4L\s0\& U:\s-33,3.2,4C,4L\s0\&
VAR:\s-33,3.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33,3.2,4C,4L\s0\& A:\s-33,3.2,4C,4L\s0\& ABBR:\s-34L\s0\&
ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& APPLET:\s-33.2,4C,4L\s0\&
AU:\s-33\s0\& B:\s-33,3.2,4C,4L\s0\& BASEFONT:\s-33.2,4C,4L\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\& BR:\s-33,3.2,4C,4L\s0\&
BUTTON:\s-34L\s0\& CITE:\s-33,3.2,4C,4L\s0\& CODE:\s-33,3.2,4C,4L\s0\&
DEL:\s-33\s0\& DFN:\s-33,3.2,4C,4L\s0\& EM:\s-33,3.2,4C,4L\s0\&
FONT:\s-33.2,4C,4L\s0\& I:\s-33,3.2,4C,4L\s0\& IFRAME:\s-34L\s0\&
IMG:\s-33,3.2,4C,4L\s0\& INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\&
KBD:\s-33,3.2,4C,4L\s0\& LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\&
MAP:\s-33.2,4C,4L\s0\& MATH:\s-33\s0\& OBJECT:\s-34C,4L\s0\&
PERSON:\s-33\s0\& Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\&
SAMP:\s-33,3.2,4C,4L\s0\& SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG:\s-33,3.2,4C,4L\s0\& STYLE:\s-34C\s0\&
SUB:\s-33,3.2,4C,4L\s0\& SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\&
TEXTAREA:\s-33.2,4C,4L\s0\& TT:\s-33,3.2,4C,4L\s0\&
U:\s-33,3.2,4C,4L\s0\& VAR:\s-33,3.2,4C,4L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<BLINK>" " \s-3required:M\s0\&" " .\|.\|. </BLINK>" " \s-3required:M\s0\&"
.\"
.RS
.I "contained in:"
A:\s-3M\s0\& ADDRESS:\s-3M\s0\& B:\s-3M\s0\& BLINK:\s-3M\s0\&
BLOCKQUOTE:\s-3M\s0\& BODY:\s-3M\s0\& CENTER:\s-3M\s0\& CITE:\s-3M\s0\&
CODE:\s-3M\s0\& DD:\s-3M\s0\& DT:\s-3M\s0\& EM:\s-3M\s0\&
FONT:\s-3M\s0\& FORM:\s-3M\s0\& H1:\s-3M\s0\& H2:\s-3M\s0\&
H3:\s-3M\s0\& H4:\s-3M\s0\& H5:\s-3M\s0\& H6:\s-3M\s0\& I:\s-3M\s0\&
KBD:\s-3M\s0\& LI:\s-3M\s0\& NOBR:\s-3M\s0\& P:\s-3M\s0\& PRE:\s-3M\s0\&
SAMP:\s-3M\s0\& STRONG:\s-3M\s0\& TT:\s-3M\s0\& VAR:\s-3M\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-3M\s0\& A:\s-3M\s0\& B:\s-3M\s0\& BASEFONT:\s-3M\s0\&
BLINK:\s-3M\s0\& BR:\s-3M\s0\& CENTER:\s-3M\s0\& CITE:\s-3M\s0\&
CODE:\s-3M\s0\& EM:\s-3M\s0\& FONT:\s-3M\s0\& I:\s-3M\s0\&
IMG:\s-3M\s0\& KBD:\s-3M\s0\& NOBR:\s-3M\s0\& SAMP:\s-3M\s0\&
STRONG:\s-3M\s0\& TT:\s-3M\s0\& VAR:\s-3M\s0\& WBR:\s-3M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<BLOCKQUOTE>" "\&" " .\|.\|. </BLOCKQUOTE>" "\&"
.\"
.RS
.I "contained in:"
APPLET:\s-34L\s0\& BLOCKQUOTE BODY BQ:\s-33\s0\& BUTTON:\s-34L\s0\&
CENTER:\s-33.2,4C,4L,M\s0\& DD DEL:\s-34L\s0\& DIV:\s-33,3.2,4C,4L\s0\&
FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\& FORM IFRAME:\s-34L\s0\&
INS:\s-34L\s0\& LI NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& TD:\s-33,3.2,4C,4L\s0\& TH:\s-33,3.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& ADDRESS
APPLET:\s-33.2,4C,4L\s0\& AU:\s-33\s0\& B BASEFONT:\s-33.2,4C,4L,M\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BLOCKQUOTE
BQ:\s-33\s0\& BR BUTTON:\s-34L\s0\& CENTER:\s-33.2,4C,4L,M\s0\& CITE
CODE CREDIT:\s-33\s0\& DEL:\s-33\s0\& DFN:\s-33,3.2,4C,4L\s0\& DIR
DIV:\s-33,3.2,4C,4L\s0\& DL EM FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\&
FONT:\s-33.2,4C,4L,M\s0\& FORM H1 H2 H3 H4 H5 H6 HR I IFRAME:\s-34L\s0\&
IMG INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\& ISINDEX KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& LISTING:\s-32,3,3.2,4C,M\s0\&
MAP:\s-33.2,4C,4L\s0\& MATH:\s-33\s0\& MENU NOBR:\s-3M\s0\&
NOFRAMES:\s-34L\s0\& NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& OL P PERSON:\s-33\s0\& PRE Q:\s-33,4C,4L\s0\&
S:\s-33,4C,4L\s0\& SAMP SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG STYLE:\s-34C\s0\& SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\& TABLE:\s-33,3.2,4C,4L\s0\&
TEXTAREA:\s-33.2,4C,4L\s0\& TT U:\s-33,3.2,4C,4L\s0\& UL VAR
WBR:\s-3M\s0\& XMP:\s-32,3,3.2,4C,M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<BODY>" " \s-3optional\s0\&" " .\|.\|. </BODY>" " \s-3optional\s0\&"
.\"
.RS
.I "contained in:"
HTML NOFRAMES:\s-34L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& ADDRESS
APPLET:\s-33.2,4C,4L\s0\& AU:\s-33\s0\& B BASEFONT:\s-33.2,4C,4L,M\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BLOCKQUOTE
BQ:\s-33\s0\& BR BUTTON:\s-34L\s0\& CENTER:\s-33.2,4C,4L,M\s0\& CITE
CODE DEL:\s-33,4L\s0\& DFN:\s-33,3.2,4C,4L\s0\& DIR
DIV:\s-33,3.2,4C,4L\s0\& DL EM FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\&
FONT:\s-33.2,4C,4L,M\s0\& FORM H1 H2 H3 H4 H5 H6 HR I IFRAME:\s-34L\s0\&
IMG INPUT:\s-33.2,4C,4L\s0\& INS:\s-33,4L\s0\& ISINDEX KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& LISTING:\s-32,3,3.2,4C,M\s0\&
MAP:\s-33.2,4C,4L\s0\& MATH:\s-33\s0\& MENU NOBR:\s-3M\s0\&
NOFRAMES:\s-34L\s0\& NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& OL P PERSON:\s-33\s0\& PRE Q:\s-33,4C,4L\s0\&
S:\s-33,4C,4L\s0\& SAMP SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG STYLE:\s-34C\s0\& SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\& TABLE:\s-33,3.2,4C,4L\s0\&
TEXTAREA:\s-33.2,4C,4L\s0\& TT U:\s-33,3.2,4C,4L\s0\& UL VAR
WBR:\s-3M\s0\& XMP:\s-32,3,3.2,4C,M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<BOX>" " \s-3required:3\s0\&" " .\|.\|. </BOX>" " \s-3required:3\s0\&"
.\"
.RS
.I "contained in:"
ABOVE:\s-33\s0\& BAR:\s-33\s0\& BELOW:\s-33\s0\& BOX:\s-33\s0\&
BT:\s-33\s0\& DDOT:\s-33\s0\& DOT:\s-33\s0\& HAT:\s-33\s0\&
ITEM:\s-33\s0\& MATH:\s-33\s0\& OF:\s-33\s0\& ROOT:\s-33\s0\&
SQRT:\s-33\s0\& T:\s-33\s0\& TILDE:\s-33\s0\& VEC:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33\s0\& ABOVE:\s-33\s0\& ARRAY:\s-33\s0\& ATOP:\s-33\s0\&
B:\s-33\s0\& BAR:\s-33\s0\& BELOW:\s-33\s0\& BOX:\s-33\s0\&
BT:\s-33\s0\& CHOOSE:\s-33\s0\& DDOT:\s-33\s0\& DOT:\s-33\s0\&
HAT:\s-33\s0\& LEFT:\s-33\s0\& OVER:\s-33\s0\& RIGHT:\s-33\s0\&
ROOT:\s-33\s0\& SQRT:\s-33\s0\& SUB:\s-33\s0\& SUP:\s-33\s0\&
T:\s-33\s0\& TILDE:\s-33\s0\& VEC:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<BQ>" " \s-3required:3\s0\&" " .\|.\|. </BQ>" " \s-3required:3\s0\&" " (deprecated)"
.\"
.RS
.I "contained in:"
BLOCKQUOTE:\s-33\s0\& BODY:\s-33\s0\& BQ:\s-33\s0\& DD:\s-33\s0\&
DIV:\s-33\s0\& FIG:\s-33\s0\& FORM:\s-33\s0\& LI:\s-33\s0\&
NOTE:\s-33\s0\& TD:\s-33\s0\& TH:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33\s0\& A:\s-33\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
ADDRESS:\s-33\s0\& AU:\s-33\s0\& B:\s-33\s0\& BIG:\s-33\s0\&
BLOCKQUOTE:\s-33\s0\& BQ:\s-33\s0\& BR:\s-33\s0\& CITE:\s-33\s0\&
CODE:\s-33\s0\& CREDIT:\s-33\s0\& DEL:\s-33\s0\& DFN:\s-33\s0\&
DIR:\s-33\s0\& DIV:\s-33\s0\& DL:\s-33\s0\& EM:\s-33\s0\& FIG:\s-33\s0\&
FORM:\s-33\s0\& H1:\s-33\s0\& H2:\s-33\s0\& H3:\s-33\s0\& H4:\s-33\s0\&
H5:\s-33\s0\& H6:\s-33\s0\& HR:\s-33\s0\& I:\s-33\s0\& IMG:\s-33\s0\&
INS:\s-33\s0\& ISINDEX:\s-33\s0\& KBD:\s-33\s0\& LANG:\s-33\s0\&
LISTING:\s-33\s0\& MATH:\s-33\s0\& MENU:\s-33\s0\& NOTE:\s-33\s0\&
OL:\s-33\s0\& P:\s-33\s0\& PERSON:\s-33\s0\& PRE:\s-33\s0\& Q:\s-33\s0\&
S:\s-33\s0\& SAMP:\s-33\s0\& SMALL:\s-33\s0\& STRONG:\s-33\s0\&
SUB:\s-33\s0\& SUP:\s-33\s0\& TAB:\s-33\s0\& TABLE:\s-33\s0\&
TT:\s-33\s0\& U:\s-33\s0\& UL:\s-33\s0\& VAR:\s-33\s0\& XMP:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<BR>" "\&"
.\"
.RS
.I "contained in:"
A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& ADDRESS
APPLET:\s-33.2,4L\s0\& AU:\s-33\s0\& B BDO:\s-34C,4L\s0\&
BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BLOCKQUOTE BODY BQ:\s-33\s0\&
BUTTON:\s-34L\s0\& CAPTION:\s-33,3.2,4C,4L\s0\&
CENTER:\s-33.2,4C,4L,M\s0\& CITE CODE CREDIT:\s-33\s0\& DD
DEL:\s-33,4L\s0\& DFN:\s-33,3.2,4C,4L\s0\& DIV:\s-33,3.2,4C,4L\s0\& DT
EM FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\& FONT:\s-33.2,4C,4L,M\s0\& FORM
H1 H2 H3 H4 H5 H6 I IFRAME:\s-34L\s0\& INS:\s-33,4L\s0\& KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& LEGEND:\s-34L\s0\& LH:\s-33\s0\& LI
NOBR:\s-3M\s0\& NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& P PERSON:\s-33\s0\& PRE Q:\s-33,4C,4L\s0\&
S:\s-33,4C,4L\s0\& SAMP SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TD:\s-33,3.2,4C,4L\s0\& TEXTFLOW:\s-34C\s0\&
TH:\s-33,3.2,4C,4L\s0\& TT U:\s-33,3.2,4C,4L\s0\& VAR
.RE
.\"
.RS
.I "contains:"
EMPTY
.RE
.\"---------------------------------------------------------------------
.BR "<BT>" " \s-3required:3\s0\&" " .\|.\|. </BT>" " \s-3required:3\s0\&"
.\"
.RS
.I "contained in:"
ABOVE:\s-33\s0\& BAR:\s-33\s0\& BELOW:\s-33\s0\& BOX:\s-33\s0\&
BT:\s-33\s0\& DDOT:\s-33\s0\& DOT:\s-33\s0\& HAT:\s-33\s0\&
ITEM:\s-33\s0\& MATH:\s-33\s0\& OF:\s-33\s0\& ROOT:\s-33\s0\&
SQRT:\s-33\s0\& T:\s-33\s0\& TILDE:\s-33\s0\& VEC:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33\s0\& ABOVE:\s-33\s0\& ARRAY:\s-33\s0\& B:\s-33\s0\&
BAR:\s-33\s0\& BELOW:\s-33\s0\& BOX:\s-33\s0\& BT:\s-33\s0\&
DDOT:\s-33\s0\& DOT:\s-33\s0\& HAT:\s-33\s0\& ROOT:\s-33\s0\&
SQRT:\s-33\s0\& SUB:\s-33\s0\& SUP:\s-33\s0\& T:\s-33\s0\&
TILDE:\s-33\s0\& VEC:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<BUTTON>" " \s-3required:4L\s0\&" " .\|.\|. </BUTTON>" " \s-3required:4L\s0\&"
.\"
.RS
.I "contained in:"
A:\s-34L\s0\& ABBR:\s-34L\s0\& ADDRESS:\s-34L\s0\& APPLET:\s-34L\s0\&
B:\s-34L\s0\& BDO:\s-34L\s0\& BIG:\s-34L\s0\& BLOCKQUOTE:\s-34L\s0\&
BODY:\s-34L\s0\& CAPTION:\s-34L\s0\& CENTER:\s-34L\s0\& CITE:\s-34L\s0\&
CODE:\s-34L\s0\& DD:\s-34L\s0\& DEL:\s-34L\s0\& DFN:\s-34L\s0\&
DIV:\s-34L\s0\& DT:\s-34L\s0\& EM:\s-34L\s0\& FIELDSET:\s-34L\s0\&
FONT:\s-34L\s0\& FORM:\s-34L\s0\& H1:\s-34L\s0\& H2:\s-34L\s0\&
H3:\s-34L\s0\& H4:\s-34L\s0\& H5:\s-34L\s0\& H6:\s-34L\s0\&
I:\s-34L\s0\& IFRAME:\s-34L\s0\& INS:\s-34L\s0\& KBD:\s-34L\s0\&
LABEL:\s-34L\s0\& LEGEND:\s-34L\s0\& LI:\s-34L\s0\& NOSCRIPT:\s-34L\s0\&
OBJECT:\s-34L\s0\& P:\s-34L\s0\& PRE:\s-34L\s0\& Q:\s-34L\s0\&
S:\s-34L\s0\& SAMP:\s-34L\s0\& SMALL:\s-34L\s0\& SPAN:\s-34L\s0\&
STRIKE:\s-34L\s0\& STRONG:\s-34L\s0\& SUB:\s-34L\s0\& SUP:\s-34L\s0\&
TD:\s-34L\s0\& TH:\s-34L\s0\& TT:\s-34L\s0\& U:\s-34L\s0\&
VAR:\s-34L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-34L\s0\& ABBR:\s-34L\s0\& ADDRESS:\s-34L\s0\&
APPLET:\s-34L\s0\& B:\s-34L\s0\& BASEFONT:\s-34L\s0\& BDO:\s-34L\s0\&
BIG:\s-34L\s0\& BLOCKQUOTE:\s-34L\s0\& BR:\s-34L\s0\& CENTER:\s-34L\s0\&
CITE:\s-34L\s0\& CODE:\s-34L\s0\& DFN:\s-34L\s0\& DIR:\s-34L\s0\&
DIV:\s-34L\s0\& DL:\s-34L\s0\& EM:\s-34L\s0\& FONT:\s-34L\s0\&
H1:\s-34L\s0\& H2:\s-34L\s0\& H3:\s-34L\s0\& H4:\s-34L\s0\&
H5:\s-34L\s0\& H6:\s-34L\s0\& HR:\s-34L\s0\& I:\s-34L\s0\&
IMG:\s-34L\s0\& KBD:\s-34L\s0\& MAP:\s-34L\s0\& MENU:\s-34L\s0\&
NOFRAMES:\s-34L\s0\& NOSCRIPT:\s-34L\s0\& OBJECT:\s-34L\s0\&
OL:\s-34L\s0\& P:\s-34L\s0\& PRE:\s-34L\s0\& Q:\s-34L\s0\& S:\s-34L\s0\&
SAMP:\s-34L\s0\& SCRIPT:\s-34L\s0\& SMALL:\s-34L\s0\& SPAN:\s-34L\s0\&
STRIKE:\s-34L\s0\& STRONG:\s-34L\s0\& SUB:\s-34L\s0\& SUP:\s-34L\s0\&
TABLE:\s-34L\s0\& TT:\s-34L\s0\& U:\s-34L\s0\& UL:\s-34L\s0\&
VAR:\s-34L\s0\&
.RE
.\"
.RS
.I "cannot contain:"
A:\s-34L\s0\& BUTTON:\s-34L\s0\& FIELDSET:\s-34L\s0\& FORM:\s-34L\s0\&
IFRAME:\s-34L\s0\& INPUT:\s-34L\s0\& ISINDEX:\s-34L\s0\&
LABEL:\s-34L\s0\& SELECT:\s-34L\s0\& TEXTAREA:\s-34L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<CAPTION>" " \s-3required:3,3.2,4C,4L\s0\&" " .\|.\|. </CAPTION>" " \s-3required:3,3.2,4C,4L\s0\&"
.\"
.RS
.I "contained in:"
FIELDSET:\s-34C\s0\& FIG:\s-33\s0\& TABLE:\s-33,3.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33,3.2,4C,4L\s0\& A:\s-33,3.2,4C,4L\s0\& ABBR:\s-34L\s0\&
ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& APPLET:\s-33.2,4C,4L\s0\&
AU:\s-33\s0\& B:\s-33,3.2,4C,4L\s0\& BASEFONT:\s-33.2,4C,4L\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\& BR:\s-33,3.2,4C,4L\s0\&
BUTTON:\s-34L\s0\& CITE:\s-33,3.2,4C,4L\s0\& CODE:\s-33,3.2,4C,4L\s0\&
DEL:\s-33\s0\& DFN:\s-33,3.2,4C,4L\s0\& EM:\s-33,3.2,4C,4L\s0\&
FONT:\s-33.2,4C,4L\s0\& I:\s-33,3.2,4C,4L\s0\& IFRAME:\s-34L\s0\&
IMG:\s-33,3.2,4C,4L\s0\& INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\&
KBD:\s-33,3.2,4C,4L\s0\& LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\&
MAP:\s-33.2,4C,4L\s0\& MATH:\s-33\s0\& OBJECT:\s-34C,4L\s0\&
PERSON:\s-33\s0\& Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\&
SAMP:\s-33,3.2,4C,4L\s0\& SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG:\s-33,3.2,4C,4L\s0\& STYLE:\s-34C\s0\&
SUB:\s-33,3.2,4C,4L\s0\& SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\&
TEXTAREA:\s-33.2,4C,4L\s0\& TT:\s-33,3.2,4C,4L\s0\&
U:\s-33,3.2,4C,4L\s0\& VAR:\s-33,3.2,4C,4L\s0\&
.RE
.\"---------------------------------------------------------------------
.B CDATA
.\"
.RS
.I "contained in:"
LISTING:\s-32,3,3.2,4C,M\s0\& PLAINTEXT:\s-32,3,3.2,4C,M\s0\&
SCRIPT:\s-33.2,4C,4L\s0\& STYLE:\s-33.2,4C,4L\s0\&
XMP:\s-32,3,3.2,4C,M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<CENTER>" " \s-3required:3.2,4C,4L,M\s0\&" " .\|.\|. </CENTER>" " \s-3required:3.2,4C,4L,M\s0\&"
.\"
.RS
.I "contained in:"
A:\s-3M\s0\& ADDRESS:\s-3M\s0\& APPLET:\s-34L\s0\& B:\s-3M\s0\&
BLINK:\s-3M\s0\& BLOCKQUOTE:\s-33.2,4C,4L,M\s0\&
BODY:\s-33.2,4C,4L,M\s0\& BUTTON:\s-34L\s0\& CENTER:\s-33.2,4C,4L,M\s0\&
CITE:\s-3M\s0\& CODE:\s-3M\s0\& DD:\s-33.2,4C,4L,M\s0\& DEL:\s-34L\s0\&
DIV:\s-33.2,4C,4L\s0\& DT:\s-3M\s0\& EM:\s-3M\s0\&
FIELDSET:\s-34C,4L\s0\& FONT:\s-3M\s0\& FORM:\s-33.2,4C,4L,M\s0\&
H1:\s-3M\s0\& H2:\s-3M\s0\& H3:\s-3M\s0\& H4:\s-3M\s0\& H5:\s-3M\s0\&
H6:\s-3M\s0\& I:\s-3M\s0\& IFRAME:\s-34L\s0\& INS:\s-34L\s0\&
KBD:\s-3M\s0\& LI:\s-33.2,4C,4L,M\s0\& NOBR:\s-3M\s0\&
NOSCRIPT:\s-34L\s0\& OBJECT:\s-34C,4L\s0\& P:\s-3M\s0\& SAMP:\s-3M\s0\&
STRONG:\s-3M\s0\& TD:\s-33.2,4C,4L\s0\& TH:\s-33.2,4C,4L\s0\&
TT:\s-3M\s0\& VAR:\s-3M\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33.2,4C,4L,M\s0\& A:\s-33.2,4C,4L,M\s0\& ABBR:\s-34L\s0\&
ADDRESS:\s-33.2,4C,4L,M\s0\& APPLET:\s-33.2,4C,4L\s0\&
B:\s-33.2,4C,4L,M\s0\& BASEFONT:\s-33.2,4C,4L,M\s0\& BDO:\s-34C,4L\s0\&
BIG:\s-33.2,4C,4L\s0\& BLINK:\s-3M\s0\& BLOCKQUOTE:\s-33.2,4C,4L,M\s0\&
BR:\s-33.2,4C,4L,M\s0\& BUTTON:\s-34L\s0\& CENTER:\s-33.2,4C,4L,M\s0\&
CITE:\s-33.2,4C,4L,M\s0\& CODE:\s-33.2,4C,4L,M\s0\&
DFN:\s-33.2,4C,4L\s0\& DIR:\s-33.2,4C,4L,M\s0\& DIV:\s-33.2,4C,4L\s0\&
DL:\s-33.2,4C,4L,M\s0\& EM:\s-33.2,4C,4L,M\s0\& FIELDSET:\s-34C,4L\s0\&
FONT:\s-33.2,4C,4L,M\s0\& FORM:\s-33.2,4C,4L,M\s0\&
H1:\s-33.2,4C,4L,M\s0\& H2:\s-33.2,4C,4L,M\s0\& H3:\s-33.2,4C,4L,M\s0\&
H4:\s-33.2,4C,4L,M\s0\& H5:\s-33.2,4C,4L,M\s0\& H6:\s-33.2,4C,4L,M\s0\&
HR:\s-33.2,4C,4L,M\s0\& I:\s-33.2,4C,4L,M\s0\& IFRAME:\s-34L\s0\&
IMG:\s-33.2,4C,4L,M\s0\& INPUT:\s-33.2,4C,4L\s0\&
ISINDEX:\s-33.2,4C,4L,M\s0\& KBD:\s-33.2,4C,4L,M\s0\&
LABEL:\s-34C,4L\s0\& LISTING:\s-33.2,4C,M\s0\& MAP:\s-33.2,4C,4L\s0\&
MENU:\s-33.2,4C,4L,M\s0\& NOBR:\s-3M\s0\& NOFRAMES:\s-34L\s0\&
NOSCRIPT:\s-34L\s0\& OBJECT:\s-34C,4L\s0\& OL:\s-33.2,4C,4L,M\s0\&
P:\s-33.2,4C,4L,M\s0\& PRE:\s-33.2,4C,4L,M\s0\& Q:\s-34C,4L\s0\&
S:\s-34C,4L\s0\& SAMP:\s-33.2,4C,4L,M\s0\& SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG:\s-33.2,4C,4L,M\s0\& STYLE:\s-34C\s0\&
SUB:\s-33.2,4C,4L\s0\& SUP:\s-33.2,4C,4L\s0\& TABLE:\s-33.2,4C,4L\s0\&
TEXTAREA:\s-33.2,4C,4L\s0\& TT:\s-33.2,4C,4L,M\s0\& U:\s-33.2,4C,4L\s0\&
UL:\s-33.2,4C,4L,M\s0\& VAR:\s-33.2,4C,4L,M\s0\& WBR:\s-3M\s0\&
XMP:\s-33.2,4C,M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<CHOOSE>" " \s-3required:3\s0\&"
.\"
.RS
.I "contained in:"
BOX:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
EMPTY:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<CITE>" "\&" " .\|.\|. </CITE>" "\&"
.\"
.RS
.I "contained in:"
A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& ADDRESS
APPLET:\s-33.2,4L\s0\& AU:\s-33\s0\& B BDO:\s-34C,4L\s0\&
BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BLOCKQUOTE BODY BQ:\s-33\s0\&
BUTTON:\s-34L\s0\& CAPTION:\s-33,3.2,4C,4L\s0\&
CENTER:\s-33.2,4C,4L,M\s0\& CITE CODE CREDIT:\s-33\s0\& DD
DEL:\s-33,4L\s0\& DFN:\s-33,3.2,4C,4L\s0\& DIV:\s-33,3.2,4C,4L\s0\& DT
EM FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\& FONT:\s-33.2,4C,4L,M\s0\& FORM
H1 H2 H3 H4 H5 H6 I IFRAME:\s-34L\s0\& INS:\s-33,4L\s0\& KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& LEGEND:\s-34L\s0\& LH:\s-33\s0\& LI
NOBR:\s-3M\s0\& NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& P PERSON:\s-33\s0\& PRE Q:\s-33,4C,4L\s0\&
S:\s-33,4C,4L\s0\& SAMP SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TD:\s-33,3.2,4C,4L\s0\& TEXTFLOW:\s-34C\s0\&
TH:\s-33,3.2,4C,4L\s0\& TT U:\s-33,3.2,4C,4L\s0\& VAR
.RE
.\"
.RS
.I "contains:"
#PCDATA A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
APPLET:\s-33.2,4C,4L\s0\& AU:\s-33\s0\& B BASEFONT:\s-33.2,4C,4L,M\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BR
BUTTON:\s-34L\s0\& CENTER:\s-3M\s0\& CITE CODE DEL:\s-33\s0\&
DFN:\s-33,3.2,4C,4L\s0\& EM FONT:\s-33.2,4C,4L,M\s0\& I
IFRAME:\s-34L\s0\& IMG INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\& KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& MAP:\s-33.2,4C,4L\s0\&
MATH:\s-33\s0\& NOBR:\s-3M\s0\& OBJECT:\s-34C,4L\s0\& PERSON:\s-33\s0\&
Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\& SAMP SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG STYLE:\s-34C\s0\& SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\& TEXTAREA:\s-33.2,4C,4L\s0\& TT
U:\s-33,3.2,4C,4L\s0\& VAR WBR:\s-3M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<CODE>" "\&" " .\|.\|. </CODE>" "\&"
.\"
.RS
.I "contained in:"
A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& ADDRESS
APPLET:\s-33.2,4L\s0\& AU:\s-33\s0\& B BDO:\s-34C,4L\s0\&
BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BLOCKQUOTE BODY BQ:\s-33\s0\&
BUTTON:\s-34L\s0\& CAPTION:\s-33,3.2,4C,4L\s0\&
CENTER:\s-33.2,4C,4L,M\s0\& CITE CODE CREDIT:\s-33\s0\& DD
DEL:\s-33,4L\s0\& DFN:\s-33,3.2,4C,4L\s0\& DIV:\s-33,3.2,4C,4L\s0\& DT
EM FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\& FONT:\s-33.2,4C,4L,M\s0\& FORM
H1 H2 H3 H4 H5 H6 I IFRAME:\s-34L\s0\& INS:\s-33,4L\s0\& KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& LEGEND:\s-34L\s0\& LH:\s-33\s0\& LI
NOBR:\s-3M\s0\& NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& P PERSON:\s-33\s0\& PRE Q:\s-33,4C,4L\s0\&
S:\s-33,4C,4L\s0\& SAMP SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TD:\s-33,3.2,4C,4L\s0\& TEXTFLOW:\s-34C\s0\&
TH:\s-33,3.2,4C,4L\s0\& TT U:\s-33,3.2,4C,4L\s0\& VAR
.RE
.\"
.RS
.I "contains:"
#PCDATA A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
APPLET:\s-33.2,4C,4L\s0\& AU:\s-33\s0\& B BASEFONT:\s-33.2,4C,4L,M\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BR
BUTTON:\s-34L\s0\& CENTER:\s-3M\s0\& CITE CODE DEL:\s-33\s0\&
DFN:\s-33,3.2,4C,4L\s0\& EM FONT:\s-33.2,4C,4L,M\s0\& I
IFRAME:\s-34L\s0\& IMG INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\& KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& MAP:\s-33.2,4C,4L\s0\&
MATH:\s-33\s0\& NOBR:\s-3M\s0\& OBJECT:\s-34C,4L\s0\& PERSON:\s-33\s0\&
Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\& SAMP SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG STYLE:\s-34C\s0\& SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\& TEXTAREA:\s-33.2,4C,4L\s0\& TT
U:\s-33,3.2,4C,4L\s0\& VAR WBR:\s-3M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<COL>" " \s-3required:4C,4L\s0\&"
.\"
.RS
.I "contained in:"
COLGROUP:\s-34C,4L\s0\& TABLE:\s-34C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
EMPTY:\s-34C,4L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<COLGROUP>" " \s-3required:4C,4L\s0\&" " .\|.\|. </COLGROUP>" " \s-3optional:4C,4L\s0\&"
.\"
.RS
.I "contained in:"
TABLE:\s-34C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
COL:\s-34C,4L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<CREDIT>" " \s-3required:3\s0\&" " .\|.\|. </CREDIT>" " \s-3required:3\s0\&"
.\"
.RS
.I "contained in:"
BLOCKQUOTE:\s-33\s0\& BQ:\s-33\s0\& FIG:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33\s0\& A:\s-33\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
AU:\s-33\s0\& B:\s-33\s0\& BIG:\s-33\s0\& BR:\s-33\s0\& CITE:\s-33\s0\&
CODE:\s-33\s0\& DEL:\s-33\s0\& DFN:\s-33\s0\& EM:\s-33\s0\& I:\s-33\s0\&
IMG:\s-33\s0\& INS:\s-33\s0\& KBD:\s-33\s0\& LANG:\s-33\s0\&
MATH:\s-33\s0\& PERSON:\s-33\s0\& Q:\s-33\s0\& S:\s-33\s0\&
SAMP:\s-33\s0\& SMALL:\s-33\s0\& STRONG:\s-33\s0\& SUB:\s-33\s0\&
SUP:\s-33\s0\& TAB:\s-33\s0\& TT:\s-33\s0\& U:\s-33\s0\& VAR:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<DD>" "\&" " .\|.\|. </DD>" " \s-3optional\s0\&"
.\"
.RS
.I "contained in:"
DL
.RE
.\"
.RS
.I "contains:"
#PCDATA A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
ADDRESS:\s-34L\s0\& APPLET:\s-33.2,4C,4L\s0\& AU:\s-33\s0\& B
BASEFONT:\s-33.2,4C,4L,M\s0\& BDO:\s-34C,4L\s0\&
BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BLOCKQUOTE BQ:\s-33\s0\& BR
BUTTON:\s-34L\s0\& CENTER:\s-33.2,4C,4L,M\s0\& CITE CODE DEL:\s-33\s0\&
DFN:\s-33,3.2,4C,4L\s0\& DIR DIV:\s-33.2,4C,4L\s0\& DL EM
FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\& FONT:\s-33.2,4C,4L,M\s0\& FORM
H1:\s-34L\s0\& H2:\s-34L\s0\& H3:\s-34L\s0\& H4:\s-34L\s0\&
H5:\s-34L\s0\& H6:\s-34L\s0\& HR:\s-33.2,4C,4L\s0\& I IFRAME:\s-34L\s0\&
IMG INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\& ISINDEX KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& LISTING:\s-32,3,3.2,4C,M\s0\&
MAP:\s-33.2,4C,4L\s0\& MATH:\s-33\s0\& MENU NOBR:\s-3M\s0\&
NOFRAMES:\s-34L\s0\& NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& OL P PERSON:\s-33\s0\& PRE Q:\s-33,4C,4L\s0\&
S:\s-33,4C,4L\s0\& SAMP SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG STYLE:\s-34C\s0\& SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\& TABLE:\s-33,3.2,4C,4L\s0\&
TEXTAREA:\s-33.2,4C,4L\s0\& TT U:\s-33,3.2,4C,4L\s0\& UL VAR
WBR:\s-3M\s0\& XMP:\s-32,3,3.2,4C,M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<DDOT>" " \s-3required:3\s0\&" " .\|.\|. </DDOT>" " \s-3required:3\s0\&"
.\"
.RS
.I "contained in:"
ABOVE:\s-33\s0\& BAR:\s-33\s0\& BELOW:\s-33\s0\& BOX:\s-33\s0\&
BT:\s-33\s0\& DDOT:\s-33\s0\& DOT:\s-33\s0\& HAT:\s-33\s0\&
ITEM:\s-33\s0\& MATH:\s-33\s0\& OF:\s-33\s0\& ROOT:\s-33\s0\&
SQRT:\s-33\s0\& T:\s-33\s0\& TILDE:\s-33\s0\& VEC:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33\s0\& ABOVE:\s-33\s0\& ARRAY:\s-33\s0\& B:\s-33\s0\&
BAR:\s-33\s0\& BELOW:\s-33\s0\& BOX:\s-33\s0\& BT:\s-33\s0\&
DDOT:\s-33\s0\& DOT:\s-33\s0\& HAT:\s-33\s0\& ROOT:\s-33\s0\&
SQRT:\s-33\s0\& SUB:\s-33\s0\& SUP:\s-33\s0\& T:\s-33\s0\&
TILDE:\s-33\s0\& VEC:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<DEL>" " \s-3required:3,4L\s0\&" " .\|.\|. </DEL>" " \s-3required:3,4L\s0\&"
.\"
.RS
.I "contained in:"
A:\s-33\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& ADDRESS:\s-33\s0\&
AU:\s-33\s0\& B:\s-33\s0\& BIG:\s-33\s0\& BLOCKQUOTE:\s-33\s0\&
BODY:\s-33,4L\s0\& BQ:\s-33\s0\& CAPTION:\s-33\s0\& CITE:\s-33\s0\&
CODE:\s-33\s0\& CREDIT:\s-33\s0\& DD:\s-33\s0\& DEL:\s-33\s0\&
DFN:\s-33\s0\& DIV:\s-33\s0\& DT:\s-33\s0\& EM:\s-33\s0\& FIG:\s-33\s0\&
FORM:\s-33\s0\& H1:\s-33\s0\& H2:\s-33\s0\& H3:\s-33\s0\& H4:\s-33\s0\&
H5:\s-33\s0\& H6:\s-33\s0\& I:\s-33\s0\& INS:\s-33\s0\& KBD:\s-33\s0\&
LANG:\s-33\s0\& LH:\s-33\s0\& LI:\s-33\s0\& NOTE:\s-33\s0\& P:\s-33\s0\&
PERSON:\s-33\s0\& PRE:\s-33\s0\& Q:\s-33\s0\& S:\s-33\s0\&
SAMP:\s-33\s0\& SMALL:\s-33\s0\& STRONG:\s-33\s0\& SUB:\s-33\s0\&
SUP:\s-33\s0\& TD:\s-33\s0\& TH:\s-33\s0\& TT:\s-33\s0\& U:\s-33\s0\&
VAR:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33,4L\s0\& A:\s-33,4L\s0\& ABBR:\s-34L\s0\& ABBREV:\s-33\s0\&
ACRONYM:\s-33\s0\& ADDRESS:\s-34L\s0\& APPLET:\s-34L\s0\& AU:\s-33\s0\&
B:\s-33,4L\s0\& BASEFONT:\s-34L\s0\& BDO:\s-34L\s0\& BIG:\s-33,4L\s0\&
BLOCKQUOTE:\s-34L\s0\& BR:\s-33,4L\s0\& BUTTON:\s-34L\s0\&
CENTER:\s-34L\s0\& CITE:\s-33,4L\s0\& CODE:\s-33,4L\s0\& DEL:\s-33\s0\&
DFN:\s-33,4L\s0\& DIR:\s-34L\s0\& DIV:\s-34L\s0\& DL:\s-34L\s0\&
EM:\s-33,4L\s0\& FIELDSET:\s-34L\s0\& FONT:\s-34L\s0\& FORM:\s-34L\s0\&
H1:\s-34L\s0\& H2:\s-34L\s0\& H3:\s-34L\s0\& H4:\s-34L\s0\&
H5:\s-34L\s0\& H6:\s-34L\s0\& HR:\s-34L\s0\& I:\s-33,4L\s0\&
IFRAME:\s-34L\s0\& IMG:\s-33,4L\s0\& INPUT:\s-34L\s0\& INS:\s-33\s0\&
ISINDEX:\s-34L\s0\& KBD:\s-33,4L\s0\& LABEL:\s-34L\s0\& LANG:\s-33\s0\&
MAP:\s-34L\s0\& MATH:\s-33\s0\& MENU:\s-34L\s0\& NOFRAMES:\s-34L\s0\&
NOSCRIPT:\s-34L\s0\& OBJECT:\s-34L\s0\& OL:\s-34L\s0\& P:\s-34L\s0\&
PERSON:\s-33\s0\& PRE:\s-34L\s0\& Q:\s-33,4L\s0\& S:\s-33,4L\s0\&
SAMP:\s-33,4L\s0\& SCRIPT:\s-34L\s0\& SELECT:\s-34L\s0\&
SMALL:\s-33,4L\s0\& SPAN:\s-34L\s0\& STRIKE:\s-34L\s0\&
STRONG:\s-33,4L\s0\& SUB:\s-33,4L\s0\& SUP:\s-33,4L\s0\& TAB:\s-33\s0\&
TABLE:\s-34L\s0\& TEXTAREA:\s-34L\s0\& TT:\s-33,4L\s0\& U:\s-33,4L\s0\&
UL:\s-34L\s0\& VAR:\s-33,4L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<DFN>" " \s-3required:3,3.2,4C,4L\s0\&" " .\|.\|. </DFN>" " \s-3required:3,3.2,4C,4L\s0\&"
.\"
.RS
.I "contained in:"
A:\s-33,3.2,4C,4L\s0\& ABBR:\s-34L\s0\& ABBREV:\s-33\s0\&
ACRONYM:\s-33\s0\& ADDRESS:\s-33,3.2,4C,4L\s0\& APPLET:\s-33.2,4L\s0\&
AU:\s-33\s0\& B:\s-33,3.2,4C,4L\s0\& BDO:\s-34C,4L\s0\&
BIG:\s-33,3.2,4C,4L\s0\& BLOCKQUOTE:\s-33,3.2,4C,4L\s0\&
BODY:\s-33,3.2,4C,4L\s0\& BQ:\s-33\s0\& BUTTON:\s-34L\s0\&
CAPTION:\s-33,3.2,4C,4L\s0\& CENTER:\s-33.2,4C,4L\s0\&
CITE:\s-33,3.2,4C,4L\s0\& CODE:\s-33,3.2,4C,4L\s0\& CREDIT:\s-33\s0\&
DD:\s-33,3.2,4C,4L\s0\& DEL:\s-33,4L\s0\& DFN:\s-33,3.2,4C,4L\s0\&
DIV:\s-33,3.2,4C,4L\s0\& DT:\s-33,3.2,4C,4L\s0\& EM:\s-33,3.2,4C,4L\s0\&
FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\& FONT:\s-33.2,4C,4L\s0\&
FORM:\s-33,3.2,4C,4L\s0\& H1:\s-33,3.2,4C,4L\s0\&
H2:\s-33,3.2,4C,4L\s0\& H3:\s-33,3.2,4C,4L\s0\& H4:\s-33,3.2,4C,4L\s0\&
H5:\s-33,3.2,4C,4L\s0\& H6:\s-33,3.2,4C,4L\s0\& I:\s-33,3.2,4C,4L\s0\&
IFRAME:\s-34L\s0\& INS:\s-33,4L\s0\& KBD:\s-33,3.2,4C,4L\s0\&
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& LEGEND:\s-34L\s0\& LH:\s-33\s0\&
LI:\s-33,3.2,4C,4L\s0\& NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& P:\s-33,3.2,4C,4L\s0\& PERSON:\s-33\s0\&
PRE:\s-33,3.2,4C,4L\s0\& Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\&
SAMP:\s-33,3.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG:\s-33,3.2,4C,4L\s0\&
SUB:\s-33,3.2,4C,4L\s0\& SUP:\s-33,3.2,4C,4L\s0\&
TD:\s-33,3.2,4C,4L\s0\& TEXTFLOW:\s-34C\s0\& TH:\s-33,3.2,4C,4L\s0\&
TT:\s-33,3.2,4C,4L\s0\& U:\s-33,3.2,4C,4L\s0\& VAR:\s-33,3.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33,3.2,4C,4L\s0\& A:\s-33,3.2,4C,4L\s0\& ABBR:\s-34L\s0\&
ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& APPLET:\s-33.2,4C,4L\s0\&
AU:\s-33\s0\& B:\s-33,3.2,4C,4L\s0\& BASEFONT:\s-33.2,4C,4L\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\& BR:\s-33,3.2,4C,4L\s0\&
BUTTON:\s-34L\s0\& CITE:\s-33,3.2,4C,4L\s0\& CODE:\s-33,3.2,4C,4L\s0\&
DEL:\s-33\s0\& DFN:\s-33,3.2,4C,4L\s0\& EM:\s-33,3.2,4C,4L\s0\&
FONT:\s-33.2,4C,4L\s0\& I:\s-33,3.2,4C,4L\s0\& IFRAME:\s-34L\s0\&
IMG:\s-33,3.2,4C,4L\s0\& INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\&
KBD:\s-33,3.2,4C,4L\s0\& LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\&
MAP:\s-33.2,4C,4L\s0\& MATH:\s-33\s0\& OBJECT:\s-34C,4L\s0\&
PERSON:\s-33\s0\& Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\&
SAMP:\s-33,3.2,4C,4L\s0\& SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG:\s-33,3.2,4C,4L\s0\& STYLE:\s-34C\s0\&
SUB:\s-33,3.2,4C,4L\s0\& SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\&
TEXTAREA:\s-33.2,4C,4L\s0\& TT:\s-33,3.2,4C,4L\s0\&
U:\s-33,3.2,4C,4L\s0\& VAR:\s-33,3.2,4C,4L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<DIR>" "\&" " .\|.\|. </DIR>" "\&" " (deprecated)"
.\"
.RS
.I "contained in:"
APPLET:\s-34L\s0\& BLOCKQUOTE BODY BQ:\s-33\s0\& BUTTON:\s-34L\s0\&
CENTER:\s-33.2,4C,4L,M\s0\& DD DEL:\s-34L\s0\& DIV:\s-33,3.2,4C,4L\s0\&
FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\& FORM IFRAME:\s-34L\s0\&
INS:\s-34L\s0\& LI NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& TD:\s-33,3.2,4C,4L\s0\& TH:\s-33,3.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
LI
.RE
.\"
.RS
.I "cannot contain:"
ADDRESS:\s-34L\s0\& BLOCKQUOTE BQ:\s-33\s0\& CENTER:\s-33.2,4C,4L,M\s0\&
DIR DIV:\s-33.2,4C,4L\s0\& DL FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\&
FORM H1:\s-34L\s0\& H2:\s-34L\s0\& H3:\s-34L\s0\& H4:\s-34L\s0\&
H5:\s-34L\s0\& H6:\s-34L\s0\& HR:\s-33.2,4C,4L\s0\& ISINDEX
LISTING:\s-32,3,3.2,4C,M\s0\& MENU NOFRAMES:\s-34L\s0\&
NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\& OL P PRE TABLE:\s-33,3.2,4C,4L\s0\&
UL XMP:\s-32,3,3.2,4C,M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<DIV>" " \s-3required:3,3.2,4C,4L\s0\&" " .\|.\|. </DIV>" " \s-3required:3,3.2,4C,4L\s0\&"
.\"
.RS
.I "contained in:"
APPLET:\s-34L\s0\& BLOCKQUOTE:\s-33,3.2,4C,4L\s0\&
BODY:\s-33,3.2,4C,4L\s0\& BQ:\s-33\s0\& BUTTON:\s-34L\s0\&
CENTER:\s-33.2,4C,4L\s0\& DD:\s-33.2,4C,4L\s0\& DEL:\s-34L\s0\&
DIV:\s-33,3.2,4C,4L\s0\& FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\&
FORM:\s-33,3.2,4C,4L\s0\& IFRAME:\s-34L\s0\& INS:\s-34L\s0\&
LI:\s-33.2,4C,4L\s0\& NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& TD:\s-33,3.2,4C,4L\s0\& TH:\s-33,3.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33,3.2,4C,4L\s0\& A:\s-33,3.2,4C,4L\s0\& ABBR:\s-34L\s0\&
ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& ADDRESS:\s-33,3.2,4C,4L\s0\&
APPLET:\s-33.2,4C,4L\s0\& AU:\s-33\s0\& B:\s-33,3.2,4C,4L\s0\&
BASEFONT:\s-33.2,4C,4L\s0\& BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\&
BLOCKQUOTE:\s-33,3.2,4C,4L\s0\& BQ:\s-33\s0\& BR:\s-33,3.2,4C,4L\s0\&
BUTTON:\s-34L\s0\& CENTER:\s-33.2,4C,4L\s0\& CITE:\s-33,3.2,4C,4L\s0\&
CODE:\s-33,3.2,4C,4L\s0\& DEL:\s-33\s0\& DFN:\s-33,3.2,4C,4L\s0\&
DIR:\s-33,3.2,4C,4L\s0\& DIV:\s-33,3.2,4C,4L\s0\&
DL:\s-33,3.2,4C,4L\s0\& EM:\s-33,3.2,4C,4L\s0\& FIELDSET:\s-34C,4L\s0\&
FIG:\s-33\s0\& FONT:\s-33.2,4C,4L\s0\& FORM:\s-33,3.2,4C,4L\s0\&
H1:\s-33,3.2,4C,4L\s0\& H2:\s-33,3.2,4C,4L\s0\& H3:\s-33,3.2,4C,4L\s0\&
H4:\s-33,3.2,4C,4L\s0\& H5:\s-33,3.2,4C,4L\s0\& H6:\s-33,3.2,4C,4L\s0\&
HR:\s-33,3.2,4C,4L\s0\& I:\s-33,3.2,4C,4L\s0\& IFRAME:\s-34L\s0\&
IMG:\s-33,3.2,4C,4L\s0\& INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\&
ISINDEX:\s-33,3.2,4C,4L\s0\& KBD:\s-33,3.2,4C,4L\s0\&
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& LISTING:\s-33,3.2,4C\s0\&
MAP:\s-33.2,4C,4L\s0\& MATH:\s-33\s0\& MENU:\s-33,3.2,4C,4L\s0\&
NOFRAMES:\s-34L\s0\& NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& OL:\s-33,3.2,4C,4L\s0\& P:\s-33,3.2,4C,4L\s0\&
PERSON:\s-33\s0\& PRE:\s-33,3.2,4C,4L\s0\& Q:\s-33,4C,4L\s0\&
S:\s-33,4C,4L\s0\& SAMP:\s-33,3.2,4C,4L\s0\& SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG:\s-33,3.2,4C,4L\s0\& STYLE:\s-34C\s0\&
SUB:\s-33,3.2,4C,4L\s0\& SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\&
TABLE:\s-33,3.2,4C,4L\s0\& TEXTAREA:\s-33.2,4C,4L\s0\&
TT:\s-33,3.2,4C,4L\s0\& U:\s-33,3.2,4C,4L\s0\& UL:\s-33,3.2,4C,4L\s0\&
VAR:\s-33,3.2,4C,4L\s0\& XMP:\s-33,3.2,4C\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<DL>" "\&" " .\|.\|. </DL>" "\&"
.\"
.RS
.I "contained in:"
APPLET:\s-34L\s0\& BLOCKQUOTE BODY BQ:\s-33\s0\& BUTTON:\s-34L\s0\&
CENTER:\s-33.2,4C,4L,M\s0\& DD DEL:\s-34L\s0\& DIV:\s-33,3.2,4C,4L\s0\&
FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\& FORM IFRAME:\s-34L\s0\&
INS:\s-34L\s0\& LI NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& TD:\s-33,3.2,4C,4L\s0\& TH:\s-33,3.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
DD DT LH:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<DOT>" " \s-3required:3\s0\&" " .\|.\|. </DOT>" " \s-3required:3\s0\&"
.\"
.RS
.I "contained in:"
ABOVE:\s-33\s0\& BAR:\s-33\s0\& BELOW:\s-33\s0\& BOX:\s-33\s0\&
BT:\s-33\s0\& DDOT:\s-33\s0\& DOT:\s-33\s0\& HAT:\s-33\s0\&
ITEM:\s-33\s0\& MATH:\s-33\s0\& OF:\s-33\s0\& ROOT:\s-33\s0\&
SQRT:\s-33\s0\& T:\s-33\s0\& TILDE:\s-33\s0\& VEC:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33\s0\& ABOVE:\s-33\s0\& ARRAY:\s-33\s0\& B:\s-33\s0\&
BAR:\s-33\s0\& BELOW:\s-33\s0\& BOX:\s-33\s0\& BT:\s-33\s0\&
DDOT:\s-33\s0\& DOT:\s-33\s0\& HAT:\s-33\s0\& ROOT:\s-33\s0\&
SQRT:\s-33\s0\& SUB:\s-33\s0\& SUP:\s-33\s0\& T:\s-33\s0\&
TILDE:\s-33\s0\& VEC:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<DT>" "\&" " .\|.\|. </DT>" " \s-3optional\s0\&"
.\"
.RS
.I "contained in:"
DL
.RE
.\"
.RS
.I "contains:"
#PCDATA A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
APPLET:\s-33.2,4C,4L\s0\& AU:\s-33\s0\& B BASEFONT:\s-33.2,4C,4L,M\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BR
BUTTON:\s-34L\s0\& CENTER:\s-3M\s0\& CITE CODE DEL:\s-33\s0\&
DFN:\s-33,3.2,4C,4L\s0\& EM FONT:\s-33.2,4C,4L,M\s0\& I
IFRAME:\s-34L\s0\& IMG INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\& KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& MAP:\s-33.2,4C,4L\s0\&
MATH:\s-33\s0\& NOBR:\s-3M\s0\& OBJECT:\s-34C,4L\s0\& PERSON:\s-33\s0\&
Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\& SAMP SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG STYLE:\s-34C\s0\& SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\& TEXTAREA:\s-33.2,4C,4L\s0\& TT
U:\s-33,3.2,4C,4L\s0\& VAR WBR:\s-3M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<EM>" "\&" " .\|.\|. </EM>" "\&"
.\"
.RS
.I "contained in:"
A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& ADDRESS
APPLET:\s-33.2,4L\s0\& AU:\s-33\s0\& B BDO:\s-34C,4L\s0\&
BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BLOCKQUOTE BODY BQ:\s-33\s0\&
BUTTON:\s-34L\s0\& CAPTION:\s-33,3.2,4C,4L\s0\&
CENTER:\s-33.2,4C,4L,M\s0\& CITE CODE CREDIT:\s-33\s0\& DD
DEL:\s-33,4L\s0\& DFN:\s-33,3.2,4C,4L\s0\& DIV:\s-33,3.2,4C,4L\s0\& DT
EM FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\& FONT:\s-33.2,4C,4L,M\s0\& FORM
H1 H2 H3 H4 H5 H6 I IFRAME:\s-34L\s0\& INS:\s-33,4L\s0\& KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& LEGEND:\s-34L\s0\& LH:\s-33\s0\& LI
NOBR:\s-3M\s0\& NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& P PERSON:\s-33\s0\& PRE Q:\s-33,4C,4L\s0\&
S:\s-33,4C,4L\s0\& SAMP SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TD:\s-33,3.2,4C,4L\s0\& TEXTFLOW:\s-34C\s0\&
TH:\s-33,3.2,4C,4L\s0\& TT U:\s-33,3.2,4C,4L\s0\& VAR
.RE
.\"
.RS
.I "contains:"
#PCDATA A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
APPLET:\s-33.2,4C,4L\s0\& AU:\s-33\s0\& B BASEFONT:\s-33.2,4C,4L,M\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BR
BUTTON:\s-34L\s0\& CENTER:\s-3M\s0\& CITE CODE DEL:\s-33\s0\&
DFN:\s-33,3.2,4C,4L\s0\& EM FONT:\s-33.2,4C,4L,M\s0\& I
IFRAME:\s-34L\s0\& IMG INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\& KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& MAP:\s-33.2,4C,4L\s0\&
MATH:\s-33\s0\& NOBR:\s-3M\s0\& OBJECT:\s-34C,4L\s0\& PERSON:\s-33\s0\&
Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\& SAMP SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG STYLE:\s-34C\s0\& SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\& TEXTAREA:\s-33.2,4C,4L\s0\& TT
U:\s-33,3.2,4C,4L\s0\& VAR WBR:\s-3M\s0\&
.RE
.\"---------------------------------------------------------------------
.B EMPTY
.\"
.RS
.I "contained in:"
AREA:\s-33.2,4C,4L\s0\& ATOP:\s-33\s0\& BASE BASEFONT:\s-33.2,4C,4L\s0\&
BR CHOOSE:\s-33\s0\& COL:\s-34C,4L\s0\& FRAME:\s-34L\s0\& HR IMG INPUT
ISINDEX LEFT:\s-33\s0\& LINK META NEXTID:\s-32,3,M\s0\& OVER:\s-33\s0\&
OVERLAY:\s-33\s0\& PARAM:\s-33.2,4C,4L\s0\& RIGHT:\s-33\s0\&
TAB:\s-33\s0\& WBR:\s-3M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<FIELDSET>" " \s-3required:4C,4L\s0\&" " .\|.\|. </FIELDSET>" " \s-3required:4C,4L\s0\&"
.\"
.RS
.I "contained in:"
APPLET:\s-34L\s0\& BLOCKQUOTE:\s-34C,4L\s0\& BODY:\s-34C,4L\s0\&
CENTER:\s-34C,4L\s0\& DD:\s-34C,4L\s0\& DEL:\s-34L\s0\&
DIV:\s-34C,4L\s0\& FIELDSET:\s-34C,4L\s0\& FORM:\s-34C,4L\s0\&
IFRAME:\s-34L\s0\& INS:\s-34L\s0\& LI:\s-34C,4L\s0\&
NOSCRIPT:\s-34L\s0\& OBJECT:\s-34C,4L\s0\& TD:\s-34C,4L\s0\&
TH:\s-34C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-34C,4L\s0\& A:\s-34C,4L\s0\& ABBR:\s-34L\s0\&
ADDRESS:\s-34C,4L\s0\& APPLET:\s-34C,4L\s0\& B:\s-34C,4L\s0\&
BASEFONT:\s-34C,4L\s0\& BDO:\s-34C,4L\s0\& BIG:\s-34C,4L\s0\&
BLOCKQUOTE:\s-34C,4L\s0\& BR:\s-34C,4L\s0\& BUTTON:\s-34L\s0\&
CAPTION:\s-34C\s0\& CENTER:\s-34C,4L\s0\& CITE:\s-34C,4L\s0\&
CODE:\s-34C,4L\s0\& DFN:\s-34C,4L\s0\& DIR:\s-34C,4L\s0\&
DIV:\s-34C,4L\s0\& DL:\s-34C,4L\s0\& EM:\s-34C,4L\s0\&
FIELDSET:\s-34C,4L\s0\& FONT:\s-34C,4L\s0\& FORM:\s-34C,4L\s0\&
H1:\s-34C,4L\s0\& H2:\s-34C,4L\s0\& H3:\s-34C,4L\s0\& H4:\s-34C,4L\s0\&
H5:\s-34C,4L\s0\& H6:\s-34C,4L\s0\& HR:\s-34C,4L\s0\& I:\s-34C,4L\s0\&
IFRAME:\s-34L\s0\& IMG:\s-34C,4L\s0\& INPUT:\s-34C,4L\s0\&
ISINDEX:\s-34C,4L\s0\& KBD:\s-34C,4L\s0\& LABEL:\s-34C,4L\s0\&
LEGEND:\s-34L\s0\& LISTING:\s-34C\s0\& MAP:\s-34C,4L\s0\&
MENU:\s-34C,4L\s0\& NOFRAMES:\s-34L\s0\& NOSCRIPT:\s-34L\s0\&
OBJECT:\s-34C,4L\s0\& OL:\s-34C,4L\s0\& P:\s-34C,4L\s0\&
PRE:\s-34C,4L\s0\& Q:\s-34C,4L\s0\& S:\s-34C,4L\s0\& SAMP:\s-34C,4L\s0\&
SCRIPT:\s-34C,4L\s0\& SELECT:\s-34C,4L\s0\& SMALL:\s-34C,4L\s0\&
SPAN:\s-34C,4L\s0\& STRIKE:\s-34L\s0\& STRONG:\s-34C,4L\s0\&
STYLE:\s-34C\s0\& SUB:\s-34C,4L\s0\& SUP:\s-34C,4L\s0\&
TABLE:\s-34C,4L\s0\& TEXTAREA:\s-34C,4L\s0\& TT:\s-34C,4L\s0\&
U:\s-34C,4L\s0\& UL:\s-34C,4L\s0\& VAR:\s-34C,4L\s0\& XMP:\s-34C\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<FIG>" " \s-3required:3\s0\&" " .\|.\|. </FIG>" " \s-3required:3\s0\&"
.\"
.RS
.I "contained in:"
BLOCKQUOTE:\s-33\s0\& BODY:\s-33\s0\& BQ:\s-33\s0\& DD:\s-33\s0\&
DIV:\s-33\s0\& FORM:\s-33\s0\& LI:\s-33\s0\& NOTE:\s-33\s0\&
TD:\s-33\s0\& TH:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33\s0\& A:\s-33\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
ADDRESS:\s-33\s0\& AU:\s-33\s0\& B:\s-33\s0\& BIG:\s-33\s0\&
BLOCKQUOTE:\s-33\s0\& BQ:\s-33\s0\& BR:\s-33\s0\& CAPTION:\s-33\s0\&
CITE:\s-33\s0\& CODE:\s-33\s0\& CREDIT:\s-33\s0\& DEL:\s-33\s0\&
DFN:\s-33\s0\& DIR:\s-33\s0\& DIV:\s-33\s0\& DL:\s-33\s0\& EM:\s-33\s0\&
FORM:\s-33\s0\& H1:\s-33\s0\& H2:\s-33\s0\& H3:\s-33\s0\& H4:\s-33\s0\&
H5:\s-33\s0\& H6:\s-33\s0\& HR:\s-33\s0\& I:\s-33\s0\& INS:\s-33\s0\&
ISINDEX:\s-33\s0\& KBD:\s-33\s0\& LANG:\s-33\s0\& LISTING:\s-33\s0\&
MATH:\s-33\s0\& MENU:\s-33\s0\& NOTE:\s-33\s0\& OL:\s-33\s0\&
OVERLAY:\s-33\s0\& P:\s-33\s0\& PERSON:\s-33\s0\& PRE:\s-33\s0\&
Q:\s-33\s0\& S:\s-33\s0\& SAMP:\s-33\s0\& SMALL:\s-33\s0\&
STRONG:\s-33\s0\& SUB:\s-33\s0\& SUP:\s-33\s0\& TAB:\s-33\s0\&
TABLE:\s-33\s0\& TT:\s-33\s0\& U:\s-33\s0\& UL:\s-33\s0\& VAR:\s-33\s0\&
XMP:\s-33\s0\&
.RE
.\"
.RS
.I "cannot contain:"
FIG:\s-33\s0\& IMG:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<FONT>" " \s-3required:3.2,4C,4L,M\s0\&" " .\|.\|. </FONT>" " \s-3required:3.2,4C,4L,M\s0\&"
.\"
.RS
.I "contained in:"
A:\s-33.2,4C,4L,M\s0\& ABBR:\s-34L\s0\& ADDRESS:\s-33.2,4C,4L,M\s0\&
APPLET:\s-33.2,4L\s0\& B:\s-33.2,4C,4L,M\s0\& BDO:\s-34C,4L\s0\&
BIG:\s-33.2,4C,4L\s0\& BLINK:\s-3M\s0\& BLOCKQUOTE:\s-33.2,4C,4L,M\s0\&
BODY:\s-33.2,4C,4L,M\s0\& BUTTON:\s-34L\s0\& CAPTION:\s-33.2,4C,4L\s0\&
CENTER:\s-33.2,4C,4L,M\s0\& CITE:\s-33.2,4C,4L,M\s0\&
CODE:\s-33.2,4C,4L,M\s0\& DD:\s-33.2,4C,4L,M\s0\& DEL:\s-34L\s0\&
DFN:\s-33.2,4C,4L\s0\& DIV:\s-33.2,4C,4L\s0\& DT:\s-33.2,4C,4L,M\s0\&
EM:\s-33.2,4C,4L,M\s0\& FIELDSET:\s-34C,4L\s0\&
FONT:\s-33.2,4C,4L,M\s0\& FORM:\s-33.2,4C,4L,M\s0\&
H1:\s-33.2,4C,4L,M\s0\& H2:\s-33.2,4C,4L,M\s0\& H3:\s-33.2,4C,4L,M\s0\&
H4:\s-33.2,4C,4L,M\s0\& H5:\s-33.2,4C,4L,M\s0\& H6:\s-33.2,4C,4L,M\s0\&
I:\s-33.2,4C,4L,M\s0\& IFRAME:\s-34L\s0\& INS:\s-34L\s0\&
KBD:\s-33.2,4C,4L,M\s0\& LABEL:\s-34C,4L\s0\& LEGEND:\s-34L\s0\&
LI:\s-33.2,4C,4L,M\s0\& NOBR:\s-3M\s0\& NOSCRIPT:\s-34L\s0\&
OBJECT:\s-34C,4L\s0\& P:\s-33.2,4C,4L,M\s0\& PRE:\s-3M\s0\&
Q:\s-34C,4L\s0\& S:\s-34C,4L\s0\& SAMP:\s-33.2,4C,4L,M\s0\&
SMALL:\s-33.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\& STRIKE:\s-33.2,4L\s0\&
STRONG:\s-33.2,4C,4L,M\s0\& SUB:\s-33.2,4C,4L\s0\&
SUP:\s-33.2,4C,4L\s0\& TD:\s-33.2,4C,4L\s0\& TEXTFLOW:\s-34C\s0\&
TH:\s-33.2,4C,4L\s0\& TT:\s-33.2,4C,4L,M\s0\& U:\s-33.2,4C,4L\s0\&
VAR:\s-33.2,4C,4L,M\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33.2,4C,4L,M\s0\& A:\s-33.2,4C,4L,M\s0\& ABBR:\s-34L\s0\&
APPLET:\s-33.2,4C,4L\s0\& B:\s-33.2,4C,4L,M\s0\&
BASEFONT:\s-33.2,4C,4L,M\s0\& BDO:\s-34C,4L\s0\& BIG:\s-33.2,4C,4L\s0\&
BLINK:\s-3M\s0\& BR:\s-33.2,4C,4L,M\s0\& BUTTON:\s-34L\s0\&
CENTER:\s-3M\s0\& CITE:\s-33.2,4C,4L,M\s0\& CODE:\s-33.2,4C,4L,M\s0\&
DFN:\s-33.2,4C,4L\s0\& EM:\s-33.2,4C,4L,M\s0\& FONT:\s-33.2,4C,4L,M\s0\&
I:\s-33.2,4C,4L,M\s0\& IFRAME:\s-34L\s0\& IMG:\s-33.2,4C,4L,M\s0\&
INPUT:\s-33.2,4C,4L\s0\& KBD:\s-33.2,4C,4L,M\s0\& LABEL:\s-34C,4L\s0\&
MAP:\s-33.2,4C,4L\s0\& NOBR:\s-3M\s0\& OBJECT:\s-34C,4L\s0\&
Q:\s-34C,4L\s0\& S:\s-34C,4L\s0\& SAMP:\s-33.2,4C,4L,M\s0\&
SCRIPT:\s-33.2,4C,4L\s0\& SELECT:\s-33.2,4C,4L\s0\&
SMALL:\s-33.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\& STRIKE:\s-33.2,4L\s0\&
STRONG:\s-33.2,4C,4L,M\s0\& STYLE:\s-34C\s0\& SUB:\s-33.2,4C,4L\s0\&
SUP:\s-33.2,4C,4L\s0\& TEXTAREA:\s-33.2,4C,4L\s0\&
TT:\s-33.2,4C,4L,M\s0\& U:\s-33.2,4C,4L\s0\& VAR:\s-33.2,4C,4L,M\s0\&
WBR:\s-3M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<FORM>" "\&" " .\|.\|. </FORM>" "\&"
.\"
.RS
.I "contained in:"
APPLET:\s-34L\s0\& BLOCKQUOTE BODY BQ:\s-33\s0\&
CENTER:\s-33.2,4C,4L,M\s0\& DD DEL:\s-34L\s0\& DIV:\s-33,3.2,4C,4L\s0\&
FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\& IFRAME:\s-34L\s0\&
INS:\s-34L\s0\& LI NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& TD:\s-33,3.2,4C,4L\s0\& TH:\s-33,3.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& ADDRESS
APPLET:\s-33.2,4C,4L\s0\& AU:\s-33\s0\& B BASEFONT:\s-33.2,4C,4L,M\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BLOCKQUOTE
BQ:\s-33\s0\& BR BUTTON:\s-34L\s0\& CENTER:\s-33.2,4C,4L,M\s0\& CITE
CODE DEL:\s-33\s0\& DFN:\s-33,3.2,4C,4L\s0\& DIR
DIV:\s-33,3.2,4C,4L\s0\& DL EM FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\&
FONT:\s-33.2,4C,4L,M\s0\& H1 H2 H3 H4 H5 H6 HR I IFRAME:\s-34L\s0\& IMG
INPUT INS:\s-33\s0\& ISINDEX KBD LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\&
LISTING:\s-32,3,3.2,4C,M\s0\& MAP:\s-33.2,4C,4L\s0\& MATH:\s-33\s0\&
MENU NOBR:\s-3M\s0\& NOFRAMES:\s-34L\s0\& NOSCRIPT:\s-34L\s0\&
NOTE:\s-33\s0\& OBJECT:\s-34C,4L\s0\& OL P PERSON:\s-33\s0\& PRE
Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\& SAMP SCRIPT:\s-33.2,4C,4L\s0\&
SELECT SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG STYLE:\s-34C\s0\& SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\& TABLE:\s-33,3.2,4C,4L\s0\&
TEXTAREA TT U:\s-33,3.2,4C,4L\s0\& UL VAR WBR:\s-3M\s0\&
XMP:\s-32,3,3.2,4C,M\s0\&
.RE
.\"
.RS
.I "cannot contain:"
FORM
.RE
.\"---------------------------------------------------------------------
.BR "<FRAME>" " \s-3required:4L\s0\&"
.\"
.RS
.I "contained in:"
FRAMESET:\s-34L\s0\&
.RE
.\"
.RS
.I "contains:"
EMPTY:\s-34L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<FRAMESET>" " \s-3required:4L\s0\&" " .\|.\|. </FRAMESET>" " \s-3required:4L\s0\&"
.\"
.RS
.I "contained in:"
FRAMESET:\s-34L\s0\& HTML:\s-34L\s0\&
.RE
.\"
.RS
.I "contains:"
FRAME:\s-34L\s0\& FRAMESET:\s-34L\s0\& NOFRAMES:\s-34L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<H1>" "\&" " .\|.\|. </H1>" "\&"
.\"
.RS
.I "contained in:"
A:\s-32,3,M\s0\& APPLET:\s-34L\s0\& BLOCKQUOTE BODY BQ:\s-33\s0\&
BUTTON:\s-34L\s0\& CENTER:\s-33.2,4C,4L,M\s0\& DD:\s-34L\s0\&
DEL:\s-34L\s0\& DIV:\s-33,3.2,4C,4L\s0\& FIELDSET:\s-34C,4L\s0\&
FIG:\s-33\s0\& FORM IFRAME:\s-34L\s0\& INS:\s-34L\s0\& LI:\s-34L\s0\&
NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\& OBJECT:\s-34C,4L\s0\&
TD:\s-33,3.2,4C,4L\s0\& TH:\s-33,3.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
APPLET:\s-33.2,4C,4L\s0\& AU:\s-33\s0\& B BASEFONT:\s-33.2,4C,4L,M\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BR
BUTTON:\s-34L\s0\& CENTER:\s-3M\s0\& CITE CODE DEL:\s-33\s0\&
DFN:\s-33,3.2,4C,4L\s0\& EM FONT:\s-33.2,4C,4L,M\s0\& I
IFRAME:\s-34L\s0\& IMG INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\& KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& MAP:\s-33.2,4C,4L\s0\&
MATH:\s-33\s0\& NOBR:\s-3M\s0\& OBJECT:\s-34C,4L\s0\& PERSON:\s-33\s0\&
Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\& SAMP SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG STYLE:\s-34C\s0\& SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\& TEXTAREA:\s-33.2,4C,4L\s0\& TT
U:\s-33,3.2,4C,4L\s0\& VAR WBR:\s-3M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<H2>" "\&" " .\|.\|. </H2>" "\&"
.\"
.RS
.I "contained in:"
A:\s-32,3,M\s0\& APPLET:\s-34L\s0\& BLOCKQUOTE BODY BQ:\s-33\s0\&
BUTTON:\s-34L\s0\& CENTER:\s-33.2,4C,4L,M\s0\& DD:\s-34L\s0\&
DEL:\s-34L\s0\& DIV:\s-33,3.2,4C,4L\s0\& FIELDSET:\s-34C,4L\s0\&
FIG:\s-33\s0\& FORM IFRAME:\s-34L\s0\& INS:\s-34L\s0\& LI:\s-34L\s0\&
NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\& OBJECT:\s-34C,4L\s0\&
TD:\s-33,3.2,4C,4L\s0\& TH:\s-33,3.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
APPLET:\s-33.2,4C,4L\s0\& AU:\s-33\s0\& B BASEFONT:\s-33.2,4C,4L,M\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BR
BUTTON:\s-34L\s0\& CENTER:\s-3M\s0\& CITE CODE DEL:\s-33\s0\&
DFN:\s-33,3.2,4C,4L\s0\& EM FONT:\s-33.2,4C,4L,M\s0\& I
IFRAME:\s-34L\s0\& IMG INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\& KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& MAP:\s-33.2,4C,4L\s0\&
MATH:\s-33\s0\& NOBR:\s-3M\s0\& OBJECT:\s-34C,4L\s0\& PERSON:\s-33\s0\&
Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\& SAMP SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG STYLE:\s-34C\s0\& SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\& TEXTAREA:\s-33.2,4C,4L\s0\& TT
U:\s-33,3.2,4C,4L\s0\& VAR WBR:\s-3M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<H3>" "\&" " .\|.\|. </H3>" "\&"
.\"
.RS
.I "contained in:"
A:\s-32,3,M\s0\& APPLET:\s-34L\s0\& BLOCKQUOTE BODY BQ:\s-33\s0\&
BUTTON:\s-34L\s0\& CENTER:\s-33.2,4C,4L,M\s0\& DD:\s-34L\s0\&
DEL:\s-34L\s0\& DIV:\s-33,3.2,4C,4L\s0\& FIELDSET:\s-34C,4L\s0\&
FIG:\s-33\s0\& FORM IFRAME:\s-34L\s0\& INS:\s-34L\s0\& LI:\s-34L\s0\&
NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\& OBJECT:\s-34C,4L\s0\&
TD:\s-33,3.2,4C,4L\s0\& TH:\s-33,3.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
APPLET:\s-33.2,4C,4L\s0\& AU:\s-33\s0\& B BASEFONT:\s-33.2,4C,4L,M\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BR
BUTTON:\s-34L\s0\& CENTER:\s-3M\s0\& CITE CODE DEL:\s-33\s0\&
DFN:\s-33,3.2,4C,4L\s0\& EM FONT:\s-33.2,4C,4L,M\s0\& I
IFRAME:\s-34L\s0\& IMG INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\& KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& MAP:\s-33.2,4C,4L\s0\&
MATH:\s-33\s0\& NOBR:\s-3M\s0\& OBJECT:\s-34C,4L\s0\& PERSON:\s-33\s0\&
Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\& SAMP SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG STYLE:\s-34C\s0\& SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\& TEXTAREA:\s-33.2,4C,4L\s0\& TT
U:\s-33,3.2,4C,4L\s0\& VAR WBR:\s-3M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<H4>" "\&" " .\|.\|. </H4>" "\&"
.\"
.RS
.I "contained in:"
A:\s-32,3,M\s0\& APPLET:\s-34L\s0\& BLOCKQUOTE BODY BQ:\s-33\s0\&
BUTTON:\s-34L\s0\& CENTER:\s-33.2,4C,4L,M\s0\& DD:\s-34L\s0\&
DEL:\s-34L\s0\& DIV:\s-33,3.2,4C,4L\s0\& FIELDSET:\s-34C,4L\s0\&
FIG:\s-33\s0\& FORM IFRAME:\s-34L\s0\& INS:\s-34L\s0\& LI:\s-34L\s0\&
NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\& OBJECT:\s-34C,4L\s0\&
TD:\s-33,3.2,4C,4L\s0\& TH:\s-33,3.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
APPLET:\s-33.2,4C,4L\s0\& AU:\s-33\s0\& B BASEFONT:\s-33.2,4C,4L,M\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BR
BUTTON:\s-34L\s0\& CENTER:\s-3M\s0\& CITE CODE DEL:\s-33\s0\&
DFN:\s-33,3.2,4C,4L\s0\& EM FONT:\s-33.2,4C,4L,M\s0\& I
IFRAME:\s-34L\s0\& IMG INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\& KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& MAP:\s-33.2,4C,4L\s0\&
MATH:\s-33\s0\& NOBR:\s-3M\s0\& OBJECT:\s-34C,4L\s0\& PERSON:\s-33\s0\&
Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\& SAMP SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG STYLE:\s-34C\s0\& SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\& TEXTAREA:\s-33.2,4C,4L\s0\& TT
U:\s-33,3.2,4C,4L\s0\& VAR WBR:\s-3M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<H5>" "\&" " .\|.\|. </H5>" "\&"
.\"
.RS
.I "contained in:"
A:\s-32,3,M\s0\& APPLET:\s-34L\s0\& BLOCKQUOTE BODY BQ:\s-33\s0\&
BUTTON:\s-34L\s0\& CENTER:\s-33.2,4C,4L,M\s0\& DD:\s-34L\s0\&
DEL:\s-34L\s0\& DIV:\s-33,3.2,4C,4L\s0\& FIELDSET:\s-34C,4L\s0\&
FIG:\s-33\s0\& FORM IFRAME:\s-34L\s0\& INS:\s-34L\s0\& LI:\s-34L\s0\&
NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\& OBJECT:\s-34C,4L\s0\&
TD:\s-33,3.2,4C,4L\s0\& TH:\s-33,3.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
APPLET:\s-33.2,4C,4L\s0\& AU:\s-33\s0\& B BASEFONT:\s-33.2,4C,4L,M\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BR
BUTTON:\s-34L\s0\& CENTER:\s-3M\s0\& CITE CODE DEL:\s-33\s0\&
DFN:\s-33,3.2,4C,4L\s0\& EM FONT:\s-33.2,4C,4L,M\s0\& I
IFRAME:\s-34L\s0\& IMG INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\& KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& MAP:\s-33.2,4C,4L\s0\&
MATH:\s-33\s0\& NOBR:\s-3M\s0\& OBJECT:\s-34C,4L\s0\& PERSON:\s-33\s0\&
Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\& SAMP SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG STYLE:\s-34C\s0\& SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\& TEXTAREA:\s-33.2,4C,4L\s0\& TT
U:\s-33,3.2,4C,4L\s0\& VAR WBR:\s-3M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<H6>" "\&" " .\|.\|. </H6>" "\&"
.\"
.RS
.I "contained in:"
A:\s-32,3,M\s0\& APPLET:\s-34L\s0\& BLOCKQUOTE BODY BQ:\s-33\s0\&
BUTTON:\s-34L\s0\& CENTER:\s-33.2,4C,4L,M\s0\& DD:\s-34L\s0\&
DEL:\s-34L\s0\& DIV:\s-33,3.2,4C,4L\s0\& FIELDSET:\s-34C,4L\s0\&
FIG:\s-33\s0\& FORM IFRAME:\s-34L\s0\& INS:\s-34L\s0\& LI:\s-34L\s0\&
NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\& OBJECT:\s-34C,4L\s0\&
TD:\s-33,3.2,4C,4L\s0\& TH:\s-33,3.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
APPLET:\s-33.2,4C,4L\s0\& AU:\s-33\s0\& B BASEFONT:\s-33.2,4C,4L,M\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BR
BUTTON:\s-34L\s0\& CENTER:\s-3M\s0\& CITE CODE DEL:\s-33\s0\&
DFN:\s-33,3.2,4C,4L\s0\& EM FONT:\s-33.2,4C,4L,M\s0\& I
IFRAME:\s-34L\s0\& IMG INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\& KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& MAP:\s-33.2,4C,4L\s0\&
MATH:\s-33\s0\& NOBR:\s-3M\s0\& OBJECT:\s-34C,4L\s0\& PERSON:\s-33\s0\&
Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\& SAMP SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG STYLE:\s-34C\s0\& SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\& TEXTAREA:\s-33.2,4C,4L\s0\& TT
U:\s-33,3.2,4C,4L\s0\& VAR WBR:\s-3M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<HAT>" " \s-3required:3\s0\&" " .\|.\|. </HAT>" " \s-3required:3\s0\&"
.\"
.RS
.I "contained in:"
ABOVE:\s-33\s0\& BAR:\s-33\s0\& BELOW:\s-33\s0\& BOX:\s-33\s0\&
BT:\s-33\s0\& DDOT:\s-33\s0\& DOT:\s-33\s0\& HAT:\s-33\s0\&
ITEM:\s-33\s0\& MATH:\s-33\s0\& OF:\s-33\s0\& ROOT:\s-33\s0\&
SQRT:\s-33\s0\& T:\s-33\s0\& TILDE:\s-33\s0\& VEC:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33\s0\& ABOVE:\s-33\s0\& ARRAY:\s-33\s0\& B:\s-33\s0\&
BAR:\s-33\s0\& BELOW:\s-33\s0\& BOX:\s-33\s0\& BT:\s-33\s0\&
DDOT:\s-33\s0\& DOT:\s-33\s0\& HAT:\s-33\s0\& ROOT:\s-33\s0\&
SQRT:\s-33\s0\& SUB:\s-33\s0\& SUP:\s-33\s0\& T:\s-33\s0\&
TILDE:\s-33\s0\& VEC:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<HEAD>" " \s-3optional\s0\&" " .\|.\|. </HEAD>" " \s-3optional\s0\&"
.\"
.RS
.I "contained in:"
HTML
.RE
.\"
.RS
.I "contains:"
BASE ISINDEX LINK META NEXTID:\s-32,3,M\s0\& SCRIPT:\s-33.2,4C,4L\s0\&
STYLE:\s-33,3.2,4C,4L\s0\& TITLE
.RE
.\"---------------------------------------------------------------------
.BR "<HR>" "\&"
.\"
.RS
.I "contained in:"
APPLET:\s-34L\s0\& BLOCKQUOTE BODY BQ:\s-33\s0\& BUTTON:\s-34L\s0\&
CENTER:\s-33.2,4C,4L,M\s0\& DD:\s-33.2,4C,4L\s0\& DEL:\s-34L\s0\&
DIV:\s-33,3.2,4C,4L\s0\& FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\& FORM
IFRAME:\s-34L\s0\& INS:\s-34L\s0\& LI:\s-33.2,4C,4L\s0\&
NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\& OBJECT:\s-34C,4L\s0\&
PRE:\s-32,M\s0\& TD:\s-33,3.2,4C,4L\s0\& TH:\s-33,3.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
EMPTY
.RE
.\"---------------------------------------------------------------------
.BR "<HTML>" " \s-3optional\s0\&" " .\|.\|. </HTML>" " \s-3optional\s0\&"
.\"
.RS
.I "contains:"
BODY FRAMESET:\s-34L\s0\& HEAD PLAINTEXT:\s-32,3.2,4C,M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<I>" "\&" " .\|.\|. </I>" "\&"
.\"
.RS
.I "contained in:"
A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& ADDRESS
APPLET:\s-33.2,4L\s0\& AU:\s-33\s0\& B BDO:\s-34C,4L\s0\&
BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BLOCKQUOTE BODY BQ:\s-33\s0\&
BUTTON:\s-34L\s0\& CAPTION:\s-33,3.2,4C,4L\s0\&
CENTER:\s-33.2,4C,4L,M\s0\& CITE CODE CREDIT:\s-33\s0\& DD
DEL:\s-33,4L\s0\& DFN:\s-33,3.2,4C,4L\s0\& DIV:\s-33,3.2,4C,4L\s0\& DT
EM FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\& FONT:\s-33.2,4C,4L,M\s0\& FORM
H1 H2 H3 H4 H5 H6 I IFRAME:\s-34L\s0\& INS:\s-33,4L\s0\& KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& LEGEND:\s-34L\s0\& LH:\s-33\s0\& LI
NOBR:\s-3M\s0\& NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& P PERSON:\s-33\s0\& PRE Q:\s-33,4C,4L\s0\&
S:\s-33,4C,4L\s0\& SAMP SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TD:\s-33,3.2,4C,4L\s0\& TEXTFLOW:\s-34C\s0\&
TH:\s-33,3.2,4C,4L\s0\& TT U:\s-33,3.2,4C,4L\s0\& VAR
.RE
.\"
.RS
.I "contains:"
#PCDATA A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
APPLET:\s-33.2,4C,4L\s0\& AU:\s-33\s0\& B BASEFONT:\s-33.2,4C,4L,M\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BR
BUTTON:\s-34L\s0\& CENTER:\s-3M\s0\& CITE CODE DEL:\s-33\s0\&
DFN:\s-33,3.2,4C,4L\s0\& EM FONT:\s-33.2,4C,4L,M\s0\& I
IFRAME:\s-34L\s0\& IMG INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\& KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& MAP:\s-33.2,4C,4L\s0\&
MATH:\s-33\s0\& NOBR:\s-3M\s0\& OBJECT:\s-34C,4L\s0\& PERSON:\s-33\s0\&
Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\& SAMP SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG STYLE:\s-34C\s0\& SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\& TEXTAREA:\s-33.2,4C,4L\s0\& TT
U:\s-33,3.2,4C,4L\s0\& VAR WBR:\s-3M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<IFRAME>" " \s-3required:4L\s0\&" " .\|.\|. </IFRAME>" " \s-3required:4L\s0\&"
.\"
.RS
.I "contained in:"
A:\s-34L\s0\& ABBR:\s-34L\s0\& ADDRESS:\s-34L\s0\& APPLET:\s-34L\s0\&
B:\s-34L\s0\& BDO:\s-34L\s0\& BIG:\s-34L\s0\& BLOCKQUOTE:\s-34L\s0\&
BODY:\s-34L\s0\& CAPTION:\s-34L\s0\& CENTER:\s-34L\s0\& CITE:\s-34L\s0\&
CODE:\s-34L\s0\& DD:\s-34L\s0\& DEL:\s-34L\s0\& DFN:\s-34L\s0\&
DIV:\s-34L\s0\& DT:\s-34L\s0\& EM:\s-34L\s0\& FIELDSET:\s-34L\s0\&
FONT:\s-34L\s0\& FORM:\s-34L\s0\& H1:\s-34L\s0\& H2:\s-34L\s0\&
H3:\s-34L\s0\& H4:\s-34L\s0\& H5:\s-34L\s0\& H6:\s-34L\s0\&
I:\s-34L\s0\& IFRAME:\s-34L\s0\& INS:\s-34L\s0\& KBD:\s-34L\s0\&
LABEL:\s-34L\s0\& LEGEND:\s-34L\s0\& LI:\s-34L\s0\& NOSCRIPT:\s-34L\s0\&
OBJECT:\s-34L\s0\& P:\s-34L\s0\& PRE:\s-34L\s0\& Q:\s-34L\s0\&
S:\s-34L\s0\& SAMP:\s-34L\s0\& SMALL:\s-34L\s0\& SPAN:\s-34L\s0\&
STRIKE:\s-34L\s0\& STRONG:\s-34L\s0\& SUB:\s-34L\s0\& SUP:\s-34L\s0\&
TD:\s-34L\s0\& TH:\s-34L\s0\& TT:\s-34L\s0\& U:\s-34L\s0\&
VAR:\s-34L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-34L\s0\& A:\s-34L\s0\& ABBR:\s-34L\s0\& ADDRESS:\s-34L\s0\&
APPLET:\s-34L\s0\& B:\s-34L\s0\& BASEFONT:\s-34L\s0\& BDO:\s-34L\s0\&
BIG:\s-34L\s0\& BLOCKQUOTE:\s-34L\s0\& BR:\s-34L\s0\& BUTTON:\s-34L\s0\&
CENTER:\s-34L\s0\& CITE:\s-34L\s0\& CODE:\s-34L\s0\& DFN:\s-34L\s0\&
DIR:\s-34L\s0\& DIV:\s-34L\s0\& DL:\s-34L\s0\& EM:\s-34L\s0\&
FIELDSET:\s-34L\s0\& FONT:\s-34L\s0\& FORM:\s-34L\s0\& H1:\s-34L\s0\&
H2:\s-34L\s0\& H3:\s-34L\s0\& H4:\s-34L\s0\& H5:\s-34L\s0\&
H6:\s-34L\s0\& HR:\s-34L\s0\& I:\s-34L\s0\& IFRAME:\s-34L\s0\&
IMG:\s-34L\s0\& INPUT:\s-34L\s0\& ISINDEX:\s-34L\s0\& KBD:\s-34L\s0\&
LABEL:\s-34L\s0\& MAP:\s-34L\s0\& MENU:\s-34L\s0\& NOFRAMES:\s-34L\s0\&
NOSCRIPT:\s-34L\s0\& OBJECT:\s-34L\s0\& OL:\s-34L\s0\& P:\s-34L\s0\&
PRE:\s-34L\s0\& Q:\s-34L\s0\& S:\s-34L\s0\& SAMP:\s-34L\s0\&
SCRIPT:\s-34L\s0\& SELECT:\s-34L\s0\& SMALL:\s-34L\s0\& SPAN:\s-34L\s0\&
STRIKE:\s-34L\s0\& STRONG:\s-34L\s0\& SUB:\s-34L\s0\& SUP:\s-34L\s0\&
TABLE:\s-34L\s0\& TEXTAREA:\s-34L\s0\& TT:\s-34L\s0\& U:\s-34L\s0\&
UL:\s-34L\s0\& VAR:\s-34L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<IMG>" "\&"
.\"
.RS
.I "contained in:"
A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& ADDRESS
APPLET:\s-33.2,4L\s0\& AU:\s-33\s0\& B BDO:\s-34C,4L\s0\&
BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BLOCKQUOTE BODY BQ:\s-33\s0\&
BUTTON:\s-34L\s0\& CAPTION:\s-33,3.2,4C,4L\s0\&
CENTER:\s-33.2,4C,4L,M\s0\& CITE CODE CREDIT:\s-33\s0\& DD
DEL:\s-33,4L\s0\& DFN:\s-33,3.2,4C,4L\s0\& DIV:\s-33,3.2,4C,4L\s0\& DT
EM FIELDSET:\s-34C,4L\s0\& FONT:\s-33.2,4C,4L,M\s0\& FORM H1 H2 H3 H4 H5
H6 I IFRAME:\s-34L\s0\& INS:\s-33,4L\s0\& KBD LABEL:\s-34C,4L\s0\&
LANG:\s-33\s0\& LEGEND:\s-34L\s0\& LH:\s-33\s0\& LI NOBR:\s-3M\s0\&
NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\& OBJECT:\s-34C,4L\s0\& P
PERSON:\s-33\s0\& Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\& SAMP
SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\& STRIKE:\s-33.2,4L\s0\&
STRONG SUB:\s-33,3.2,4C,4L\s0\& SUP:\s-33,3.2,4C,4L\s0\&
TD:\s-33,3.2,4C,4L\s0\& TEXTFLOW:\s-34C\s0\& TH:\s-33,3.2,4C,4L\s0\& TT
U:\s-33,3.2,4C,4L\s0\& VAR
.RE
.\"
.RS
.I "contains:"
EMPTY
.RE
.\"---------------------------------------------------------------------
.BR "<INPUT>" "\&"
.\"
.RS
.I "contained in:"
A:\s-33.2,4C,4L\s0\& ABBR:\s-34L\s0\& ADDRESS:\s-33.2,4C,4L\s0\&
APPLET:\s-33.2,4L\s0\& B:\s-33.2,4C,4L\s0\& BDO:\s-34C,4L\s0\&
BIG:\s-33.2,4C,4L\s0\& BLOCKQUOTE:\s-33.2,4C,4L\s0\&
BODY:\s-33.2,4C,4L\s0\& CAPTION:\s-33.2,4C,4L\s0\&
CENTER:\s-33.2,4C,4L\s0\& CITE:\s-33.2,4C,4L\s0\&
CODE:\s-33.2,4C,4L\s0\& DD:\s-33.2,4C,4L\s0\& DEL:\s-34L\s0\&
DFN:\s-33.2,4C,4L\s0\& DIV:\s-33.2,4C,4L\s0\& DT:\s-33.2,4C,4L\s0\&
EM:\s-33.2,4C,4L\s0\& FIELDSET:\s-34C,4L\s0\& FONT:\s-33.2,4C,4L\s0\&
FORM H1:\s-33.2,4C,4L\s0\& H2:\s-33.2,4C,4L\s0\& H3:\s-33.2,4C,4L\s0\&
H4:\s-33.2,4C,4L\s0\& H5:\s-33.2,4C,4L\s0\& H6:\s-33.2,4C,4L\s0\&
I:\s-33.2,4C,4L\s0\& IFRAME:\s-34L\s0\& INS:\s-34L\s0\&
KBD:\s-33.2,4C,4L\s0\& LABEL:\s-34C,4L\s0\& LEGEND:\s-34L\s0\&
LI:\s-33.2,4C,4L\s0\& NOSCRIPT:\s-34L\s0\& OBJECT:\s-34C,4L\s0\&
P:\s-33.2,4C,4L\s0\& PRE:\s-33.2,4C,4L\s0\& Q:\s-34C,4L\s0\&
S:\s-34C,4L\s0\& SAMP:\s-33.2,4C,4L\s0\& SMALL:\s-33.2,4C,4L\s0\&
SPAN:\s-34C,4L\s0\& STRIKE:\s-33.2,4L\s0\& STRONG:\s-33.2,4C,4L\s0\&
SUB:\s-33.2,4C,4L\s0\& SUP:\s-33.2,4C,4L\s0\& TD:\s-33.2,4C,4L\s0\&
TEXTFLOW:\s-34C\s0\& TH:\s-33.2,4C,4L\s0\& TT:\s-33.2,4C,4L\s0\&
U:\s-33.2,4C,4L\s0\& VAR:\s-33.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
EMPTY
.RE
.\"---------------------------------------------------------------------
.BR "<INS>" " \s-3required:3,4L\s0\&" " .\|.\|. </INS>" " \s-3required:3,4L\s0\&"
.\"
.RS
.I "contained in:"
A:\s-33\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& ADDRESS:\s-33\s0\&
AU:\s-33\s0\& B:\s-33\s0\& BIG:\s-33\s0\& BLOCKQUOTE:\s-33\s0\&
BODY:\s-33,4L\s0\& BQ:\s-33\s0\& CAPTION:\s-33\s0\& CITE:\s-33\s0\&
CODE:\s-33\s0\& CREDIT:\s-33\s0\& DD:\s-33\s0\& DEL:\s-33\s0\&
DFN:\s-33\s0\& DIV:\s-33\s0\& DT:\s-33\s0\& EM:\s-33\s0\& FIG:\s-33\s0\&
FORM:\s-33\s0\& H1:\s-33\s0\& H2:\s-33\s0\& H3:\s-33\s0\& H4:\s-33\s0\&
H5:\s-33\s0\& H6:\s-33\s0\& I:\s-33\s0\& INS:\s-33\s0\& KBD:\s-33\s0\&
LANG:\s-33\s0\& LH:\s-33\s0\& LI:\s-33\s0\& NOTE:\s-33\s0\& P:\s-33\s0\&
PERSON:\s-33\s0\& PRE:\s-33\s0\& Q:\s-33\s0\& S:\s-33\s0\&
SAMP:\s-33\s0\& SMALL:\s-33\s0\& STRONG:\s-33\s0\& SUB:\s-33\s0\&
SUP:\s-33\s0\& TD:\s-33\s0\& TH:\s-33\s0\& TT:\s-33\s0\& U:\s-33\s0\&
VAR:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33,4L\s0\& A:\s-33,4L\s0\& ABBR:\s-34L\s0\& ABBREV:\s-33\s0\&
ACRONYM:\s-33\s0\& ADDRESS:\s-34L\s0\& APPLET:\s-34L\s0\& AU:\s-33\s0\&
B:\s-33,4L\s0\& BASEFONT:\s-34L\s0\& BDO:\s-34L\s0\& BIG:\s-33,4L\s0\&
BLOCKQUOTE:\s-34L\s0\& BR:\s-33,4L\s0\& BUTTON:\s-34L\s0\&
CENTER:\s-34L\s0\& CITE:\s-33,4L\s0\& CODE:\s-33,4L\s0\& DEL:\s-33\s0\&
DFN:\s-33,4L\s0\& DIR:\s-34L\s0\& DIV:\s-34L\s0\& DL:\s-34L\s0\&
EM:\s-33,4L\s0\& FIELDSET:\s-34L\s0\& FONT:\s-34L\s0\& FORM:\s-34L\s0\&
H1:\s-34L\s0\& H2:\s-34L\s0\& H3:\s-34L\s0\& H4:\s-34L\s0\&
H5:\s-34L\s0\& H6:\s-34L\s0\& HR:\s-34L\s0\& I:\s-33,4L\s0\&
IFRAME:\s-34L\s0\& IMG:\s-33,4L\s0\& INPUT:\s-34L\s0\& INS:\s-33\s0\&
ISINDEX:\s-34L\s0\& KBD:\s-33,4L\s0\& LABEL:\s-34L\s0\& LANG:\s-33\s0\&
MAP:\s-34L\s0\& MATH:\s-33\s0\& MENU:\s-34L\s0\& NOFRAMES:\s-34L\s0\&
NOSCRIPT:\s-34L\s0\& OBJECT:\s-34L\s0\& OL:\s-34L\s0\& P:\s-34L\s0\&
PERSON:\s-33\s0\& PRE:\s-34L\s0\& Q:\s-33,4L\s0\& S:\s-33,4L\s0\&
SAMP:\s-33,4L\s0\& SCRIPT:\s-34L\s0\& SELECT:\s-34L\s0\&
SMALL:\s-33,4L\s0\& SPAN:\s-34L\s0\& STRIKE:\s-34L\s0\&
STRONG:\s-33,4L\s0\& SUB:\s-33,4L\s0\& SUP:\s-33,4L\s0\& TAB:\s-33\s0\&
TABLE:\s-34L\s0\& TEXTAREA:\s-34L\s0\& TT:\s-33,4L\s0\& U:\s-33,4L\s0\&
UL:\s-34L\s0\& VAR:\s-33,4L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<ISINDEX>" "\&"
.\"
.RS
.I "contained in:"
APPLET:\s-34L\s0\& BLOCKQUOTE BODY BQ:\s-33\s0\&
CENTER:\s-33.2,4C,4L,M\s0\& DD DEL:\s-34L\s0\& DIV:\s-33,3.2,4C,4L\s0\&
FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\& FORM HEAD IFRAME:\s-34L\s0\&
INS:\s-34L\s0\& LI NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& TD:\s-33,3.2,4C,4L\s0\& TH:\s-33,3.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
EMPTY
.RE
.\"---------------------------------------------------------------------
.BR "<ITEM>" " \s-3required:3\s0\&" " .\|.\|. </ITEM>" " \s-3optional:3\s0\&"
.\"
.RS
.I "contained in:"
ROW:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33\s0\& ABOVE:\s-33\s0\& ARRAY:\s-33\s0\& B:\s-33\s0\&
BAR:\s-33\s0\& BELOW:\s-33\s0\& BOX:\s-33\s0\& BT:\s-33\s0\&
DDOT:\s-33\s0\& DOT:\s-33\s0\& HAT:\s-33\s0\& ROOT:\s-33\s0\&
SQRT:\s-33\s0\& SUB:\s-33\s0\& SUP:\s-33\s0\& T:\s-33\s0\&
TILDE:\s-33\s0\& VEC:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<KBD>" "\&" " .\|.\|. </KBD>" "\&"
.\"
.RS
.I "contained in:"
A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& ADDRESS
APPLET:\s-33.2,4L\s0\& AU:\s-33\s0\& B BDO:\s-34C,4L\s0\&
BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BLOCKQUOTE BODY BQ:\s-33\s0\&
BUTTON:\s-34L\s0\& CAPTION:\s-33,3.2,4C,4L\s0\&
CENTER:\s-33.2,4C,4L,M\s0\& CITE CODE CREDIT:\s-33\s0\& DD
DEL:\s-33,4L\s0\& DFN:\s-33,3.2,4C,4L\s0\& DIV:\s-33,3.2,4C,4L\s0\& DT
EM FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\& FONT:\s-33.2,4C,4L,M\s0\& FORM
H1 H2 H3 H4 H5 H6 I IFRAME:\s-34L\s0\& INS:\s-33,4L\s0\& KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& LEGEND:\s-34L\s0\& LH:\s-33\s0\& LI
NOBR:\s-3M\s0\& NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& P PERSON:\s-33\s0\& PRE Q:\s-33,4C,4L\s0\&
S:\s-33,4C,4L\s0\& SAMP SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TD:\s-33,3.2,4C,4L\s0\& TEXTFLOW:\s-34C\s0\&
TH:\s-33,3.2,4C,4L\s0\& TT U:\s-33,3.2,4C,4L\s0\& VAR
.RE
.\"
.RS
.I "contains:"
#PCDATA A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
APPLET:\s-33.2,4C,4L\s0\& AU:\s-33\s0\& B BASEFONT:\s-33.2,4C,4L,M\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BR
BUTTON:\s-34L\s0\& CENTER:\s-3M\s0\& CITE CODE DEL:\s-33\s0\&
DFN:\s-33,3.2,4C,4L\s0\& EM FONT:\s-33.2,4C,4L,M\s0\& I
IFRAME:\s-34L\s0\& IMG INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\& KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& MAP:\s-33.2,4C,4L\s0\&
MATH:\s-33\s0\& NOBR:\s-3M\s0\& OBJECT:\s-34C,4L\s0\& PERSON:\s-33\s0\&
Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\& SAMP SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG STYLE:\s-34C\s0\& SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\& TEXTAREA:\s-33.2,4C,4L\s0\& TT
U:\s-33,3.2,4C,4L\s0\& VAR WBR:\s-3M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<LABEL>" " \s-3required:4C,4L\s0\&" " .\|.\|. </LABEL>" " \s-3required:4C,4L\s0\&"
.\"
.RS
.I "contained in:"
A:\s-34C,4L\s0\& ABBR:\s-34L\s0\& ADDRESS:\s-34C,4L\s0\&
APPLET:\s-34L\s0\& B:\s-34C,4L\s0\& BDO:\s-34C,4L\s0\&
BIG:\s-34C,4L\s0\& BLOCKQUOTE:\s-34C,4L\s0\& BODY:\s-34C,4L\s0\&
CAPTION:\s-34C,4L\s0\& CENTER:\s-34C,4L\s0\& CITE:\s-34C,4L\s0\&
CODE:\s-34C,4L\s0\& DD:\s-34C,4L\s0\& DEL:\s-34L\s0\& DFN:\s-34C,4L\s0\&
DIV:\s-34C,4L\s0\& DT:\s-34C,4L\s0\& EM:\s-34C,4L\s0\&
FIELDSET:\s-34C,4L\s0\& FONT:\s-34C,4L\s0\& FORM:\s-34C,4L\s0\&
H1:\s-34C,4L\s0\& H2:\s-34C,4L\s0\& H3:\s-34C,4L\s0\& H4:\s-34C,4L\s0\&
H5:\s-34C,4L\s0\& H6:\s-34C,4L\s0\& I:\s-34C,4L\s0\& IFRAME:\s-34L\s0\&
INS:\s-34L\s0\& KBD:\s-34C,4L\s0\& LEGEND:\s-34L\s0\& LI:\s-34C,4L\s0\&
NOSCRIPT:\s-34L\s0\& OBJECT:\s-34C,4L\s0\& P:\s-34C,4L\s0\&
PRE:\s-34C,4L\s0\& Q:\s-34C,4L\s0\& S:\s-34C,4L\s0\& SAMP:\s-34C,4L\s0\&
SMALL:\s-34C,4L\s0\& SPAN:\s-34C,4L\s0\& STRIKE:\s-34L\s0\&
STRONG:\s-34C,4L\s0\& SUB:\s-34C,4L\s0\& SUP:\s-34C,4L\s0\&
TD:\s-34C,4L\s0\& TEXTFLOW:\s-34C\s0\& TH:\s-34C,4L\s0\&
TT:\s-34C,4L\s0\& U:\s-34C,4L\s0\& VAR:\s-34C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-34C,4L\s0\& A:\s-34C,4L\s0\& ABBR:\s-34L\s0\&
APPLET:\s-34C,4L\s0\& B:\s-34C,4L\s0\& BASEFONT:\s-34C,4L\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-34C,4L\s0\& BR:\s-34C,4L\s0\&
BUTTON:\s-34L\s0\& CITE:\s-34C,4L\s0\& CODE:\s-34C,4L\s0\&
DFN:\s-34C,4L\s0\& EM:\s-34C,4L\s0\& FONT:\s-34C,4L\s0\&
I:\s-34C,4L\s0\& IFRAME:\s-34L\s0\& IMG:\s-34C,4L\s0\&
INPUT:\s-34C,4L\s0\& KBD:\s-34C,4L\s0\& MAP:\s-34C,4L\s0\&
OBJECT:\s-34C,4L\s0\& Q:\s-34C,4L\s0\& S:\s-34C,4L\s0\&
SAMP:\s-34C,4L\s0\& SCRIPT:\s-34C,4L\s0\& SELECT:\s-34C,4L\s0\&
SMALL:\s-34C,4L\s0\& SPAN:\s-34C,4L\s0\& STRIKE:\s-34L\s0\&
STRONG:\s-34C,4L\s0\& STYLE:\s-34C\s0\& SUB:\s-34C,4L\s0\&
SUP:\s-34C,4L\s0\& TEXTAREA:\s-34C,4L\s0\& TT:\s-34C,4L\s0\&
U:\s-34C,4L\s0\& VAR:\s-34C,4L\s0\&
.RE
.\"
.RS
.I "cannot contain:"
LABEL:\s-34C,4L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<LANG>" " \s-3required:3\s0\&" " .\|.\|. </LANG>" " \s-3required:3\s0\&"
.\"
.RS
.I "contained in:"
A:\s-33\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& ADDRESS:\s-33\s0\&
AU:\s-33\s0\& B:\s-33\s0\& BIG:\s-33\s0\& BLOCKQUOTE:\s-33\s0\&
BODY:\s-33\s0\& BQ:\s-33\s0\& CAPTION:\s-33\s0\& CITE:\s-33\s0\&
CODE:\s-33\s0\& CREDIT:\s-33\s0\& DD:\s-33\s0\& DEL:\s-33\s0\&
DFN:\s-33\s0\& DIV:\s-33\s0\& DT:\s-33\s0\& EM:\s-33\s0\& FIG:\s-33\s0\&
FORM:\s-33\s0\& H1:\s-33\s0\& H2:\s-33\s0\& H3:\s-33\s0\& H4:\s-33\s0\&
H5:\s-33\s0\& H6:\s-33\s0\& I:\s-33\s0\& INS:\s-33\s0\& KBD:\s-33\s0\&
LANG:\s-33\s0\& LH:\s-33\s0\& LI:\s-33\s0\& NOTE:\s-33\s0\& P:\s-33\s0\&
PERSON:\s-33\s0\& PRE:\s-33\s0\& Q:\s-33\s0\& S:\s-33\s0\&
SAMP:\s-33\s0\& SMALL:\s-33\s0\& STRONG:\s-33\s0\& SUB:\s-33\s0\&
SUP:\s-33\s0\& TD:\s-33\s0\& TH:\s-33\s0\& TT:\s-33\s0\& U:\s-33\s0\&
VAR:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33\s0\& A:\s-33\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
AU:\s-33\s0\& B:\s-33\s0\& BIG:\s-33\s0\& BR:\s-33\s0\& CITE:\s-33\s0\&
CODE:\s-33\s0\& DEL:\s-33\s0\& DFN:\s-33\s0\& EM:\s-33\s0\& I:\s-33\s0\&
IMG:\s-33\s0\& INS:\s-33\s0\& KBD:\s-33\s0\& LANG:\s-33\s0\&
MATH:\s-33\s0\& PERSON:\s-33\s0\& Q:\s-33\s0\& S:\s-33\s0\&
SAMP:\s-33\s0\& SMALL:\s-33\s0\& STRONG:\s-33\s0\& SUB:\s-33\s0\&
SUP:\s-33\s0\& TAB:\s-33\s0\& TT:\s-33\s0\& U:\s-33\s0\& VAR:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<LEFT>" " \s-3required:3\s0\&"
.\"
.RS
.I "contained in:"
BOX:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
EMPTY:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<LEGEND>" " \s-3required:4L\s0\&" " .\|.\|. </LEGEND>" " \s-3required:4L\s0\&"
.\"
.RS
.I "contained in:"
FIELDSET:\s-34L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-34L\s0\& A:\s-34L\s0\& ABBR:\s-34L\s0\& APPLET:\s-34L\s0\&
B:\s-34L\s0\& BASEFONT:\s-34L\s0\& BDO:\s-34L\s0\& BIG:\s-34L\s0\&
BR:\s-34L\s0\& BUTTON:\s-34L\s0\& CITE:\s-34L\s0\& CODE:\s-34L\s0\&
DFN:\s-34L\s0\& EM:\s-34L\s0\& FONT:\s-34L\s0\& I:\s-34L\s0\&
IFRAME:\s-34L\s0\& IMG:\s-34L\s0\& INPUT:\s-34L\s0\& KBD:\s-34L\s0\&
LABEL:\s-34L\s0\& MAP:\s-34L\s0\& OBJECT:\s-34L\s0\& Q:\s-34L\s0\&
S:\s-34L\s0\& SAMP:\s-34L\s0\& SCRIPT:\s-34L\s0\& SELECT:\s-34L\s0\&
SMALL:\s-34L\s0\& SPAN:\s-34L\s0\& STRIKE:\s-34L\s0\& STRONG:\s-34L\s0\&
SUB:\s-34L\s0\& SUP:\s-34L\s0\& TEXTAREA:\s-34L\s0\& TT:\s-34L\s0\&
U:\s-34L\s0\& VAR:\s-34L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<LH>" " \s-3required:3\s0\&" " .\|.\|. </LH>" " \s-3optional:3\s0\&"
.\"
.RS
.I "contained in:"
DL:\s-33\s0\& OL:\s-33\s0\& UL:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33\s0\& A:\s-33\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
AU:\s-33\s0\& B:\s-33\s0\& BIG:\s-33\s0\& BR:\s-33\s0\& CITE:\s-33\s0\&
CODE:\s-33\s0\& DEL:\s-33\s0\& DFN:\s-33\s0\& EM:\s-33\s0\& I:\s-33\s0\&
IMG:\s-33\s0\& INS:\s-33\s0\& KBD:\s-33\s0\& LANG:\s-33\s0\&
MATH:\s-33\s0\& PERSON:\s-33\s0\& Q:\s-33\s0\& S:\s-33\s0\&
SAMP:\s-33\s0\& SMALL:\s-33\s0\& STRONG:\s-33\s0\& SUB:\s-33\s0\&
SUP:\s-33\s0\& TAB:\s-33\s0\& TT:\s-33\s0\& U:\s-33\s0\& VAR:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<LI>" "\&" " .\|.\|. </LI>" " \s-3optional\s0\&"
.\"
.RS
.I "contained in:"
DIR MENU OL UL
.RE
.\"
.RS
.I "contains:"
#PCDATA A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
ADDRESS:\s-34L\s0\& APPLET:\s-33.2,4C,4L\s0\& AU:\s-33\s0\& B
BASEFONT:\s-33.2,4C,4L,M\s0\& BDO:\s-34C,4L\s0\&
BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BLOCKQUOTE BQ:\s-33\s0\& BR
BUTTON:\s-34L\s0\& CENTER:\s-33.2,4C,4L,M\s0\& CITE CODE DEL:\s-33\s0\&
DFN:\s-33,3.2,4C,4L\s0\& DIR DIV:\s-33.2,4C,4L\s0\& DL EM
FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\& FONT:\s-33.2,4C,4L,M\s0\& FORM
H1:\s-34L\s0\& H2:\s-34L\s0\& H3:\s-34L\s0\& H4:\s-34L\s0\&
H5:\s-34L\s0\& H6:\s-34L\s0\& HR:\s-33.2,4C,4L\s0\& I IFRAME:\s-34L\s0\&
IMG INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\& ISINDEX KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& LISTING:\s-32,3,3.2,4C,M\s0\&
MAP:\s-33.2,4C,4L\s0\& MATH:\s-33\s0\& MENU NOBR:\s-3M\s0\&
NOFRAMES:\s-34L\s0\& NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& OL P PERSON:\s-33\s0\& PRE Q:\s-33,4C,4L\s0\&
S:\s-33,4C,4L\s0\& SAMP SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG STYLE:\s-34C\s0\& SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\& TABLE:\s-33,3.2,4C,4L\s0\&
TEXTAREA:\s-33.2,4C,4L\s0\& TT U:\s-33,3.2,4C,4L\s0\& UL VAR
WBR:\s-3M\s0\& XMP:\s-32,3,3.2,4C,M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<LINK>" "\&"
.\"
.RS
.I "contained in:"
HEAD
.RE
.\"
.RS
.I "contains:"
EMPTY
.RE
.\"---------------------------------------------------------------------
.BR "<LISTING>" " \s-3required:2,3,3.2,4C,M\s0\&" " .\|.\|. </LISTING>" " \s-3required:2,3,3.2,4C,M\s0\&" " (deprecated)"
.\"
.RS
.I "contained in:"
BLOCKQUOTE:\s-32,3,3.2,4C,M\s0\& BODY:\s-32,3,3.2,4C,M\s0\&
BQ:\s-33\s0\& CENTER:\s-33.2,4C,M\s0\& DD:\s-32,3,3.2,4C,M\s0\&
DIV:\s-33,3.2,4C\s0\& FIELDSET:\s-34C\s0\& FIG:\s-33\s0\&
FORM:\s-32,3,3.2,4C,M\s0\& LI:\s-32,3,3.2,4C,M\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C\s0\& TD:\s-33,3.2,4C\s0\& TH:\s-33,3.2,4C\s0\&
.RE
.\"
.RS
.I "contains:"
CDATA:\s-32,3,3.2,4C,M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<MAP>" " \s-3required:3.2,4C,4L\s0\&" " .\|.\|. </MAP>" " \s-3required:3.2,4C,4L\s0\&"
.\"
.RS
.I "contained in:"
A:\s-33.2,4C,4L\s0\& ABBR:\s-34L\s0\& ADDRESS:\s-33.2,4C,4L\s0\&
APPLET:\s-33.2,4L\s0\& B:\s-33.2,4C,4L\s0\& BDO:\s-34C,4L\s0\&
BIG:\s-33.2,4C,4L\s0\& BLOCKQUOTE:\s-33.2,4C,4L\s0\&
BODY:\s-33.2,4C,4L\s0\& BUTTON:\s-34L\s0\& CAPTION:\s-33.2,4C,4L\s0\&
CENTER:\s-33.2,4C,4L\s0\& CITE:\s-33.2,4C,4L\s0\&
CODE:\s-33.2,4C,4L\s0\& DD:\s-33.2,4C,4L\s0\& DEL:\s-34L\s0\&
DFN:\s-33.2,4C,4L\s0\& DIV:\s-33.2,4C,4L\s0\& DT:\s-33.2,4C,4L\s0\&
EM:\s-33.2,4C,4L\s0\& FIELDSET:\s-34C,4L\s0\& FONT:\s-33.2,4C,4L\s0\&
FORM:\s-33.2,4C,4L\s0\& H1:\s-33.2,4C,4L\s0\& H2:\s-33.2,4C,4L\s0\&
H3:\s-33.2,4C,4L\s0\& H4:\s-33.2,4C,4L\s0\& H5:\s-33.2,4C,4L\s0\&
H6:\s-33.2,4C,4L\s0\& I:\s-33.2,4C,4L\s0\& IFRAME:\s-34L\s0\&
INS:\s-34L\s0\& KBD:\s-33.2,4C,4L\s0\& LABEL:\s-34C,4L\s0\&
LEGEND:\s-34L\s0\& LI:\s-33.2,4C,4L\s0\& NOSCRIPT:\s-34L\s0\&
OBJECT:\s-34C,4L\s0\& P:\s-33.2,4C,4L\s0\& PRE:\s-33.2,4C,4L\s0\&
Q:\s-34C,4L\s0\& S:\s-34C,4L\s0\& SAMP:\s-33.2,4C,4L\s0\&
SMALL:\s-33.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\& STRIKE:\s-33.2,4L\s0\&
STRONG:\s-33.2,4C,4L\s0\& SUB:\s-33.2,4C,4L\s0\& SUP:\s-33.2,4C,4L\s0\&
TD:\s-33.2,4C,4L\s0\& TEXTFLOW:\s-34C\s0\& TH:\s-33.2,4C,4L\s0\&
TT:\s-33.2,4C,4L\s0\& U:\s-33.2,4C,4L\s0\& VAR:\s-33.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
AREA:\s-33.2,4C,4L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<MATH>" " \s-3required:3\s0\&" " .\|.\|. </MATH>" " \s-3required:3\s0\&"
.\"
.RS
.I "contained in:"
A:\s-33\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& ADDRESS:\s-33\s0\&
AU:\s-33\s0\& B:\s-33\s0\& BIG:\s-33\s0\& BLOCKQUOTE:\s-33\s0\&
BODY:\s-33\s0\& BQ:\s-33\s0\& CAPTION:\s-33\s0\& CITE:\s-33\s0\&
CODE:\s-33\s0\& CREDIT:\s-33\s0\& DD:\s-33\s0\& DEL:\s-33\s0\&
DFN:\s-33\s0\& DIV:\s-33\s0\& DT:\s-33\s0\& EM:\s-33\s0\& FIG:\s-33\s0\&
FORM:\s-33\s0\& H1:\s-33\s0\& H2:\s-33\s0\& H3:\s-33\s0\& H4:\s-33\s0\&
H5:\s-33\s0\& H6:\s-33\s0\& I:\s-33\s0\& INS:\s-33\s0\& KBD:\s-33\s0\&
LANG:\s-33\s0\& LH:\s-33\s0\& LI:\s-33\s0\& NOTE:\s-33\s0\& P:\s-33\s0\&
PERSON:\s-33\s0\& Q:\s-33\s0\& S:\s-33\s0\& SAMP:\s-33\s0\&
SMALL:\s-33\s0\& STRONG:\s-33\s0\& SUB:\s-33\s0\& SUP:\s-33\s0\&
TD:\s-33\s0\& TH:\s-33\s0\& TT:\s-33\s0\& U:\s-33\s0\& VAR:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33\s0\& ABOVE:\s-33\s0\& ARRAY:\s-33\s0\& B:\s-33\s0\&
BAR:\s-33\s0\& BELOW:\s-33\s0\& BOX:\s-33\s0\& BT:\s-33\s0\&
DDOT:\s-33\s0\& DOT:\s-33\s0\& HAT:\s-33\s0\& ROOT:\s-33\s0\&
SQRT:\s-33\s0\& SUB:\s-33\s0\& SUP:\s-33\s0\& T:\s-33\s0\&
TILDE:\s-33\s0\& VEC:\s-33\s0\&
.RE
.\"
.RS
.I "cannot contain:"
A:\s-33\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& AU:\s-33\s0\&
BIG:\s-33\s0\& BR:\s-33\s0\& CITE:\s-33\s0\& CODE:\s-33\s0\&
DEL:\s-33\s0\& DFN:\s-33\s0\& EM:\s-33\s0\& I:\s-33\s0\& IMG:\s-33\s0\&
INS:\s-33\s0\& KBD:\s-33\s0\& LANG:\s-33\s0\& MATH:\s-33\s0\&
PERSON:\s-33\s0\& Q:\s-33\s0\& S:\s-33\s0\& SAMP:\s-33\s0\&
SMALL:\s-33\s0\& STRONG:\s-33\s0\& TAB:\s-33\s0\& TT:\s-33\s0\&
U:\s-33\s0\& VAR:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<MENU>" "\&" " .\|.\|. </MENU>" "\&" " (deprecated)"
.\"
.RS
.I "contained in:"
APPLET:\s-34L\s0\& BLOCKQUOTE BODY BQ:\s-33\s0\& BUTTON:\s-34L\s0\&
CENTER:\s-33.2,4C,4L,M\s0\& DD DEL:\s-34L\s0\& DIV:\s-33,3.2,4C,4L\s0\&
FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\& FORM IFRAME:\s-34L\s0\&
INS:\s-34L\s0\& LI NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& TD:\s-33,3.2,4C,4L\s0\& TH:\s-33,3.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
LI
.RE
.\"
.RS
.I "cannot contain:"
ADDRESS:\s-34L\s0\& BLOCKQUOTE BQ:\s-33\s0\& CENTER:\s-33.2,4C,4L,M\s0\&
DIR DIV:\s-33.2,4C,4L\s0\& DL FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\&
FORM H1:\s-34L\s0\& H2:\s-34L\s0\& H3:\s-34L\s0\& H4:\s-34L\s0\&
H5:\s-34L\s0\& H6:\s-34L\s0\& HR:\s-33.2,4C,4L\s0\& ISINDEX
LISTING:\s-32,3,3.2,4C,M\s0\& MENU NOFRAMES:\s-34L\s0\&
NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\& OL P PRE TABLE:\s-33,3.2,4C,4L\s0\&
UL XMP:\s-32,3,3.2,4C,M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<META>" "\&"
.\"
.RS
.I "contained in:"
HEAD
.RE
.\"
.RS
.I "contains:"
EMPTY
.RE
.\"---------------------------------------------------------------------
.BR "<NEXTID>" " \s-3required:2,3,M\s0\&" " (deprecated)"
.\"
.RS
.I "contained in:"
HEAD:\s-32,3,M\s0\&
.RE
.\"
.RS
.I "contains:"
EMPTY:\s-32,3,M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<NOBR>" " \s-3required:M\s0\&" " .\|.\|. </NOBR>" " \s-3required:M\s0\&"
.\"
.RS
.I "contained in:"
A:\s-3M\s0\& ADDRESS:\s-3M\s0\& B:\s-3M\s0\& BLINK:\s-3M\s0\&
BLOCKQUOTE:\s-3M\s0\& BODY:\s-3M\s0\& CENTER:\s-3M\s0\& CITE:\s-3M\s0\&
CODE:\s-3M\s0\& DD:\s-3M\s0\& DT:\s-3M\s0\& EM:\s-3M\s0\&
FONT:\s-3M\s0\& FORM:\s-3M\s0\& H1:\s-3M\s0\& H2:\s-3M\s0\&
H3:\s-3M\s0\& H4:\s-3M\s0\& H5:\s-3M\s0\& H6:\s-3M\s0\& I:\s-3M\s0\&
KBD:\s-3M\s0\& LI:\s-3M\s0\& NOBR:\s-3M\s0\& P:\s-3M\s0\&
SAMP:\s-3M\s0\& STRONG:\s-3M\s0\& TT:\s-3M\s0\& VAR:\s-3M\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-3M\s0\& A:\s-3M\s0\& B:\s-3M\s0\& BASEFONT:\s-3M\s0\&
BLINK:\s-3M\s0\& BR:\s-3M\s0\& CENTER:\s-3M\s0\& CITE:\s-3M\s0\&
CODE:\s-3M\s0\& EM:\s-3M\s0\& FONT:\s-3M\s0\& I:\s-3M\s0\&
IMG:\s-3M\s0\& KBD:\s-3M\s0\& NOBR:\s-3M\s0\& SAMP:\s-3M\s0\&
STRONG:\s-3M\s0\& TT:\s-3M\s0\& VAR:\s-3M\s0\& WBR:\s-3M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<NOFRAMES>" " \s-3required:4L\s0\&" " .\|.\|. </NOFRAMES>" " \s-3required:4L\s0\&"
.\"
.RS
.I "contained in:"
APPLET:\s-34L\s0\& BLOCKQUOTE:\s-34L\s0\& BODY:\s-34L\s0\&
BUTTON:\s-34L\s0\& CENTER:\s-34L\s0\& DD:\s-34L\s0\& DEL:\s-34L\s0\&
DIV:\s-34L\s0\& FIELDSET:\s-34L\s0\& FORM:\s-34L\s0\&
FRAMESET:\s-34L\s0\& IFRAME:\s-34L\s0\& INS:\s-34L\s0\& LI:\s-34L\s0\&
NOSCRIPT:\s-34L\s0\& OBJECT:\s-34L\s0\& TD:\s-34L\s0\& TH:\s-34L\s0\&
.RE
.\"
.RS
.I "contains:"
BODY:\s-34L\s0\&
.RE
.\"
.RS
.I "cannot contain:"
#PCDATA:\s-34L\s0\& A:\s-34L\s0\& ABBR:\s-34L\s0\& ADDRESS:\s-34L\s0\&
APPLET:\s-34L\s0\& B:\s-34L\s0\& BASEFONT:\s-34L\s0\& BDO:\s-34L\s0\&
BIG:\s-34L\s0\& BLOCKQUOTE:\s-34L\s0\& BR:\s-34L\s0\& BUTTON:\s-34L\s0\&
CENTER:\s-34L\s0\& CITE:\s-34L\s0\& CODE:\s-34L\s0\& DFN:\s-34L\s0\&
DIR:\s-34L\s0\& DIV:\s-34L\s0\& DL:\s-34L\s0\& EM:\s-34L\s0\&
FIELDSET:\s-34L\s0\& FONT:\s-34L\s0\& FORM:\s-34L\s0\& H1:\s-34L\s0\&
H2:\s-34L\s0\& H3:\s-34L\s0\& H4:\s-34L\s0\& H5:\s-34L\s0\&
H6:\s-34L\s0\& HR:\s-34L\s0\& I:\s-34L\s0\& IFRAME:\s-34L\s0\&
IMG:\s-34L\s0\& INPUT:\s-34L\s0\& ISINDEX:\s-34L\s0\& KBD:\s-34L\s0\&
LABEL:\s-34L\s0\& MAP:\s-34L\s0\& MENU:\s-34L\s0\& NOFRAMES:\s-34L\s0\&
NOSCRIPT:\s-34L\s0\& OBJECT:\s-34L\s0\& OL:\s-34L\s0\& P:\s-34L\s0\&
PRE:\s-34L\s0\& Q:\s-34L\s0\& S:\s-34L\s0\& SAMP:\s-34L\s0\&
SCRIPT:\s-34L\s0\& SELECT:\s-34L\s0\& SMALL:\s-34L\s0\& SPAN:\s-34L\s0\&
STRIKE:\s-34L\s0\& STRONG:\s-34L\s0\& SUB:\s-34L\s0\& SUP:\s-34L\s0\&
TABLE:\s-34L\s0\& TEXTAREA:\s-34L\s0\& TT:\s-34L\s0\& U:\s-34L\s0\&
UL:\s-34L\s0\& VAR:\s-34L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<NOSCRIPT>" " \s-3required:4L\s0\&" " .\|.\|. </NOSCRIPT>" " \s-3required:4L\s0\&"
.\"
.RS
.I "contained in:"
APPLET:\s-34L\s0\& BLOCKQUOTE:\s-34L\s0\& BODY:\s-34L\s0\&
BUTTON:\s-34L\s0\& CENTER:\s-34L\s0\& DD:\s-34L\s0\& DEL:\s-34L\s0\&
DIV:\s-34L\s0\& FIELDSET:\s-34L\s0\& FORM:\s-34L\s0\& IFRAME:\s-34L\s0\&
INS:\s-34L\s0\& LI:\s-34L\s0\& NOSCRIPT:\s-34L\s0\& OBJECT:\s-34L\s0\&
TD:\s-34L\s0\& TH:\s-34L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-34L\s0\& A:\s-34L\s0\& ABBR:\s-34L\s0\& ADDRESS:\s-34L\s0\&
APPLET:\s-34L\s0\& B:\s-34L\s0\& BASEFONT:\s-34L\s0\& BDO:\s-34L\s0\&
BIG:\s-34L\s0\& BLOCKQUOTE:\s-34L\s0\& BR:\s-34L\s0\& BUTTON:\s-34L\s0\&
CENTER:\s-34L\s0\& CITE:\s-34L\s0\& CODE:\s-34L\s0\& DFN:\s-34L\s0\&
DIR:\s-34L\s0\& DIV:\s-34L\s0\& DL:\s-34L\s0\& EM:\s-34L\s0\&
FIELDSET:\s-34L\s0\& FONT:\s-34L\s0\& FORM:\s-34L\s0\& H1:\s-34L\s0\&
H2:\s-34L\s0\& H3:\s-34L\s0\& H4:\s-34L\s0\& H5:\s-34L\s0\&
H6:\s-34L\s0\& HR:\s-34L\s0\& I:\s-34L\s0\& IFRAME:\s-34L\s0\&
IMG:\s-34L\s0\& INPUT:\s-34L\s0\& ISINDEX:\s-34L\s0\& KBD:\s-34L\s0\&
LABEL:\s-34L\s0\& MAP:\s-34L\s0\& MENU:\s-34L\s0\& NOFRAMES:\s-34L\s0\&
NOSCRIPT:\s-34L\s0\& OBJECT:\s-34L\s0\& OL:\s-34L\s0\& P:\s-34L\s0\&
PRE:\s-34L\s0\& Q:\s-34L\s0\& S:\s-34L\s0\& SAMP:\s-34L\s0\&
SCRIPT:\s-34L\s0\& SELECT:\s-34L\s0\& SMALL:\s-34L\s0\& SPAN:\s-34L\s0\&
STRIKE:\s-34L\s0\& STRONG:\s-34L\s0\& SUB:\s-34L\s0\& SUP:\s-34L\s0\&
TABLE:\s-34L\s0\& TEXTAREA:\s-34L\s0\& TT:\s-34L\s0\& U:\s-34L\s0\&
UL:\s-34L\s0\& VAR:\s-34L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<NOTE>" " \s-3required:3\s0\&" " .\|.\|. </NOTE>" " \s-3required:3\s0\&"
.\"
.RS
.I "contained in:"
BLOCKQUOTE:\s-33\s0\& BODY:\s-33\s0\& BQ:\s-33\s0\& DD:\s-33\s0\&
DIV:\s-33\s0\& FIG:\s-33\s0\& FORM:\s-33\s0\& LI:\s-33\s0\&
NOTE:\s-33\s0\& TD:\s-33\s0\& TH:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33\s0\& A:\s-33\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
ADDRESS:\s-33\s0\& AU:\s-33\s0\& B:\s-33\s0\& BIG:\s-33\s0\&
BLOCKQUOTE:\s-33\s0\& BQ:\s-33\s0\& BR:\s-33\s0\& CITE:\s-33\s0\&
CODE:\s-33\s0\& DEL:\s-33\s0\& DFN:\s-33\s0\& DIR:\s-33\s0\&
DIV:\s-33\s0\& DL:\s-33\s0\& EM:\s-33\s0\& FIG:\s-33\s0\&
FORM:\s-33\s0\& H1:\s-33\s0\& H2:\s-33\s0\& H3:\s-33\s0\& H4:\s-33\s0\&
H5:\s-33\s0\& H6:\s-33\s0\& HR:\s-33\s0\& I:\s-33\s0\& IMG:\s-33\s0\&
INS:\s-33\s0\& ISINDEX:\s-33\s0\& KBD:\s-33\s0\& LANG:\s-33\s0\&
LISTING:\s-33\s0\& MATH:\s-33\s0\& MENU:\s-33\s0\& NOTE:\s-33\s0\&
OL:\s-33\s0\& P:\s-33\s0\& PERSON:\s-33\s0\& PRE:\s-33\s0\& Q:\s-33\s0\&
S:\s-33\s0\& SAMP:\s-33\s0\& SMALL:\s-33\s0\& STRONG:\s-33\s0\&
SUB:\s-33\s0\& SUP:\s-33\s0\& TAB:\s-33\s0\& TABLE:\s-33\s0\&
TT:\s-33\s0\& U:\s-33\s0\& UL:\s-33\s0\& VAR:\s-33\s0\& XMP:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<OBJECT>" " \s-3required:4C,4L\s0\&" " .\|.\|. </OBJECT>" " \s-3required:4C,4L\s0\&"
.\"
.RS
.I "contained in:"
A:\s-34C,4L\s0\& ABBR:\s-34L\s0\& ADDRESS:\s-34C,4L\s0\&
APPLET:\s-34L\s0\& B:\s-34C,4L\s0\& BDO:\s-34C,4L\s0\&
BIG:\s-34C,4L\s0\& BLOCKQUOTE:\s-34C,4L\s0\& BODY:\s-34C,4L\s0\&
BUTTON:\s-34L\s0\& CAPTION:\s-34C,4L\s0\& CENTER:\s-34C,4L\s0\&
CITE:\s-34C,4L\s0\& CODE:\s-34C,4L\s0\& DD:\s-34C,4L\s0\&
DEL:\s-34L\s0\& DFN:\s-34C,4L\s0\& DIV:\s-34C,4L\s0\& DT:\s-34C,4L\s0\&
EM:\s-34C,4L\s0\& FIELDSET:\s-34C,4L\s0\& FONT:\s-34C,4L\s0\&
FORM:\s-34C,4L\s0\& H1:\s-34C,4L\s0\& H2:\s-34C,4L\s0\&
H3:\s-34C,4L\s0\& H4:\s-34C,4L\s0\& H5:\s-34C,4L\s0\& H6:\s-34C,4L\s0\&
I:\s-34C,4L\s0\& IFRAME:\s-34L\s0\& INS:\s-34L\s0\& KBD:\s-34C,4L\s0\&
LABEL:\s-34C,4L\s0\& LEGEND:\s-34L\s0\& LI:\s-34C,4L\s0\&
NOSCRIPT:\s-34L\s0\& OBJECT:\s-34C,4L\s0\& P:\s-34C,4L\s0\&
PRE:\s-34C\s0\& Q:\s-34C,4L\s0\& S:\s-34C,4L\s0\& SAMP:\s-34C,4L\s0\&
SMALL:\s-34C,4L\s0\& SPAN:\s-34C,4L\s0\& STRIKE:\s-34L\s0\&
STRONG:\s-34C,4L\s0\& SUB:\s-34C,4L\s0\& SUP:\s-34C,4L\s0\&
TD:\s-34C,4L\s0\& TEXTFLOW:\s-34C\s0\& TH:\s-34C,4L\s0\&
TT:\s-34C,4L\s0\& U:\s-34C,4L\s0\& VAR:\s-34C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-34C,4L\s0\& A:\s-34C,4L\s0\& ABBR:\s-34L\s0\&
ADDRESS:\s-34C,4L\s0\& APPLET:\s-34C,4L\s0\& B:\s-34C,4L\s0\&
BASEFONT:\s-34C,4L\s0\& BDO:\s-34C,4L\s0\& BIG:\s-34C,4L\s0\&
BLOCKQUOTE:\s-34C,4L\s0\& BR:\s-34C,4L\s0\& BUTTON:\s-34L\s0\&
CENTER:\s-34C,4L\s0\& CITE:\s-34C,4L\s0\& CODE:\s-34C,4L\s0\&
DFN:\s-34C,4L\s0\& DIR:\s-34C,4L\s0\& DIV:\s-34C,4L\s0\&
DL:\s-34C,4L\s0\& EM:\s-34C,4L\s0\& FIELDSET:\s-34C,4L\s0\&
FONT:\s-34C,4L\s0\& FORM:\s-34C,4L\s0\& H1:\s-34C,4L\s0\&
H2:\s-34C,4L\s0\& H3:\s-34C,4L\s0\& H4:\s-34C,4L\s0\& H5:\s-34C,4L\s0\&
H6:\s-34C,4L\s0\& HR:\s-34C,4L\s0\& I:\s-34C,4L\s0\& IFRAME:\s-34L\s0\&
IMG:\s-34C,4L\s0\& INPUT:\s-34C,4L\s0\& ISINDEX:\s-34C,4L\s0\&
KBD:\s-34C,4L\s0\& LABEL:\s-34C,4L\s0\& LISTING:\s-34C\s0\&
MAP:\s-34C,4L\s0\& MENU:\s-34C,4L\s0\& NOFRAMES:\s-34L\s0\&
NOSCRIPT:\s-34L\s0\& OBJECT:\s-34C,4L\s0\& OL:\s-34C,4L\s0\&
P:\s-34C,4L\s0\& PARAM:\s-34C,4L\s0\& PRE:\s-34C,4L\s0\&
Q:\s-34C,4L\s0\& S:\s-34C,4L\s0\& SAMP:\s-34C,4L\s0\&
SCRIPT:\s-34C,4L\s0\& SELECT:\s-34C,4L\s0\& SMALL:\s-34C,4L\s0\&
SPAN:\s-34C,4L\s0\& STRIKE:\s-34L\s0\& STRONG:\s-34C,4L\s0\&
STYLE:\s-34C\s0\& SUB:\s-34C,4L\s0\& SUP:\s-34C,4L\s0\&
TABLE:\s-34C,4L\s0\& TEXTAREA:\s-34C,4L\s0\& TT:\s-34C,4L\s0\&
U:\s-34C,4L\s0\& UL:\s-34C,4L\s0\& VAR:\s-34C,4L\s0\& XMP:\s-34C\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<OF>" " \s-3required:3\s0\&" " .\|.\|. </OF>" " \s-3optional:3\s0\&"
.\"
.RS
.I "contained in:"
ROOT:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33\s0\& ABOVE:\s-33\s0\& ARRAY:\s-33\s0\& B:\s-33\s0\&
BAR:\s-33\s0\& BELOW:\s-33\s0\& BOX:\s-33\s0\& BT:\s-33\s0\&
DDOT:\s-33\s0\& DOT:\s-33\s0\& HAT:\s-33\s0\& ROOT:\s-33\s0\&
SQRT:\s-33\s0\& SUB:\s-33\s0\& SUP:\s-33\s0\& T:\s-33\s0\&
TILDE:\s-33\s0\& VEC:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<OL>" "\&" " .\|.\|. </OL>" "\&"
.\"
.RS
.I "contained in:"
APPLET:\s-34L\s0\& BLOCKQUOTE BODY BQ:\s-33\s0\& BUTTON:\s-34L\s0\&
CENTER:\s-33.2,4C,4L,M\s0\& DD DEL:\s-34L\s0\& DIV:\s-33,3.2,4C,4L\s0\&
FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\& FORM IFRAME:\s-34L\s0\&
INS:\s-34L\s0\& LI NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& TD:\s-33,3.2,4C,4L\s0\& TH:\s-33,3.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
LH:\s-33\s0\& LI
.RE
.\"---------------------------------------------------------------------
.BR "<OPTGROUP>" " \s-3required:4L\s0\&" " .\|.\|. </OPTGROUP>" " \s-3required:4L\s0\&"
.\"
.RS
.I "contained in:"
OPTGROUP:\s-34L\s0\& SELECT:\s-34L\s0\&
.RE
.\"
.RS
.I "contains:"
OPTGROUP:\s-34L\s0\& OPTION:\s-34L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<OPTION>" "\&" " .\|.\|. </OPTION>" " \s-3optional\s0\&"
.\"
.RS
.I "contained in:"
OPTGROUP:\s-34L\s0\& SELECT
.RE
.\"
.RS
.I "contains:"
#PCDATA
.RE
.\"---------------------------------------------------------------------
.BR "<OVER>" " \s-3required:3\s0\&"
.\"
.RS
.I "contained in:"
BOX:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
EMPTY:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<OVERLAY>" " \s-3required:3\s0\&"
.\"
.RS
.I "contained in:"
FIG:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
EMPTY:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<P>" "\&" " .\|.\|. </P>" " \s-3optional\s0\&"
.\"
.RS
.I "contained in:"
ADDRESS APPLET:\s-34L\s0\& BLOCKQUOTE BODY BQ:\s-33\s0\&
BUTTON:\s-34L\s0\& CENTER:\s-33.2,4C,4L,M\s0\& DD DEL:\s-34L\s0\&
DIV:\s-33,3.2,4C,4L\s0\& FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\& FORM
IFRAME:\s-34L\s0\& INS:\s-34L\s0\& LI NOSCRIPT:\s-34L\s0\&
NOTE:\s-33\s0\& OBJECT:\s-34C,4L\s0\& TD:\s-33,3.2,4C,4L\s0\&
TH:\s-33,3.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
APPLET:\s-33.2,4C,4L\s0\& AU:\s-33\s0\& B BASEFONT:\s-33.2,4C,4L,M\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BR
BUTTON:\s-34L\s0\& CENTER:\s-3M\s0\& CITE CODE DEL:\s-33\s0\&
DFN:\s-33,3.2,4C,4L\s0\& EM FONT:\s-33.2,4C,4L,M\s0\& I
IFRAME:\s-34L\s0\& IMG INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\& KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& MAP:\s-33.2,4C,4L\s0\&
MATH:\s-33\s0\& NOBR:\s-3M\s0\& OBJECT:\s-34C,4L\s0\& PERSON:\s-33\s0\&
Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\& SAMP SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG STYLE:\s-34C\s0\& SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\& TEXTAREA:\s-33.2,4C,4L\s0\& TT
U:\s-33,3.2,4C,4L\s0\& VAR WBR:\s-3M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<PARAM>" " \s-3required:3.2,4C,4L\s0\&"
.\"
.RS
.I "contained in:"
APPLET:\s-33.2,4C,4L\s0\& OBJECT:\s-34C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
EMPTY:\s-33.2,4C,4L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<PERSON>" " \s-3required:3\s0\&" " .\|.\|. </PERSON>" " \s-3required:3\s0\&"
.\"
.RS
.I "contained in:"
A:\s-33\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& ADDRESS:\s-33\s0\&
AU:\s-33\s0\& B:\s-33\s0\& BIG:\s-33\s0\& BLOCKQUOTE:\s-33\s0\&
BODY:\s-33\s0\& BQ:\s-33\s0\& CAPTION:\s-33\s0\& CITE:\s-33\s0\&
CODE:\s-33\s0\& CREDIT:\s-33\s0\& DD:\s-33\s0\& DEL:\s-33\s0\&
DFN:\s-33\s0\& DIV:\s-33\s0\& DT:\s-33\s0\& EM:\s-33\s0\& FIG:\s-33\s0\&
FORM:\s-33\s0\& H1:\s-33\s0\& H2:\s-33\s0\& H3:\s-33\s0\& H4:\s-33\s0\&
H5:\s-33\s0\& H6:\s-33\s0\& I:\s-33\s0\& INS:\s-33\s0\& KBD:\s-33\s0\&
LANG:\s-33\s0\& LH:\s-33\s0\& LI:\s-33\s0\& NOTE:\s-33\s0\& P:\s-33\s0\&
PERSON:\s-33\s0\& PRE:\s-33\s0\& Q:\s-33\s0\& S:\s-33\s0\&
SAMP:\s-33\s0\& SMALL:\s-33\s0\& STRONG:\s-33\s0\& SUB:\s-33\s0\&
SUP:\s-33\s0\& TD:\s-33\s0\& TH:\s-33\s0\& TT:\s-33\s0\& U:\s-33\s0\&
VAR:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33\s0\& A:\s-33\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
AU:\s-33\s0\& B:\s-33\s0\& BIG:\s-33\s0\& BR:\s-33\s0\& CITE:\s-33\s0\&
CODE:\s-33\s0\& DEL:\s-33\s0\& DFN:\s-33\s0\& EM:\s-33\s0\& I:\s-33\s0\&
IMG:\s-33\s0\& INS:\s-33\s0\& KBD:\s-33\s0\& LANG:\s-33\s0\&
MATH:\s-33\s0\& PERSON:\s-33\s0\& Q:\s-33\s0\& S:\s-33\s0\&
SAMP:\s-33\s0\& SMALL:\s-33\s0\& STRONG:\s-33\s0\& SUB:\s-33\s0\&
SUP:\s-33\s0\& TAB:\s-33\s0\& TT:\s-33\s0\& U:\s-33\s0\& VAR:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<PLAINTEXT>" " \s-3required:2,3,3.2,4C,M\s0\&" " .\|.\|. </PLAINTEXT>" " \s-3optional:2,3,3.2,4C,M\s0\&" " (deprecated)"
.\"
.RS
.I "contained in:"
HTML:\s-32,3.2,4C,M\s0\&
.RE
.\"
.RS
.I "contains:"
CDATA:\s-32,3,3.2,4C,M\s0\&
.RE
.IP
.hy
.ad
NB: The meaning of this tag is aberrant, in that the closing tag is
not supposed to be present, even though the grammar says that it is
optional: the environment instead terminates at end-of-file.  Browsers
differ in their handling of the end tag: some display it as ordinary
text, and others terminate the environment.
.na
.nh
.PP
.\"---------------------------------------------------------------------
.BR "<PRE>" "\&" " .\|.\|. </PRE>" "\&"
.\"
.RS
.I "contained in:"
APPLET:\s-34L\s0\& BLOCKQUOTE BODY BQ:\s-33\s0\& BUTTON:\s-34L\s0\&
CENTER:\s-33.2,4C,4L,M\s0\& DD DEL:\s-34L\s0\& DIV:\s-33,3.2,4C,4L\s0\&
FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\& FORM IFRAME:\s-34L\s0\&
INS:\s-34L\s0\& LI NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& TD:\s-33,3.2,4C,4L\s0\& TH:\s-33,3.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
APPLET:\s-33.2,4C\s0\& AU:\s-33\s0\& B BASEFONT:\s-33.2,4C\s0\&
BDO:\s-34C,4L\s0\& BLINK:\s-3M\s0\& BR BUTTON:\s-34L\s0\& CITE CODE
DEL:\s-33\s0\& DFN:\s-33,3.2,4C,4L\s0\& EM FONT:\s-3M\s0\&
HR:\s-32,M\s0\& I IFRAME:\s-34L\s0\& INPUT:\s-33.2,4C,4L\s0\&
INS:\s-33\s0\& KBD LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\&
MAP:\s-33.2,4C,4L\s0\& OBJECT:\s-34C\s0\& PERSON:\s-33\s0\&
Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\& SAMP SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\& STRIKE:\s-33.2,4L\s0\&
STRONG STYLE:\s-34C\s0\& TEXTAREA:\s-33.2,4C,4L\s0\& TT
U:\s-33,3.2,4C,4L\s0\& VAR
.RE
.\"
.RS
.I "cannot contain:"
APPLET:\s-34L\s0\& BASEFONT:\s-34L\s0\& BIG:\s-33,3.2,4C,4L\s0\&
FONT:\s-33.2,4C,4L\s0\& IMG:\s-33,3.2,4C,4L\s0\& MATH:\s-33\s0\&
OBJECT:\s-34L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<Q>" " \s-3required:3,4C,4L\s0\&" " .\|.\|. </Q>" " \s-3required:3,4C,4L\s0\&"
.\"
.RS
.I "contained in:"
A:\s-33,4C,4L\s0\& ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
ADDRESS:\s-33,4C,4L\s0\& APPLET:\s-34L\s0\& AU:\s-33\s0\&
B:\s-33,4C,4L\s0\& BDO:\s-34C,4L\s0\& BIG:\s-33,4C,4L\s0\&
BLOCKQUOTE:\s-33,4C,4L\s0\& BODY:\s-33,4C,4L\s0\& BQ:\s-33\s0\&
BUTTON:\s-34L\s0\& CAPTION:\s-33,4C,4L\s0\& CENTER:\s-34C,4L\s0\&
CITE:\s-33,4C,4L\s0\& CODE:\s-33,4C,4L\s0\& CREDIT:\s-33\s0\&
DD:\s-33,4C,4L\s0\& DEL:\s-33,4L\s0\& DFN:\s-33,4C,4L\s0\&
DIV:\s-33,4C,4L\s0\& DT:\s-33,4C,4L\s0\& EM:\s-33,4C,4L\s0\&
FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\& FONT:\s-34C,4L\s0\&
FORM:\s-33,4C,4L\s0\& H1:\s-33,4C,4L\s0\& H2:\s-33,4C,4L\s0\&
H3:\s-33,4C,4L\s0\& H4:\s-33,4C,4L\s0\& H5:\s-33,4C,4L\s0\&
H6:\s-33,4C,4L\s0\& I:\s-33,4C,4L\s0\& IFRAME:\s-34L\s0\&
INS:\s-33,4L\s0\& KBD:\s-33,4C,4L\s0\& LABEL:\s-34C,4L\s0\&
LANG:\s-33\s0\& LEGEND:\s-34L\s0\& LH:\s-33\s0\& LI:\s-33,4C,4L\s0\&
NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\& OBJECT:\s-34C,4L\s0\&
P:\s-33,4C,4L\s0\& PERSON:\s-33\s0\& PRE:\s-33,4C,4L\s0\&
Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\& SAMP:\s-33,4C,4L\s0\&
SMALL:\s-33,4C,4L\s0\& SPAN:\s-34C,4L\s0\& STRIKE:\s-34L\s0\&
STRONG:\s-33,4C,4L\s0\& SUB:\s-33,4C,4L\s0\& SUP:\s-33,4C,4L\s0\&
TD:\s-33,4C,4L\s0\& TEXTFLOW:\s-34C\s0\& TH:\s-33,4C,4L\s0\&
TT:\s-33,4C,4L\s0\& U:\s-33,4C,4L\s0\& VAR:\s-33,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33,4C,4L\s0\& A:\s-33,4C,4L\s0\& ABBR:\s-34L\s0\&
ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& APPLET:\s-34C,4L\s0\& AU:\s-33\s0\&
B:\s-33,4C,4L\s0\& BASEFONT:\s-34C,4L\s0\& BDO:\s-34C,4L\s0\&
BIG:\s-33,4C,4L\s0\& BR:\s-33,4C,4L\s0\& BUTTON:\s-34L\s0\&
CITE:\s-33,4C,4L\s0\& CODE:\s-33,4C,4L\s0\& DEL:\s-33\s0\&
DFN:\s-33,4C,4L\s0\& EM:\s-33,4C,4L\s0\& FONT:\s-34C,4L\s0\&
I:\s-33,4C,4L\s0\& IFRAME:\s-34L\s0\& IMG:\s-33,4C,4L\s0\&
INPUT:\s-34C,4L\s0\& INS:\s-33\s0\& KBD:\s-33,4C,4L\s0\&
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& MAP:\s-34C,4L\s0\& MATH:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& PERSON:\s-33\s0\& Q:\s-33,4C,4L\s0\&
S:\s-33,4C,4L\s0\& SAMP:\s-33,4C,4L\s0\& SCRIPT:\s-34C,4L\s0\&
SELECT:\s-34C,4L\s0\& SMALL:\s-33,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-34L\s0\& STRONG:\s-33,4C,4L\s0\& STYLE:\s-34C\s0\&
SUB:\s-33,4C,4L\s0\& SUP:\s-33,4C,4L\s0\& TAB:\s-33\s0\&
TEXTAREA:\s-34C,4L\s0\& TT:\s-33,4C,4L\s0\& U:\s-33,4C,4L\s0\&
VAR:\s-33,4C,4L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<RIGHT>" " \s-3required:3\s0\&"
.\"
.RS
.I "contained in:"
BOX:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
EMPTY:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<ROOT>" " \s-3required:3\s0\&" " .\|.\|. </ROOT>" " \s-3required:3\s0\&"
.\"
.RS
.I "contained in:"
ABOVE:\s-33\s0\& BAR:\s-33\s0\& BELOW:\s-33\s0\& BOX:\s-33\s0\&
BT:\s-33\s0\& DDOT:\s-33\s0\& DOT:\s-33\s0\& HAT:\s-33\s0\&
ITEM:\s-33\s0\& MATH:\s-33\s0\& OF:\s-33\s0\& ROOT:\s-33\s0\&
SQRT:\s-33\s0\& T:\s-33\s0\& TILDE:\s-33\s0\& VEC:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33\s0\& ABOVE:\s-33\s0\& ARRAY:\s-33\s0\& B:\s-33\s0\&
BAR:\s-33\s0\& BELOW:\s-33\s0\& BOX:\s-33\s0\& BT:\s-33\s0\&
DDOT:\s-33\s0\& DOT:\s-33\s0\& HAT:\s-33\s0\& OF:\s-33\s0\&
ROOT:\s-33\s0\& SQRT:\s-33\s0\& SUB:\s-33\s0\& SUP:\s-33\s0\&
T:\s-33\s0\& TILDE:\s-33\s0\& VEC:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<ROW>" " \s-3required:3\s0\&" " .\|.\|. </ROW>" " \s-3optional:3\s0\&"
.\"
.RS
.I "contained in:"
ARRAY:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
ITEM:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<S>" " \s-3required:3,4C,4L\s0\&" " .\|.\|. </S>" " \s-3required:3,4C,4L\s0\&"
.\"
.RS
.I "contained in:"
A:\s-33,4C,4L\s0\& ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
ADDRESS:\s-33,4C,4L\s0\& APPLET:\s-34L\s0\& AU:\s-33\s0\&
B:\s-33,4C,4L\s0\& BDO:\s-34C,4L\s0\& BIG:\s-33,4C,4L\s0\&
BLOCKQUOTE:\s-33,4C,4L\s0\& BODY:\s-33,4C,4L\s0\& BQ:\s-33\s0\&
BUTTON:\s-34L\s0\& CAPTION:\s-33,4C,4L\s0\& CENTER:\s-34C,4L\s0\&
CITE:\s-33,4C,4L\s0\& CODE:\s-33,4C,4L\s0\& CREDIT:\s-33\s0\&
DD:\s-33,4C,4L\s0\& DEL:\s-33,4L\s0\& DFN:\s-33,4C,4L\s0\&
DIV:\s-33,4C,4L\s0\& DT:\s-33,4C,4L\s0\& EM:\s-33,4C,4L\s0\&
FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\& FONT:\s-34C,4L\s0\&
FORM:\s-33,4C,4L\s0\& H1:\s-33,4C,4L\s0\& H2:\s-33,4C,4L\s0\&
H3:\s-33,4C,4L\s0\& H4:\s-33,4C,4L\s0\& H5:\s-33,4C,4L\s0\&
H6:\s-33,4C,4L\s0\& I:\s-33,4C,4L\s0\& IFRAME:\s-34L\s0\&
INS:\s-33,4L\s0\& KBD:\s-33,4C,4L\s0\& LABEL:\s-34C,4L\s0\&
LANG:\s-33\s0\& LEGEND:\s-34L\s0\& LH:\s-33\s0\& LI:\s-33,4C,4L\s0\&
NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\& OBJECT:\s-34C,4L\s0\&
P:\s-33,4C,4L\s0\& PERSON:\s-33\s0\& PRE:\s-33,4C,4L\s0\&
Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\& SAMP:\s-33,4C,4L\s0\&
SMALL:\s-33,4C,4L\s0\& SPAN:\s-34C,4L\s0\& STRIKE:\s-34L\s0\&
STRONG:\s-33,4C,4L\s0\& SUB:\s-33,4C,4L\s0\& SUP:\s-33,4C,4L\s0\&
TD:\s-33,4C,4L\s0\& TEXTFLOW:\s-34C\s0\& TH:\s-33,4C,4L\s0\&
TT:\s-33,4C,4L\s0\& U:\s-33,4C,4L\s0\& VAR:\s-33,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33,4C,4L\s0\& A:\s-33,4C,4L\s0\& ABBR:\s-34L\s0\&
ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& APPLET:\s-34C,4L\s0\& AU:\s-33\s0\&
B:\s-33,4C,4L\s0\& BASEFONT:\s-34C,4L\s0\& BDO:\s-34C,4L\s0\&
BIG:\s-33,4C,4L\s0\& BR:\s-33,4C,4L\s0\& BUTTON:\s-34L\s0\&
CITE:\s-33,4C,4L\s0\& CODE:\s-33,4C,4L\s0\& DEL:\s-33\s0\&
DFN:\s-33,4C,4L\s0\& EM:\s-33,4C,4L\s0\& FONT:\s-34C,4L\s0\&
I:\s-33,4C,4L\s0\& IFRAME:\s-34L\s0\& IMG:\s-33,4C,4L\s0\&
INPUT:\s-34C,4L\s0\& INS:\s-33\s0\& KBD:\s-33,4C,4L\s0\&
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& MAP:\s-34C,4L\s0\& MATH:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& PERSON:\s-33\s0\& Q:\s-33,4C,4L\s0\&
S:\s-33,4C,4L\s0\& SAMP:\s-33,4C,4L\s0\& SCRIPT:\s-34C,4L\s0\&
SELECT:\s-34C,4L\s0\& SMALL:\s-33,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-34L\s0\& STRONG:\s-33,4C,4L\s0\& STYLE:\s-34C\s0\&
SUB:\s-33,4C,4L\s0\& SUP:\s-33,4C,4L\s0\& TAB:\s-33\s0\&
TEXTAREA:\s-34C,4L\s0\& TT:\s-33,4C,4L\s0\& U:\s-33,4C,4L\s0\&
VAR:\s-33,4C,4L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<SAMP>" "\&" " .\|.\|. </SAMP>" "\&"
.\"
.RS
.I "contained in:"
A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& ADDRESS
APPLET:\s-33.2,4L\s0\& AU:\s-33\s0\& B BDO:\s-34C,4L\s0\&
BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BLOCKQUOTE BODY BQ:\s-33\s0\&
BUTTON:\s-34L\s0\& CAPTION:\s-33,3.2,4C,4L\s0\&
CENTER:\s-33.2,4C,4L,M\s0\& CITE CODE CREDIT:\s-33\s0\& DD
DEL:\s-33,4L\s0\& DFN:\s-33,3.2,4C,4L\s0\& DIV:\s-33,3.2,4C,4L\s0\& DT
EM FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\& FONT:\s-33.2,4C,4L,M\s0\& FORM
H1 H2 H3 H4 H5 H6 I IFRAME:\s-34L\s0\& INS:\s-33,4L\s0\& KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& LEGEND:\s-34L\s0\& LH:\s-33\s0\& LI
NOBR:\s-3M\s0\& NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& P PERSON:\s-33\s0\& PRE Q:\s-33,4C,4L\s0\&
S:\s-33,4C,4L\s0\& SAMP SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TD:\s-33,3.2,4C,4L\s0\& TEXTFLOW:\s-34C\s0\&
TH:\s-33,3.2,4C,4L\s0\& TT U:\s-33,3.2,4C,4L\s0\& VAR
.RE
.\"
.RS
.I "contains:"
#PCDATA A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
APPLET:\s-33.2,4C,4L\s0\& AU:\s-33\s0\& B BASEFONT:\s-33.2,4C,4L,M\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BR
BUTTON:\s-34L\s0\& CENTER:\s-3M\s0\& CITE CODE DEL:\s-33\s0\&
DFN:\s-33,3.2,4C,4L\s0\& EM FONT:\s-33.2,4C,4L,M\s0\& I
IFRAME:\s-34L\s0\& IMG INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\& KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& MAP:\s-33.2,4C,4L\s0\&
MATH:\s-33\s0\& NOBR:\s-3M\s0\& OBJECT:\s-34C,4L\s0\& PERSON:\s-33\s0\&
Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\& SAMP SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG STYLE:\s-34C\s0\& SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\& TEXTAREA:\s-33.2,4C,4L\s0\& TT
U:\s-33,3.2,4C,4L\s0\& VAR WBR:\s-3M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<SCRIPT>" " \s-3required:3.2,4C,4L\s0\&" " .\|.\|. </SCRIPT>" " \s-3required:3.2,4C,4L\s0\&"
.\"
.RS
.I "contained in:"
A:\s-33.2,4C,4L\s0\& ABBR:\s-34L\s0\& ADDRESS:\s-33.2,4C,4L\s0\&
APPLET:\s-33.2,4L\s0\& B:\s-33.2,4C,4L\s0\& BDO:\s-34C,4L\s0\&
BIG:\s-33.2,4C,4L\s0\& BLOCKQUOTE:\s-33.2,4C,4L\s0\&
BODY:\s-33.2,4C,4L\s0\& BUTTON:\s-34L\s0\& CAPTION:\s-33.2,4C,4L\s0\&
CENTER:\s-33.2,4C,4L\s0\& CITE:\s-33.2,4C,4L\s0\&
CODE:\s-33.2,4C,4L\s0\& DD:\s-33.2,4C,4L\s0\& DEL:\s-34L\s0\&
DFN:\s-33.2,4C,4L\s0\& DIV:\s-33.2,4C,4L\s0\& DT:\s-33.2,4C,4L\s0\&
EM:\s-33.2,4C,4L\s0\& FIELDSET:\s-34C,4L\s0\& FONT:\s-33.2,4C,4L\s0\&
FORM:\s-33.2,4C,4L\s0\& H1:\s-33.2,4C,4L\s0\& H2:\s-33.2,4C,4L\s0\&
H3:\s-33.2,4C,4L\s0\& H4:\s-33.2,4C,4L\s0\& H5:\s-33.2,4C,4L\s0\&
H6:\s-33.2,4C,4L\s0\& HEAD:\s-33.2,4C,4L\s0\& I:\s-33.2,4C,4L\s0\&
IFRAME:\s-34L\s0\& INS:\s-34L\s0\& KBD:\s-33.2,4C,4L\s0\&
LABEL:\s-34C,4L\s0\& LEGEND:\s-34L\s0\& LI:\s-33.2,4C,4L\s0\&
NOSCRIPT:\s-34L\s0\& OBJECT:\s-34C,4L\s0\& P:\s-33.2,4C,4L\s0\&
PRE:\s-33.2,4C,4L\s0\& Q:\s-34C,4L\s0\& S:\s-34C,4L\s0\&
SAMP:\s-33.2,4C,4L\s0\& SMALL:\s-33.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG:\s-33.2,4C,4L\s0\& SUB:\s-33.2,4C,4L\s0\&
SUP:\s-33.2,4C,4L\s0\& TD:\s-33.2,4C,4L\s0\& TEXTFLOW:\s-34C\s0\&
TH:\s-33.2,4C,4L\s0\& TT:\s-33.2,4C,4L\s0\& U:\s-33.2,4C,4L\s0\&
VAR:\s-33.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
CDATA:\s-33.2,4C,4L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<SELECT>" "\&" " .\|.\|. </SELECT>" "\&"
.\"
.RS
.I "contained in:"
A:\s-33.2,4C,4L\s0\& ABBR:\s-34L\s0\& ADDRESS:\s-33.2,4C,4L\s0\&
APPLET:\s-33.2,4L\s0\& B:\s-33.2,4C,4L\s0\& BDO:\s-34C,4L\s0\&
BIG:\s-33.2,4C,4L\s0\& BLOCKQUOTE:\s-33.2,4C,4L\s0\&
BODY:\s-33.2,4C,4L\s0\& CAPTION:\s-33.2,4C,4L\s0\&
CENTER:\s-33.2,4C,4L\s0\& CITE:\s-33.2,4C,4L\s0\&
CODE:\s-33.2,4C,4L\s0\& DD:\s-33.2,4C,4L\s0\& DEL:\s-34L\s0\&
DFN:\s-33.2,4C,4L\s0\& DIV:\s-33.2,4C,4L\s0\& DT:\s-33.2,4C,4L\s0\&
EM:\s-33.2,4C,4L\s0\& FIELDSET:\s-34C,4L\s0\& FONT:\s-33.2,4C,4L\s0\&
FORM H1:\s-33.2,4C,4L\s0\& H2:\s-33.2,4C,4L\s0\& H3:\s-33.2,4C,4L\s0\&
H4:\s-33.2,4C,4L\s0\& H5:\s-33.2,4C,4L\s0\& H6:\s-33.2,4C,4L\s0\&
I:\s-33.2,4C,4L\s0\& IFRAME:\s-34L\s0\& INS:\s-34L\s0\&
KBD:\s-33.2,4C,4L\s0\& LABEL:\s-34C,4L\s0\& LEGEND:\s-34L\s0\&
LI:\s-33.2,4C,4L\s0\& NOSCRIPT:\s-34L\s0\& OBJECT:\s-34C,4L\s0\&
P:\s-33.2,4C,4L\s0\& PRE:\s-33.2,4C,4L\s0\& Q:\s-34C,4L\s0\&
S:\s-34C,4L\s0\& SAMP:\s-33.2,4C,4L\s0\& SMALL:\s-33.2,4C,4L\s0\&
SPAN:\s-34C,4L\s0\& STRIKE:\s-33.2,4L\s0\& STRONG:\s-33.2,4C,4L\s0\&
SUB:\s-33.2,4C,4L\s0\& SUP:\s-33.2,4C,4L\s0\& TD:\s-33.2,4C,4L\s0\&
TEXTFLOW:\s-34C\s0\& TH:\s-33.2,4C,4L\s0\& TT:\s-33.2,4C,4L\s0\&
U:\s-33.2,4C,4L\s0\& VAR:\s-33.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
OPTGROUP:\s-34L\s0\& OPTION
.RE
.\"
.RS
.I "cannot contain:"
INPUT:\s-33\s0\& SELECT:\s-33\s0\& TEXTAREA:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<SMALL>" " \s-3required:3,3.2,4C,4L\s0\&" " .\|.\|. </SMALL>" " \s-3required:3,3.2,4C,4L\s0\&"
.\"
.RS
.I "contained in:"
A:\s-33,3.2,4C,4L\s0\& ABBR:\s-34L\s0\& ABBREV:\s-33\s0\&
ACRONYM:\s-33\s0\& ADDRESS:\s-33,3.2,4C,4L\s0\& APPLET:\s-33.2,4L\s0\&
AU:\s-33\s0\& B:\s-33,3.2,4C,4L\s0\& BDO:\s-34C,4L\s0\&
BIG:\s-33,3.2,4C,4L\s0\& BLOCKQUOTE:\s-33,3.2,4C,4L\s0\&
BODY:\s-33,3.2,4C,4L\s0\& BQ:\s-33\s0\& BUTTON:\s-34L\s0\&
CAPTION:\s-33,3.2,4C,4L\s0\& CENTER:\s-33.2,4C,4L\s0\&
CITE:\s-33,3.2,4C,4L\s0\& CODE:\s-33,3.2,4C,4L\s0\& CREDIT:\s-33\s0\&
DD:\s-33,3.2,4C,4L\s0\& DEL:\s-33,4L\s0\& DFN:\s-33,3.2,4C,4L\s0\&
DIV:\s-33,3.2,4C,4L\s0\& DT:\s-33,3.2,4C,4L\s0\& EM:\s-33,3.2,4C,4L\s0\&
FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\& FONT:\s-33.2,4C,4L\s0\&
FORM:\s-33,3.2,4C,4L\s0\& H1:\s-33,3.2,4C,4L\s0\&
H2:\s-33,3.2,4C,4L\s0\& H3:\s-33,3.2,4C,4L\s0\& H4:\s-33,3.2,4C,4L\s0\&
H5:\s-33,3.2,4C,4L\s0\& H6:\s-33,3.2,4C,4L\s0\& I:\s-33,3.2,4C,4L\s0\&
IFRAME:\s-34L\s0\& INS:\s-33,4L\s0\& KBD:\s-33,3.2,4C,4L\s0\&
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& LEGEND:\s-34L\s0\& LH:\s-33\s0\&
LI:\s-33,3.2,4C,4L\s0\& NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& P:\s-33,3.2,4C,4L\s0\& PERSON:\s-33\s0\&
Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\& SAMP:\s-33,3.2,4C,4L\s0\&
SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\& STRIKE:\s-33.2,4L\s0\&
STRONG:\s-33,3.2,4C,4L\s0\& SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TD:\s-33,3.2,4C,4L\s0\& TEXTFLOW:\s-34C\s0\&
TH:\s-33,3.2,4C,4L\s0\& TT:\s-33,3.2,4C,4L\s0\& U:\s-33,3.2,4C,4L\s0\&
VAR:\s-33,3.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33,3.2,4C,4L\s0\& A:\s-33,3.2,4C,4L\s0\& ABBR:\s-34L\s0\&
ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& APPLET:\s-33.2,4C,4L\s0\&
AU:\s-33\s0\& B:\s-33,3.2,4C,4L\s0\& BASEFONT:\s-33.2,4C,4L\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\& BR:\s-33,3.2,4C,4L\s0\&
BUTTON:\s-34L\s0\& CITE:\s-33,3.2,4C,4L\s0\& CODE:\s-33,3.2,4C,4L\s0\&
DEL:\s-33\s0\& DFN:\s-33,3.2,4C,4L\s0\& EM:\s-33,3.2,4C,4L\s0\&
FONT:\s-33.2,4C,4L\s0\& I:\s-33,3.2,4C,4L\s0\& IFRAME:\s-34L\s0\&
IMG:\s-33,3.2,4C,4L\s0\& INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\&
KBD:\s-33,3.2,4C,4L\s0\& LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\&
MAP:\s-33.2,4C,4L\s0\& MATH:\s-33\s0\& OBJECT:\s-34C,4L\s0\&
PERSON:\s-33\s0\& Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\&
SAMP:\s-33,3.2,4C,4L\s0\& SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG:\s-33,3.2,4C,4L\s0\& STYLE:\s-34C\s0\&
SUB:\s-33,3.2,4C,4L\s0\& SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\&
TEXTAREA:\s-33.2,4C,4L\s0\& TT:\s-33,3.2,4C,4L\s0\&
U:\s-33,3.2,4C,4L\s0\& VAR:\s-33,3.2,4C,4L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<SPAN>" " \s-3required:4C,4L\s0\&" " .\|.\|. </SPAN>" " \s-3required:4C,4L\s0\&"
.\"
.RS
.I "contained in:"
A:\s-34C,4L\s0\& ABBR:\s-34L\s0\& ADDRESS:\s-34C,4L\s0\&
APPLET:\s-34L\s0\& B:\s-34C,4L\s0\& BDO:\s-34C,4L\s0\&
BIG:\s-34C,4L\s0\& BLOCKQUOTE:\s-34C,4L\s0\& BODY:\s-34C,4L\s0\&
BUTTON:\s-34L\s0\& CAPTION:\s-34C,4L\s0\& CENTER:\s-34C,4L\s0\&
CITE:\s-34C,4L\s0\& CODE:\s-34C,4L\s0\& DD:\s-34C,4L\s0\&
DEL:\s-34L\s0\& DFN:\s-34C,4L\s0\& DIV:\s-34C,4L\s0\& DT:\s-34C,4L\s0\&
EM:\s-34C,4L\s0\& FIELDSET:\s-34C,4L\s0\& FONT:\s-34C,4L\s0\&
FORM:\s-34C,4L\s0\& H1:\s-34C,4L\s0\& H2:\s-34C,4L\s0\&
H3:\s-34C,4L\s0\& H4:\s-34C,4L\s0\& H5:\s-34C,4L\s0\& H6:\s-34C,4L\s0\&
I:\s-34C,4L\s0\& IFRAME:\s-34L\s0\& INS:\s-34L\s0\& KBD:\s-34C,4L\s0\&
LABEL:\s-34C,4L\s0\& LEGEND:\s-34L\s0\& LI:\s-34C,4L\s0\&
NOSCRIPT:\s-34L\s0\& OBJECT:\s-34C,4L\s0\& P:\s-34C,4L\s0\&
PRE:\s-34C,4L\s0\& Q:\s-34C,4L\s0\& S:\s-34C,4L\s0\& SAMP:\s-34C,4L\s0\&
SMALL:\s-34C,4L\s0\& SPAN:\s-34C,4L\s0\& STRIKE:\s-34L\s0\&
STRONG:\s-34C,4L\s0\& SUB:\s-34C,4L\s0\& SUP:\s-34C,4L\s0\&
TD:\s-34C,4L\s0\& TEXTFLOW:\s-34C\s0\& TH:\s-34C,4L\s0\&
TT:\s-34C,4L\s0\& U:\s-34C,4L\s0\& VAR:\s-34C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-34C,4L\s0\& A:\s-34C,4L\s0\& ABBR:\s-34L\s0\&
APPLET:\s-34C,4L\s0\& B:\s-34C,4L\s0\& BASEFONT:\s-34C,4L\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-34C,4L\s0\& BR:\s-34C,4L\s0\&
BUTTON:\s-34L\s0\& CITE:\s-34C,4L\s0\& CODE:\s-34C,4L\s0\&
DFN:\s-34C,4L\s0\& EM:\s-34C,4L\s0\& FONT:\s-34C,4L\s0\&
I:\s-34C,4L\s0\& IFRAME:\s-34L\s0\& IMG:\s-34C,4L\s0\&
INPUT:\s-34C,4L\s0\& KBD:\s-34C,4L\s0\& LABEL:\s-34C,4L\s0\&
MAP:\s-34C,4L\s0\& OBJECT:\s-34C,4L\s0\& Q:\s-34C,4L\s0\&
S:\s-34C,4L\s0\& SAMP:\s-34C,4L\s0\& SCRIPT:\s-34C,4L\s0\&
SELECT:\s-34C,4L\s0\& SMALL:\s-34C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-34L\s0\& STRONG:\s-34C,4L\s0\& STYLE:\s-34C\s0\&
SUB:\s-34C,4L\s0\& SUP:\s-34C,4L\s0\& TEXTAREA:\s-34C,4L\s0\&
TT:\s-34C,4L\s0\& U:\s-34C,4L\s0\& VAR:\s-34C,4L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<SQRT>" " \s-3required:3\s0\&" " .\|.\|. </SQRT>" " \s-3required:3\s0\&"
.\"
.RS
.I "contained in:"
ABOVE:\s-33\s0\& BAR:\s-33\s0\& BELOW:\s-33\s0\& BOX:\s-33\s0\&
BT:\s-33\s0\& DDOT:\s-33\s0\& DOT:\s-33\s0\& HAT:\s-33\s0\&
ITEM:\s-33\s0\& MATH:\s-33\s0\& OF:\s-33\s0\& ROOT:\s-33\s0\&
SQRT:\s-33\s0\& T:\s-33\s0\& TILDE:\s-33\s0\& VEC:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33\s0\& ABOVE:\s-33\s0\& ARRAY:\s-33\s0\& B:\s-33\s0\&
BAR:\s-33\s0\& BELOW:\s-33\s0\& BOX:\s-33\s0\& BT:\s-33\s0\&
DDOT:\s-33\s0\& DOT:\s-33\s0\& HAT:\s-33\s0\& ROOT:\s-33\s0\&
SQRT:\s-33\s0\& SUB:\s-33\s0\& SUP:\s-33\s0\& T:\s-33\s0\&
TILDE:\s-33\s0\& VEC:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<STRIKE>" " \s-3required:3.2,4L\s0\&" " .\|.\|. </STRIKE>" " \s-3required:3.2,4L\s0\&"
.\"
.RS
.I "contained in:"
A:\s-33.2,4L\s0\& ABBR:\s-34L\s0\& ADDRESS:\s-33.2,4L\s0\&
APPLET:\s-33.2,4L\s0\& B:\s-33.2,4L\s0\& BDO:\s-34L\s0\&
BIG:\s-33.2,4L\s0\& BLOCKQUOTE:\s-33.2,4L\s0\& BODY:\s-33.2,4L\s0\&
BUTTON:\s-34L\s0\& CAPTION:\s-33.2,4L\s0\& CENTER:\s-33.2,4L\s0\&
CITE:\s-33.2,4L\s0\& CODE:\s-33.2,4L\s0\& DD:\s-33.2,4L\s0\&
DEL:\s-34L\s0\& DFN:\s-33.2,4L\s0\& DIV:\s-33.2,4L\s0\&
DT:\s-33.2,4L\s0\& EM:\s-33.2,4L\s0\& FIELDSET:\s-34L\s0\&
FONT:\s-33.2,4L\s0\& FORM:\s-33.2,4L\s0\& H1:\s-33.2,4L\s0\&
H2:\s-33.2,4L\s0\& H3:\s-33.2,4L\s0\& H4:\s-33.2,4L\s0\&
H5:\s-33.2,4L\s0\& H6:\s-33.2,4L\s0\& I:\s-33.2,4L\s0\&
IFRAME:\s-34L\s0\& INS:\s-34L\s0\& KBD:\s-33.2,4L\s0\& LABEL:\s-34L\s0\&
LEGEND:\s-34L\s0\& LI:\s-33.2,4L\s0\& NOSCRIPT:\s-34L\s0\&
OBJECT:\s-34L\s0\& P:\s-33.2,4L\s0\& PRE:\s-33.2,4L\s0\& Q:\s-34L\s0\&
S:\s-34L\s0\& SAMP:\s-33.2,4L\s0\& SMALL:\s-33.2,4L\s0\&
SPAN:\s-34L\s0\& STRIKE:\s-33.2,4L\s0\& STRONG:\s-33.2,4L\s0\&
SUB:\s-33.2,4L\s0\& SUP:\s-33.2,4L\s0\& TD:\s-33.2,4L\s0\&
TH:\s-33.2,4L\s0\& TT:\s-33.2,4L\s0\& U:\s-33.2,4L\s0\&
VAR:\s-33.2,4L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33.2,4L\s0\& A:\s-33.2,4L\s0\& ABBR:\s-34L\s0\&
APPLET:\s-33.2,4L\s0\& B:\s-33.2,4L\s0\& BASEFONT:\s-33.2,4L\s0\&
BDO:\s-34L\s0\& BIG:\s-33.2,4L\s0\& BR:\s-33.2,4L\s0\&
BUTTON:\s-34L\s0\& CITE:\s-33.2,4L\s0\& CODE:\s-33.2,4L\s0\&
DFN:\s-33.2,4L\s0\& EM:\s-33.2,4L\s0\& FONT:\s-33.2,4L\s0\&
I:\s-33.2,4L\s0\& IFRAME:\s-34L\s0\& IMG:\s-33.2,4L\s0\&
INPUT:\s-33.2,4L\s0\& KBD:\s-33.2,4L\s0\& LABEL:\s-34L\s0\&
MAP:\s-33.2,4L\s0\& OBJECT:\s-34L\s0\& Q:\s-34L\s0\& S:\s-34L\s0\&
SAMP:\s-33.2,4L\s0\& SCRIPT:\s-33.2,4L\s0\& SELECT:\s-33.2,4L\s0\&
SMALL:\s-33.2,4L\s0\& SPAN:\s-34L\s0\& STRIKE:\s-33.2,4L\s0\&
STRONG:\s-33.2,4L\s0\& SUB:\s-33.2,4L\s0\& SUP:\s-33.2,4L\s0\&
TEXTAREA:\s-33.2,4L\s0\& TT:\s-33.2,4L\s0\& U:\s-33.2,4L\s0\&
VAR:\s-33.2,4L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<STRONG>" "\&" " .\|.\|. </STRONG>" "\&"
.\"
.RS
.I "contained in:"
A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& ADDRESS
APPLET:\s-33.2,4L\s0\& AU:\s-33\s0\& B BDO:\s-34C,4L\s0\&
BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BLOCKQUOTE BODY BQ:\s-33\s0\&
BUTTON:\s-34L\s0\& CAPTION:\s-33,3.2,4C,4L\s0\&
CENTER:\s-33.2,4C,4L,M\s0\& CITE CODE CREDIT:\s-33\s0\& DD
DEL:\s-33,4L\s0\& DFN:\s-33,3.2,4C,4L\s0\& DIV:\s-33,3.2,4C,4L\s0\& DT
EM FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\& FONT:\s-33.2,4C,4L,M\s0\& FORM
H1 H2 H3 H4 H5 H6 I IFRAME:\s-34L\s0\& INS:\s-33,4L\s0\& KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& LEGEND:\s-34L\s0\& LH:\s-33\s0\& LI
NOBR:\s-3M\s0\& NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& P PERSON:\s-33\s0\& PRE Q:\s-33,4C,4L\s0\&
S:\s-33,4C,4L\s0\& SAMP SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TD:\s-33,3.2,4C,4L\s0\& TEXTFLOW:\s-34C\s0\&
TH:\s-33,3.2,4C,4L\s0\& TT U:\s-33,3.2,4C,4L\s0\& VAR
.RE
.\"
.RS
.I "contains:"
#PCDATA A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
APPLET:\s-33.2,4C,4L\s0\& AU:\s-33\s0\& B BASEFONT:\s-33.2,4C,4L,M\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BR
BUTTON:\s-34L\s0\& CENTER:\s-3M\s0\& CITE CODE DEL:\s-33\s0\&
DFN:\s-33,3.2,4C,4L\s0\& EM FONT:\s-33.2,4C,4L,M\s0\& I
IFRAME:\s-34L\s0\& IMG INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\& KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& MAP:\s-33.2,4C,4L\s0\&
MATH:\s-33\s0\& NOBR:\s-3M\s0\& OBJECT:\s-34C,4L\s0\& PERSON:\s-33\s0\&
Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\& SAMP SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG STYLE:\s-34C\s0\& SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\& TEXTAREA:\s-33.2,4C,4L\s0\& TT
U:\s-33,3.2,4C,4L\s0\& VAR WBR:\s-3M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<STYLE>" " \s-3required:3,3.2,4C,4L\s0\&" " .\|.\|. </STYLE>" " \s-3required:3.2,4C,4L optional:3\s0\&"
.\"
.RS
.I "contained in:"
A:\s-34C\s0\& ADDRESS:\s-34C\s0\& B:\s-34C\s0\& BDO:\s-34C\s0\&
BIG:\s-34C\s0\& BLOCKQUOTE:\s-34C\s0\& BODY:\s-34C\s0\&
CAPTION:\s-34C\s0\& CENTER:\s-34C\s0\& CITE:\s-34C\s0\& CODE:\s-34C\s0\&
DD:\s-34C\s0\& DFN:\s-34C\s0\& DIV:\s-34C\s0\& DT:\s-34C\s0\&
EM:\s-34C\s0\& FIELDSET:\s-34C\s0\& FONT:\s-34C\s0\& FORM:\s-34C\s0\&
H1:\s-34C\s0\& H2:\s-34C\s0\& H3:\s-34C\s0\& H4:\s-34C\s0\&
H5:\s-34C\s0\& H6:\s-34C\s0\& HEAD:\s-33,3.2,4C,4L\s0\& I:\s-34C\s0\&
KBD:\s-34C\s0\& LABEL:\s-34C\s0\& LI:\s-34C\s0\& OBJECT:\s-34C\s0\&
P:\s-34C\s0\& PRE:\s-34C\s0\& Q:\s-34C\s0\& S:\s-34C\s0\&
SAMP:\s-34C\s0\& SMALL:\s-34C\s0\& SPAN:\s-34C\s0\& STRONG:\s-34C\s0\&
SUB:\s-34C\s0\& SUP:\s-34C\s0\& TD:\s-34C\s0\& TEXTFLOW:\s-34C\s0\&
TH:\s-34C\s0\& TT:\s-34C\s0\& U:\s-34C\s0\& VAR:\s-34C\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33\s0\& CDATA:\s-33.2,4C,4L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<SUB>" " \s-3required:3,3.2,4C,4L\s0\&" " .\|.\|. </SUB>" " \s-3required:3,3.2,4C,4L\s0\&"
.\"
.RS
.I "contained in:"
A:\s-33,3.2,4C,4L\s0\& ABBR:\s-34L\s0\& ABBREV:\s-33\s0\&
ABOVE:\s-33\s0\& ACRONYM:\s-33\s0\& ADDRESS:\s-33,3.2,4C,4L\s0\&
APPLET:\s-33.2,4L\s0\& AU:\s-33\s0\& B:\s-33,3.2,4C,4L\s0\&
BAR:\s-33\s0\& BDO:\s-34C,4L\s0\& BELOW:\s-33\s0\&
BIG:\s-33,3.2,4C,4L\s0\& BLOCKQUOTE:\s-33,3.2,4C,4L\s0\&
BODY:\s-33,3.2,4C,4L\s0\& BOX:\s-33\s0\& BQ:\s-33\s0\& BT:\s-33\s0\&
BUTTON:\s-34L\s0\& CAPTION:\s-33,3.2,4C,4L\s0\&
CENTER:\s-33.2,4C,4L\s0\& CITE:\s-33,3.2,4C,4L\s0\&
CODE:\s-33,3.2,4C,4L\s0\& CREDIT:\s-33\s0\& DD:\s-33,3.2,4C,4L\s0\&
DDOT:\s-33\s0\& DEL:\s-33,4L\s0\& DFN:\s-33,3.2,4C,4L\s0\&
DIV:\s-33,3.2,4C,4L\s0\& DOT:\s-33\s0\& DT:\s-33,3.2,4C,4L\s0\&
EM:\s-33,3.2,4C,4L\s0\& FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\&
FONT:\s-33.2,4C,4L\s0\& FORM:\s-33,3.2,4C,4L\s0\&
H1:\s-33,3.2,4C,4L\s0\& H2:\s-33,3.2,4C,4L\s0\& H3:\s-33,3.2,4C,4L\s0\&
H4:\s-33,3.2,4C,4L\s0\& H5:\s-33,3.2,4C,4L\s0\& H6:\s-33,3.2,4C,4L\s0\&
HAT:\s-33\s0\& I:\s-33,3.2,4C,4L\s0\& IFRAME:\s-34L\s0\&
INS:\s-33,4L\s0\& ITEM:\s-33\s0\& KBD:\s-33,3.2,4C,4L\s0\&
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& LEGEND:\s-34L\s0\& LH:\s-33\s0\&
LI:\s-33,3.2,4C,4L\s0\& MATH:\s-33\s0\& NOSCRIPT:\s-34L\s0\&
NOTE:\s-33\s0\& OBJECT:\s-34C,4L\s0\& OF:\s-33\s0\&
P:\s-33,3.2,4C,4L\s0\& PERSON:\s-33\s0\& Q:\s-33,4C,4L\s0\&
ROOT:\s-33\s0\& S:\s-33,4C,4L\s0\& SAMP:\s-33,3.2,4C,4L\s0\&
SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\& SQRT:\s-33\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG:\s-33,3.2,4C,4L\s0\&
SUB:\s-33,3.2,4C,4L\s0\& SUP:\s-33,3.2,4C,4L\s0\& T:\s-33\s0\&
TD:\s-33,3.2,4C,4L\s0\& TEXTFLOW:\s-34C\s0\& TH:\s-33,3.2,4C,4L\s0\&
TILDE:\s-33\s0\& TT:\s-33,3.2,4C,4L\s0\& U:\s-33,3.2,4C,4L\s0\&
VAR:\s-33,3.2,4C,4L\s0\& VEC:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33,3.2,4C,4L\s0\& A:\s-33,3.2,4C,4L\s0\& ABBR:\s-34L\s0\&
ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& APPLET:\s-33.2,4C,4L\s0\&
AU:\s-33\s0\& B:\s-33,3.2,4C,4L\s0\& BASEFONT:\s-33.2,4C,4L\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\& BR:\s-33,3.2,4C,4L\s0\&
BUTTON:\s-34L\s0\& CITE:\s-33,3.2,4C,4L\s0\& CODE:\s-33,3.2,4C,4L\s0\&
DEL:\s-33\s0\& DFN:\s-33,3.2,4C,4L\s0\& EM:\s-33,3.2,4C,4L\s0\&
FONT:\s-33.2,4C,4L\s0\& I:\s-33,3.2,4C,4L\s0\& IFRAME:\s-34L\s0\&
IMG:\s-33,3.2,4C,4L\s0\& INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\&
KBD:\s-33,3.2,4C,4L\s0\& LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\&
MAP:\s-33.2,4C,4L\s0\& MATH:\s-33\s0\& OBJECT:\s-34C,4L\s0\&
PERSON:\s-33\s0\& Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\&
SAMP:\s-33,3.2,4C,4L\s0\& SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG:\s-33,3.2,4C,4L\s0\& STYLE:\s-34C\s0\&
SUB:\s-33,3.2,4C,4L\s0\& SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\&
TEXTAREA:\s-33.2,4C,4L\s0\& TT:\s-33,3.2,4C,4L\s0\&
U:\s-33,3.2,4C,4L\s0\& VAR:\s-33,3.2,4C,4L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<SUP>" " \s-3required:3,3.2,4C,4L\s0\&" " .\|.\|. </SUP>" " \s-3required:3,3.2,4C,4L\s0\&"
.\"
.RS
.I "contained in:"
A:\s-33,3.2,4C,4L\s0\& ABBR:\s-34L\s0\& ABBREV:\s-33\s0\&
ABOVE:\s-33\s0\& ACRONYM:\s-33\s0\& ADDRESS:\s-33,3.2,4C,4L\s0\&
APPLET:\s-33.2,4L\s0\& AU:\s-33\s0\& B:\s-33,3.2,4C,4L\s0\&
BAR:\s-33\s0\& BDO:\s-34C,4L\s0\& BELOW:\s-33\s0\&
BIG:\s-33,3.2,4C,4L\s0\& BLOCKQUOTE:\s-33,3.2,4C,4L\s0\&
BODY:\s-33,3.2,4C,4L\s0\& BOX:\s-33\s0\& BQ:\s-33\s0\& BT:\s-33\s0\&
BUTTON:\s-34L\s0\& CAPTION:\s-33,3.2,4C,4L\s0\&
CENTER:\s-33.2,4C,4L\s0\& CITE:\s-33,3.2,4C,4L\s0\&
CODE:\s-33,3.2,4C,4L\s0\& CREDIT:\s-33\s0\& DD:\s-33,3.2,4C,4L\s0\&
DDOT:\s-33\s0\& DEL:\s-33,4L\s0\& DFN:\s-33,3.2,4C,4L\s0\&
DIV:\s-33,3.2,4C,4L\s0\& DOT:\s-33\s0\& DT:\s-33,3.2,4C,4L\s0\&
EM:\s-33,3.2,4C,4L\s0\& FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\&
FONT:\s-33.2,4C,4L\s0\& FORM:\s-33,3.2,4C,4L\s0\&
H1:\s-33,3.2,4C,4L\s0\& H2:\s-33,3.2,4C,4L\s0\& H3:\s-33,3.2,4C,4L\s0\&
H4:\s-33,3.2,4C,4L\s0\& H5:\s-33,3.2,4C,4L\s0\& H6:\s-33,3.2,4C,4L\s0\&
HAT:\s-33\s0\& I:\s-33,3.2,4C,4L\s0\& IFRAME:\s-34L\s0\&
INS:\s-33,4L\s0\& ITEM:\s-33\s0\& KBD:\s-33,3.2,4C,4L\s0\&
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& LEGEND:\s-34L\s0\& LH:\s-33\s0\&
LI:\s-33,3.2,4C,4L\s0\& MATH:\s-33\s0\& NOSCRIPT:\s-34L\s0\&
NOTE:\s-33\s0\& OBJECT:\s-34C,4L\s0\& OF:\s-33\s0\&
P:\s-33,3.2,4C,4L\s0\& PERSON:\s-33\s0\& Q:\s-33,4C,4L\s0\&
ROOT:\s-33\s0\& S:\s-33,4C,4L\s0\& SAMP:\s-33,3.2,4C,4L\s0\&
SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\& SQRT:\s-33\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG:\s-33,3.2,4C,4L\s0\&
SUB:\s-33,3.2,4C,4L\s0\& SUP:\s-33,3.2,4C,4L\s0\& T:\s-33\s0\&
TD:\s-33,3.2,4C,4L\s0\& TEXTFLOW:\s-34C\s0\& TH:\s-33,3.2,4C,4L\s0\&
TILDE:\s-33\s0\& TT:\s-33,3.2,4C,4L\s0\& U:\s-33,3.2,4C,4L\s0\&
VAR:\s-33,3.2,4C,4L\s0\& VEC:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33,3.2,4C,4L\s0\& A:\s-33,3.2,4C,4L\s0\& ABBR:\s-34L\s0\&
ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& APPLET:\s-33.2,4C,4L\s0\&
AU:\s-33\s0\& B:\s-33,3.2,4C,4L\s0\& BASEFONT:\s-33.2,4C,4L\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\& BR:\s-33,3.2,4C,4L\s0\&
BUTTON:\s-34L\s0\& CITE:\s-33,3.2,4C,4L\s0\& CODE:\s-33,3.2,4C,4L\s0\&
DEL:\s-33\s0\& DFN:\s-33,3.2,4C,4L\s0\& EM:\s-33,3.2,4C,4L\s0\&
FONT:\s-33.2,4C,4L\s0\& I:\s-33,3.2,4C,4L\s0\& IFRAME:\s-34L\s0\&
IMG:\s-33,3.2,4C,4L\s0\& INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\&
KBD:\s-33,3.2,4C,4L\s0\& LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\&
MAP:\s-33.2,4C,4L\s0\& MATH:\s-33\s0\& OBJECT:\s-34C,4L\s0\&
PERSON:\s-33\s0\& Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\&
SAMP:\s-33,3.2,4C,4L\s0\& SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG:\s-33,3.2,4C,4L\s0\& STYLE:\s-34C\s0\&
SUB:\s-33,3.2,4C,4L\s0\& SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\&
TEXTAREA:\s-33.2,4C,4L\s0\& TT:\s-33,3.2,4C,4L\s0\&
U:\s-33,3.2,4C,4L\s0\& VAR:\s-33,3.2,4C,4L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<T>" " \s-3required:3\s0\&" " .\|.\|. </T>" " \s-3required:3\s0\&"
.\"
.RS
.I "contained in:"
ABOVE:\s-33\s0\& BAR:\s-33\s0\& BELOW:\s-33\s0\& BOX:\s-33\s0\&
BT:\s-33\s0\& DDOT:\s-33\s0\& DOT:\s-33\s0\& HAT:\s-33\s0\&
ITEM:\s-33\s0\& MATH:\s-33\s0\& OF:\s-33\s0\& ROOT:\s-33\s0\&
SQRT:\s-33\s0\& T:\s-33\s0\& TILDE:\s-33\s0\& VEC:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33\s0\& ABOVE:\s-33\s0\& ARRAY:\s-33\s0\& B:\s-33\s0\&
BAR:\s-33\s0\& BELOW:\s-33\s0\& BOX:\s-33\s0\& BT:\s-33\s0\&
DDOT:\s-33\s0\& DOT:\s-33\s0\& HAT:\s-33\s0\& ROOT:\s-33\s0\&
SQRT:\s-33\s0\& SUB:\s-33\s0\& SUP:\s-33\s0\& T:\s-33\s0\&
TILDE:\s-33\s0\& VEC:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<TAB>" " \s-3required:3\s0\&"
.\"
.RS
.I "contained in:"
A:\s-33\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& ADDRESS:\s-33\s0\&
AU:\s-33\s0\& B:\s-33\s0\& BIG:\s-33\s0\& BLOCKQUOTE:\s-33\s0\&
BODY:\s-33\s0\& BQ:\s-33\s0\& CAPTION:\s-33\s0\& CITE:\s-33\s0\&
CODE:\s-33\s0\& CREDIT:\s-33\s0\& DD:\s-33\s0\& DEL:\s-33\s0\&
DFN:\s-33\s0\& DIV:\s-33\s0\& DT:\s-33\s0\& EM:\s-33\s0\& FIG:\s-33\s0\&
FORM:\s-33\s0\& H1:\s-33\s0\& H2:\s-33\s0\& H3:\s-33\s0\& H4:\s-33\s0\&
H5:\s-33\s0\& H6:\s-33\s0\& I:\s-33\s0\& INS:\s-33\s0\& KBD:\s-33\s0\&
LANG:\s-33\s0\& LH:\s-33\s0\& LI:\s-33\s0\& NOTE:\s-33\s0\& P:\s-33\s0\&
PERSON:\s-33\s0\& Q:\s-33\s0\& S:\s-33\s0\& SAMP:\s-33\s0\&
SMALL:\s-33\s0\& STRONG:\s-33\s0\& SUB:\s-33\s0\& SUP:\s-33\s0\&
TD:\s-33\s0\& TH:\s-33\s0\& TT:\s-33\s0\& U:\s-33\s0\& VAR:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
EMPTY:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<TABLE>" " \s-3required:3,3.2,4C,4L\s0\&" " .\|.\|. </TABLE>" " \s-3required:3,3.2,4C,4L\s0\&"
.\"
.RS
.I "contained in:"
APPLET:\s-34L\s0\& BLOCKQUOTE:\s-33,3.2,4C,4L\s0\&
BODY:\s-33,3.2,4C,4L\s0\& BQ:\s-33\s0\& BUTTON:\s-34L\s0\&
CENTER:\s-33.2,4C,4L\s0\& DD:\s-33,3.2,4C,4L\s0\& DEL:\s-34L\s0\&
DIV:\s-33,3.2,4C,4L\s0\& FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\&
FORM:\s-33,3.2,4C,4L\s0\& IFRAME:\s-34L\s0\& INS:\s-34L\s0\&
LI:\s-33,3.2,4C,4L\s0\& NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& TD:\s-33,3.2,4C,4L\s0\& TH:\s-33,3.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
CAPTION:\s-33,3.2,4C,4L\s0\& COL:\s-34C,4L\s0\& COLGROUP:\s-34C,4L\s0\&
TBODY:\s-34C,4L\s0\& TFOOT:\s-34C,4L\s0\& THEAD:\s-34C,4L\s0\&
TR:\s-33,3.2\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<TBODY>" " \s-3optional:4C,4L\s0\&" " .\|.\|. </TBODY>" " \s-3optional:4C,4L\s0\&"
.\"
.RS
.I "contained in:"
TABLE:\s-34C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
TR:\s-34C,4L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<TD>" " \s-3required:3,3.2,4C,4L\s0\&" " .\|.\|. </TD>" " \s-3optional:3,3.2,4C,4L\s0\&"
.\"
.RS
.I "contained in:"
TR:\s-33,3.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33,3.2,4C,4L\s0\& A:\s-33,3.2,4C,4L\s0\& ABBR:\s-34L\s0\&
ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& ADDRESS:\s-33,3.2,4C,4L\s0\&
APPLET:\s-33.2,4C,4L\s0\& AU:\s-33\s0\& B:\s-33,3.2,4C,4L\s0\&
BASEFONT:\s-33.2,4C,4L\s0\& BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\&
BLOCKQUOTE:\s-33,3.2,4C,4L\s0\& BQ:\s-33\s0\& BR:\s-33,3.2,4C,4L\s0\&
BUTTON:\s-34L\s0\& CENTER:\s-33.2,4C,4L\s0\& CITE:\s-33,3.2,4C,4L\s0\&
CODE:\s-33,3.2,4C,4L\s0\& DEL:\s-33\s0\& DFN:\s-33,3.2,4C,4L\s0\&
DIR:\s-33,3.2,4C,4L\s0\& DIV:\s-33,3.2,4C,4L\s0\&
DL:\s-33,3.2,4C,4L\s0\& EM:\s-33,3.2,4C,4L\s0\& FIELDSET:\s-34C,4L\s0\&
FIG:\s-33\s0\& FONT:\s-33.2,4C,4L\s0\& FORM:\s-33,3.2,4C,4L\s0\&
H1:\s-33,3.2,4C,4L\s0\& H2:\s-33,3.2,4C,4L\s0\& H3:\s-33,3.2,4C,4L\s0\&
H4:\s-33,3.2,4C,4L\s0\& H5:\s-33,3.2,4C,4L\s0\& H6:\s-33,3.2,4C,4L\s0\&
HR:\s-33,3.2,4C,4L\s0\& I:\s-33,3.2,4C,4L\s0\& IFRAME:\s-34L\s0\&
IMG:\s-33,3.2,4C,4L\s0\& INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\&
ISINDEX:\s-33,3.2,4C,4L\s0\& KBD:\s-33,3.2,4C,4L\s0\&
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& LISTING:\s-33,3.2,4C\s0\&
MAP:\s-33.2,4C,4L\s0\& MATH:\s-33\s0\& MENU:\s-33,3.2,4C,4L\s0\&
NOFRAMES:\s-34L\s0\& NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& OL:\s-33,3.2,4C,4L\s0\& P:\s-33,3.2,4C,4L\s0\&
PERSON:\s-33\s0\& PRE:\s-33,3.2,4C,4L\s0\& Q:\s-33,4C,4L\s0\&
S:\s-33,4C,4L\s0\& SAMP:\s-33,3.2,4C,4L\s0\& SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG:\s-33,3.2,4C,4L\s0\& STYLE:\s-34C\s0\&
SUB:\s-33,3.2,4C,4L\s0\& SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\&
TABLE:\s-33,3.2,4C,4L\s0\& TEXTAREA:\s-33.2,4C,4L\s0\&
TT:\s-33,3.2,4C,4L\s0\& U:\s-33,3.2,4C,4L\s0\& UL:\s-33,3.2,4C,4L\s0\&
VAR:\s-33,3.2,4C,4L\s0\& XMP:\s-33,3.2,4C\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<TEXTAREA>" "\&" " .\|.\|. </TEXTAREA>" "\&"
.\"
.RS
.I "contained in:"
A:\s-33.2,4C,4L\s0\& ABBR:\s-34L\s0\& ADDRESS:\s-33.2,4C,4L\s0\&
APPLET:\s-33.2,4L\s0\& B:\s-33.2,4C,4L\s0\& BDO:\s-34C,4L\s0\&
BIG:\s-33.2,4C,4L\s0\& BLOCKQUOTE:\s-33.2,4C,4L\s0\&
BODY:\s-33.2,4C,4L\s0\& CAPTION:\s-33.2,4C,4L\s0\&
CENTER:\s-33.2,4C,4L\s0\& CITE:\s-33.2,4C,4L\s0\&
CODE:\s-33.2,4C,4L\s0\& DD:\s-33.2,4C,4L\s0\& DEL:\s-34L\s0\&
DFN:\s-33.2,4C,4L\s0\& DIV:\s-33.2,4C,4L\s0\& DT:\s-33.2,4C,4L\s0\&
EM:\s-33.2,4C,4L\s0\& FIELDSET:\s-34C,4L\s0\& FONT:\s-33.2,4C,4L\s0\&
FORM H1:\s-33.2,4C,4L\s0\& H2:\s-33.2,4C,4L\s0\& H3:\s-33.2,4C,4L\s0\&
H4:\s-33.2,4C,4L\s0\& H5:\s-33.2,4C,4L\s0\& H6:\s-33.2,4C,4L\s0\&
I:\s-33.2,4C,4L\s0\& IFRAME:\s-34L\s0\& INS:\s-34L\s0\&
KBD:\s-33.2,4C,4L\s0\& LABEL:\s-34C,4L\s0\& LEGEND:\s-34L\s0\&
LI:\s-33.2,4C,4L\s0\& NOSCRIPT:\s-34L\s0\& OBJECT:\s-34C,4L\s0\&
P:\s-33.2,4C,4L\s0\& PRE:\s-33.2,4C,4L\s0\& Q:\s-34C,4L\s0\&
S:\s-34C,4L\s0\& SAMP:\s-33.2,4C,4L\s0\& SMALL:\s-33.2,4C,4L\s0\&
SPAN:\s-34C,4L\s0\& STRIKE:\s-33.2,4L\s0\& STRONG:\s-33.2,4C,4L\s0\&
SUB:\s-33.2,4C,4L\s0\& SUP:\s-33.2,4C,4L\s0\& TD:\s-33.2,4C,4L\s0\&
TEXTFLOW:\s-34C\s0\& TH:\s-33.2,4C,4L\s0\& TT:\s-33.2,4C,4L\s0\&
U:\s-33.2,4C,4L\s0\& VAR:\s-33.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA
.RE
.\"
.RS
.I "cannot contain:"
INPUT:\s-33\s0\& SELECT:\s-33\s0\& TEXTAREA:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<TEXTFLOW>" " \s-3optional:4C\s0\&" " .\|.\|. </TEXTFLOW>" " \s-3optional:4C\s0\&"
.\"
.RS
.I "contained in:"
APPLET:\s-34C\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-34C\s0\& A:\s-34C\s0\& APPLET:\s-34C\s0\& B:\s-34C\s0\&
BASEFONT:\s-34C\s0\& BDO:\s-34C\s0\& BIG:\s-34C\s0\& BR:\s-34C\s0\&
CITE:\s-34C\s0\& CODE:\s-34C\s0\& DFN:\s-34C\s0\& EM:\s-34C\s0\&
FONT:\s-34C\s0\& I:\s-34C\s0\& IMG:\s-34C\s0\& INPUT:\s-34C\s0\&
KBD:\s-34C\s0\& LABEL:\s-34C\s0\& MAP:\s-34C\s0\& OBJECT:\s-34C\s0\&
Q:\s-34C\s0\& S:\s-34C\s0\& SAMP:\s-34C\s0\& SCRIPT:\s-34C\s0\&
SELECT:\s-34C\s0\& SMALL:\s-34C\s0\& SPAN:\s-34C\s0\& STRONG:\s-34C\s0\&
STYLE:\s-34C\s0\& SUB:\s-34C\s0\& SUP:\s-34C\s0\& TEXTAREA:\s-34C\s0\&
TT:\s-34C\s0\& U:\s-34C\s0\& VAR:\s-34C\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<TFOOT>" " \s-3required:4C,4L\s0\&" " .\|.\|. </TFOOT>" " \s-3optional:4C,4L\s0\&"
.\"
.RS
.I "contained in:"
TABLE:\s-34C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
TR:\s-34C,4L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<TH>" " \s-3required:3,3.2,4C,4L\s0\&" " .\|.\|. </TH>" " \s-3optional:3,3.2,4C,4L\s0\&"
.\"
.RS
.I "contained in:"
TR:\s-33,3.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33,3.2,4C,4L\s0\& A:\s-33,3.2,4C,4L\s0\& ABBR:\s-34L\s0\&
ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& ADDRESS:\s-33,3.2,4C,4L\s0\&
APPLET:\s-33.2,4C,4L\s0\& AU:\s-33\s0\& B:\s-33,3.2,4C,4L\s0\&
BASEFONT:\s-33.2,4C,4L\s0\& BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\&
BLOCKQUOTE:\s-33,3.2,4C,4L\s0\& BQ:\s-33\s0\& BR:\s-33,3.2,4C,4L\s0\&
BUTTON:\s-34L\s0\& CENTER:\s-33.2,4C,4L\s0\& CITE:\s-33,3.2,4C,4L\s0\&
CODE:\s-33,3.2,4C,4L\s0\& DEL:\s-33\s0\& DFN:\s-33,3.2,4C,4L\s0\&
DIR:\s-33,3.2,4C,4L\s0\& DIV:\s-33,3.2,4C,4L\s0\&
DL:\s-33,3.2,4C,4L\s0\& EM:\s-33,3.2,4C,4L\s0\& FIELDSET:\s-34C,4L\s0\&
FIG:\s-33\s0\& FONT:\s-33.2,4C,4L\s0\& FORM:\s-33,3.2,4C,4L\s0\&
H1:\s-33,3.2,4C,4L\s0\& H2:\s-33,3.2,4C,4L\s0\& H3:\s-33,3.2,4C,4L\s0\&
H4:\s-33,3.2,4C,4L\s0\& H5:\s-33,3.2,4C,4L\s0\& H6:\s-33,3.2,4C,4L\s0\&
HR:\s-33,3.2,4C,4L\s0\& I:\s-33,3.2,4C,4L\s0\& IFRAME:\s-34L\s0\&
IMG:\s-33,3.2,4C,4L\s0\& INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\&
ISINDEX:\s-33,3.2,4C,4L\s0\& KBD:\s-33,3.2,4C,4L\s0\&
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& LISTING:\s-33,3.2,4C\s0\&
MAP:\s-33.2,4C,4L\s0\& MATH:\s-33\s0\& MENU:\s-33,3.2,4C,4L\s0\&
NOFRAMES:\s-34L\s0\& NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& OL:\s-33,3.2,4C,4L\s0\& P:\s-33,3.2,4C,4L\s0\&
PERSON:\s-33\s0\& PRE:\s-33,3.2,4C,4L\s0\& Q:\s-33,4C,4L\s0\&
S:\s-33,4C,4L\s0\& SAMP:\s-33,3.2,4C,4L\s0\& SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG:\s-33,3.2,4C,4L\s0\& STYLE:\s-34C\s0\&
SUB:\s-33,3.2,4C,4L\s0\& SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\&
TABLE:\s-33,3.2,4C,4L\s0\& TEXTAREA:\s-33.2,4C,4L\s0\&
TT:\s-33,3.2,4C,4L\s0\& U:\s-33,3.2,4C,4L\s0\& UL:\s-33,3.2,4C,4L\s0\&
VAR:\s-33,3.2,4C,4L\s0\& XMP:\s-33,3.2,4C\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<THEAD>" " \s-3required:4C,4L\s0\&" " .\|.\|. </THEAD>" " \s-3optional:4C,4L\s0\&"
.\"
.RS
.I "contained in:"
TABLE:\s-34C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
TR:\s-34C,4L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<TILDE>" " \s-3required:3\s0\&" " .\|.\|. </TILDE>" " \s-3required:3\s0\&"
.\"
.RS
.I "contained in:"
ABOVE:\s-33\s0\& BAR:\s-33\s0\& BELOW:\s-33\s0\& BOX:\s-33\s0\&
BT:\s-33\s0\& DDOT:\s-33\s0\& DOT:\s-33\s0\& HAT:\s-33\s0\&
ITEM:\s-33\s0\& MATH:\s-33\s0\& OF:\s-33\s0\& ROOT:\s-33\s0\&
SQRT:\s-33\s0\& T:\s-33\s0\& TILDE:\s-33\s0\& VEC:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33\s0\& ABOVE:\s-33\s0\& ARRAY:\s-33\s0\& B:\s-33\s0\&
BAR:\s-33\s0\& BELOW:\s-33\s0\& BOX:\s-33\s0\& BT:\s-33\s0\&
DDOT:\s-33\s0\& DOT:\s-33\s0\& HAT:\s-33\s0\& ROOT:\s-33\s0\&
SQRT:\s-33\s0\& SUB:\s-33\s0\& SUP:\s-33\s0\& T:\s-33\s0\&
TILDE:\s-33\s0\& VEC:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<TITLE>" "\&" " .\|.\|. </TITLE>" "\&"
.\"
.RS
.I "contained in:"
HEAD
.RE
.\"
.RS
.I "contains:"
#PCDATA
.RE
.\"
.RS
.I "cannot contain:"
LINK:\s-33.2,4C,4L\s0\& META:\s-33.2,4C,4L\s0\&
SCRIPT:\s-33.2,4C,4L\s0\& STYLE:\s-33.2,4C,4L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<TR>" " \s-3required:3,3.2,4C,4L\s0\&" " .\|.\|. </TR>" " \s-3optional:3,3.2,4C,4L\s0\&"
.\"
.RS
.I "contained in:"
TABLE:\s-33,3.2\s0\& TBODY:\s-34C,4L\s0\& TFOOT:\s-34C,4L\s0\&
THEAD:\s-34C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
TD:\s-33,3.2,4C,4L\s0\& TH:\s-33,3.2,4C,4L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<TT>" "\&" " .\|.\|. </TT>" "\&"
.\"
.RS
.I "contained in:"
A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& ADDRESS
APPLET:\s-33.2,4L\s0\& AU:\s-33\s0\& B BDO:\s-34C,4L\s0\&
BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BLOCKQUOTE BODY BQ:\s-33\s0\&
BUTTON:\s-34L\s0\& CAPTION:\s-33,3.2,4C,4L\s0\&
CENTER:\s-33.2,4C,4L,M\s0\& CITE CODE CREDIT:\s-33\s0\& DD
DEL:\s-33,4L\s0\& DFN:\s-33,3.2,4C,4L\s0\& DIV:\s-33,3.2,4C,4L\s0\& DT
EM FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\& FONT:\s-33.2,4C,4L,M\s0\& FORM
H1 H2 H3 H4 H5 H6 I IFRAME:\s-34L\s0\& INS:\s-33,4L\s0\& KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& LEGEND:\s-34L\s0\& LH:\s-33\s0\& LI
NOBR:\s-3M\s0\& NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& P PERSON:\s-33\s0\& PRE Q:\s-33,4C,4L\s0\&
S:\s-33,4C,4L\s0\& SAMP SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TD:\s-33,3.2,4C,4L\s0\& TEXTFLOW:\s-34C\s0\&
TH:\s-33,3.2,4C,4L\s0\& TT U:\s-33,3.2,4C,4L\s0\& VAR
.RE
.\"
.RS
.I "contains:"
#PCDATA A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
APPLET:\s-33.2,4C,4L\s0\& AU:\s-33\s0\& B BASEFONT:\s-33.2,4C,4L,M\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BR
BUTTON:\s-34L\s0\& CENTER:\s-3M\s0\& CITE CODE DEL:\s-33\s0\&
DFN:\s-33,3.2,4C,4L\s0\& EM FONT:\s-33.2,4C,4L,M\s0\& I
IFRAME:\s-34L\s0\& IMG INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\& KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& MAP:\s-33.2,4C,4L\s0\&
MATH:\s-33\s0\& NOBR:\s-3M\s0\& OBJECT:\s-34C,4L\s0\& PERSON:\s-33\s0\&
Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\& SAMP SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG STYLE:\s-34C\s0\& SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\& TEXTAREA:\s-33.2,4C,4L\s0\& TT
U:\s-33,3.2,4C,4L\s0\& VAR WBR:\s-3M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<U>" " \s-3required:3,3.2,4C,4L\s0\&" " .\|.\|. </U>" " \s-3required:3,3.2,4C,4L\s0\&"
.\"
.RS
.I "contained in:"
A:\s-33,3.2,4C,4L\s0\& ABBR:\s-34L\s0\& ABBREV:\s-33\s0\&
ACRONYM:\s-33\s0\& ADDRESS:\s-33,3.2,4C,4L\s0\& APPLET:\s-33.2,4L\s0\&
AU:\s-33\s0\& B:\s-33,3.2,4C,4L\s0\& BDO:\s-34C,4L\s0\&
BIG:\s-33,3.2,4C,4L\s0\& BLOCKQUOTE:\s-33,3.2,4C,4L\s0\&
BODY:\s-33,3.2,4C,4L\s0\& BQ:\s-33\s0\& BUTTON:\s-34L\s0\&
CAPTION:\s-33,3.2,4C,4L\s0\& CENTER:\s-33.2,4C,4L\s0\&
CITE:\s-33,3.2,4C,4L\s0\& CODE:\s-33,3.2,4C,4L\s0\& CREDIT:\s-33\s0\&
DD:\s-33,3.2,4C,4L\s0\& DEL:\s-33,4L\s0\& DFN:\s-33,3.2,4C,4L\s0\&
DIV:\s-33,3.2,4C,4L\s0\& DT:\s-33,3.2,4C,4L\s0\& EM:\s-33,3.2,4C,4L\s0\&
FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\& FONT:\s-33.2,4C,4L\s0\&
FORM:\s-33,3.2,4C,4L\s0\& H1:\s-33,3.2,4C,4L\s0\&
H2:\s-33,3.2,4C,4L\s0\& H3:\s-33,3.2,4C,4L\s0\& H4:\s-33,3.2,4C,4L\s0\&
H5:\s-33,3.2,4C,4L\s0\& H6:\s-33,3.2,4C,4L\s0\& I:\s-33,3.2,4C,4L\s0\&
IFRAME:\s-34L\s0\& INS:\s-33,4L\s0\& KBD:\s-33,3.2,4C,4L\s0\&
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& LEGEND:\s-34L\s0\& LH:\s-33\s0\&
LI:\s-33,3.2,4C,4L\s0\& NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& P:\s-33,3.2,4C,4L\s0\& PERSON:\s-33\s0\&
PRE:\s-33,3.2,4C,4L\s0\& Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\&
SAMP:\s-33,3.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG:\s-33,3.2,4C,4L\s0\&
SUB:\s-33,3.2,4C,4L\s0\& SUP:\s-33,3.2,4C,4L\s0\&
TD:\s-33,3.2,4C,4L\s0\& TEXTFLOW:\s-34C\s0\& TH:\s-33,3.2,4C,4L\s0\&
TT:\s-33,3.2,4C,4L\s0\& U:\s-33,3.2,4C,4L\s0\& VAR:\s-33,3.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33,3.2,4C,4L\s0\& A:\s-33,3.2,4C,4L\s0\& ABBR:\s-34L\s0\&
ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& APPLET:\s-33.2,4C,4L\s0\&
AU:\s-33\s0\& B:\s-33,3.2,4C,4L\s0\& BASEFONT:\s-33.2,4C,4L\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\& BR:\s-33,3.2,4C,4L\s0\&
BUTTON:\s-34L\s0\& CITE:\s-33,3.2,4C,4L\s0\& CODE:\s-33,3.2,4C,4L\s0\&
DEL:\s-33\s0\& DFN:\s-33,3.2,4C,4L\s0\& EM:\s-33,3.2,4C,4L\s0\&
FONT:\s-33.2,4C,4L\s0\& I:\s-33,3.2,4C,4L\s0\& IFRAME:\s-34L\s0\&
IMG:\s-33,3.2,4C,4L\s0\& INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\&
KBD:\s-33,3.2,4C,4L\s0\& LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\&
MAP:\s-33.2,4C,4L\s0\& MATH:\s-33\s0\& OBJECT:\s-34C,4L\s0\&
PERSON:\s-33\s0\& Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\&
SAMP:\s-33,3.2,4C,4L\s0\& SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG:\s-33,3.2,4C,4L\s0\& STYLE:\s-34C\s0\&
SUB:\s-33,3.2,4C,4L\s0\& SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\&
TEXTAREA:\s-33.2,4C,4L\s0\& TT:\s-33,3.2,4C,4L\s0\&
U:\s-33,3.2,4C,4L\s0\& VAR:\s-33,3.2,4C,4L\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<UL>" "\&" " .\|.\|. </UL>" "\&"
.\"
.RS
.I "contained in:"
APPLET:\s-34L\s0\& BLOCKQUOTE BODY BQ:\s-33\s0\& BUTTON:\s-34L\s0\&
CENTER:\s-33.2,4C,4L,M\s0\& DD DEL:\s-34L\s0\& DIV:\s-33,3.2,4C,4L\s0\&
FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\& FORM IFRAME:\s-34L\s0\&
INS:\s-34L\s0\& LI NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& TD:\s-33,3.2,4C,4L\s0\& TH:\s-33,3.2,4C,4L\s0\&
.RE
.\"
.RS
.I "contains:"
LH:\s-33\s0\& LI
.RE
.\"---------------------------------------------------------------------
.BR "<VAR>" "\&" " .\|.\|. </VAR>" "\&"
.\"
.RS
.I "contained in:"
A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\& ADDRESS
APPLET:\s-33.2,4L\s0\& AU:\s-33\s0\& B BDO:\s-34C,4L\s0\&
BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BLOCKQUOTE BODY BQ:\s-33\s0\&
BUTTON:\s-34L\s0\& CAPTION:\s-33,3.2,4C,4L\s0\&
CENTER:\s-33.2,4C,4L,M\s0\& CITE CODE CREDIT:\s-33\s0\& DD
DEL:\s-33,4L\s0\& DFN:\s-33,3.2,4C,4L\s0\& DIV:\s-33,3.2,4C,4L\s0\& DT
EM FIELDSET:\s-34C,4L\s0\& FIG:\s-33\s0\& FONT:\s-33.2,4C,4L,M\s0\& FORM
H1 H2 H3 H4 H5 H6 I IFRAME:\s-34L\s0\& INS:\s-33,4L\s0\& KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& LEGEND:\s-34L\s0\& LH:\s-33\s0\& LI
NOBR:\s-3M\s0\& NOSCRIPT:\s-34L\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C,4L\s0\& P PERSON:\s-33\s0\& PRE Q:\s-33,4C,4L\s0\&
S:\s-33,4C,4L\s0\& SAMP SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TD:\s-33,3.2,4C,4L\s0\& TEXTFLOW:\s-34C\s0\&
TH:\s-33,3.2,4C,4L\s0\& TT U:\s-33,3.2,4C,4L\s0\& VAR
.RE
.\"
.RS
.I "contains:"
#PCDATA A ABBR:\s-34L\s0\& ABBREV:\s-33\s0\& ACRONYM:\s-33\s0\&
APPLET:\s-33.2,4C,4L\s0\& AU:\s-33\s0\& B BASEFONT:\s-33.2,4C,4L,M\s0\&
BDO:\s-34C,4L\s0\& BIG:\s-33,3.2,4C,4L\s0\& BLINK:\s-3M\s0\& BR
BUTTON:\s-34L\s0\& CENTER:\s-3M\s0\& CITE CODE DEL:\s-33\s0\&
DFN:\s-33,3.2,4C,4L\s0\& EM FONT:\s-33.2,4C,4L,M\s0\& I
IFRAME:\s-34L\s0\& IMG INPUT:\s-33.2,4C,4L\s0\& INS:\s-33\s0\& KBD
LABEL:\s-34C,4L\s0\& LANG:\s-33\s0\& MAP:\s-33.2,4C,4L\s0\&
MATH:\s-33\s0\& NOBR:\s-3M\s0\& OBJECT:\s-34C,4L\s0\& PERSON:\s-33\s0\&
Q:\s-33,4C,4L\s0\& S:\s-33,4C,4L\s0\& SAMP SCRIPT:\s-33.2,4C,4L\s0\&
SELECT:\s-33.2,4C,4L\s0\& SMALL:\s-33,3.2,4C,4L\s0\& SPAN:\s-34C,4L\s0\&
STRIKE:\s-33.2,4L\s0\& STRONG STYLE:\s-34C\s0\& SUB:\s-33,3.2,4C,4L\s0\&
SUP:\s-33,3.2,4C,4L\s0\& TAB:\s-33\s0\& TEXTAREA:\s-33.2,4C,4L\s0\& TT
U:\s-33,3.2,4C,4L\s0\& VAR WBR:\s-3M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<VEC>" " \s-3required:3\s0\&" " .\|.\|. </VEC>" " \s-3required:3\s0\&"
.\"
.RS
.I "contained in:"
ABOVE:\s-33\s0\& BAR:\s-33\s0\& BELOW:\s-33\s0\& BOX:\s-33\s0\&
BT:\s-33\s0\& DDOT:\s-33\s0\& DOT:\s-33\s0\& HAT:\s-33\s0\&
ITEM:\s-33\s0\& MATH:\s-33\s0\& OF:\s-33\s0\& ROOT:\s-33\s0\&
SQRT:\s-33\s0\& T:\s-33\s0\& TILDE:\s-33\s0\& VEC:\s-33\s0\&
.RE
.\"
.RS
.I "contains:"
#PCDATA:\s-33\s0\& ABOVE:\s-33\s0\& ARRAY:\s-33\s0\& B:\s-33\s0\&
BAR:\s-33\s0\& BELOW:\s-33\s0\& BOX:\s-33\s0\& BT:\s-33\s0\&
DDOT:\s-33\s0\& DOT:\s-33\s0\& HAT:\s-33\s0\& ROOT:\s-33\s0\&
SQRT:\s-33\s0\& SUB:\s-33\s0\& SUP:\s-33\s0\& T:\s-33\s0\&
TILDE:\s-33\s0\& VEC:\s-33\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<WBR>" " \s-3required:M\s0\&"
.\"
.RS
.I "contained in:"
A:\s-3M\s0\& ADDRESS:\s-3M\s0\& B:\s-3M\s0\& BLINK:\s-3M\s0\&
BLOCKQUOTE:\s-3M\s0\& BODY:\s-3M\s0\& CENTER:\s-3M\s0\& CITE:\s-3M\s0\&
CODE:\s-3M\s0\& DD:\s-3M\s0\& DT:\s-3M\s0\& EM:\s-3M\s0\&
FONT:\s-3M\s0\& FORM:\s-3M\s0\& H1:\s-3M\s0\& H2:\s-3M\s0\&
H3:\s-3M\s0\& H4:\s-3M\s0\& H5:\s-3M\s0\& H6:\s-3M\s0\& I:\s-3M\s0\&
KBD:\s-3M\s0\& LI:\s-3M\s0\& NOBR:\s-3M\s0\& P:\s-3M\s0\&
SAMP:\s-3M\s0\& STRONG:\s-3M\s0\& TT:\s-3M\s0\& VAR:\s-3M\s0\&
.RE
.\"
.RS
.I "contains:"
EMPTY:\s-3M\s0\&
.RE
.\"---------------------------------------------------------------------
.BR "<XMP>" " \s-3required:2,3,3.2,4C,M\s0\&" " .\|.\|. </XMP>" " \s-3required:2,3,3.2,4C,M\s0\&" " (deprecated)"
.\"
.RS
.I "contained in:"
BLOCKQUOTE:\s-32,3,3.2,4C,M\s0\& BODY:\s-32,3,3.2,4C,M\s0\&
BQ:\s-33\s0\& CENTER:\s-33.2,4C,M\s0\& DD:\s-32,3,3.2,4C,M\s0\&
DIV:\s-33,3.2,4C\s0\& FIELDSET:\s-34C\s0\& FIG:\s-33\s0\&
FORM:\s-32,3,3.2,4C,M\s0\& LI:\s-32,3,3.2,4C,M\s0\& NOTE:\s-33\s0\&
OBJECT:\s-34C\s0\& TD:\s-33,3.2,4C\s0\& TH:\s-33,3.2,4C\s0\&
.RE
.\"
.RS
.I "contains:"
CDATA:\s-32,3,3.2,4C,M\s0\&
.RE
.\"*********************************************************************
.hy
.ad
.\"=====================================================================
.SH "PRETTYPRINTER LIMITATIONS"
Like \*(La\&, Lisp, \*(Ps\&, and \*(Te\&, SGML is an
.I extensible
language.  In particular, at run time, it is possible to redefine the
syntax and semantics of all lexical elements, including the base
character set, the characters that may appear in identifiers, and the
special characters that delimit tags or strings.
.PP
In SGML, this is conventionally done in SGML declaration files for
syntax definitions, and in DTD files, which are analogous to \*(La\&
style files.  Low-level typesetting commands of the flavor ``select a
14-point Lucida-BoldItalic font'', ``skip down vertically 6 picas'',
and ``draw a horizontal rule 3 ems long'' are notably absent.  SGML
documents are expected to use only high-level markup commands, leaving
the visual appearance entirely up to the DTD specification, and the
formatting software.
.PP
Unlike \*(La\& and \*(Te\&, SGML is
.I not
a typesetting system.  It is only a grammar for a standard markup
language, and it is left to SGML software implementors to write DTDs,
and to provide for translation of SGML documents to specific document
formatting, typesetting, or word processing systems.  In this respect,
SGML is similar to the RTF (Rich Text Format) supported by many
popular word processors, in that it can serve as an intermediate
language for electronic document exchange; several language
translators between SGML and other text representations are mentioned
in the
.B "SEE ALSO"
section below.  Regrettably, there is wide variation in the
capabilities and document models of current text formatting systems,
so such translations are usually rough approximations that may require
substantial hand patching to make them truly satisfactory.
.PP
HTML is a modest subset of SGML, with tag names apparently chosen from
SGML, the Free Software Foundation's \*(Te\&info system (which in turn
is modeled on the earlier Scribe document formatting system), and
occasionally, also from \*(La\&.
.PP
.B html-pretty
is written in this spirit: it knows about the meaning and typical
use of all standard HTML tags, but nothing about other SGML DTDs.
However, the style-file facility makes it possible to prepare
formatting rules for
.I any
SGML DTD, extending the applicability of
.B html-pretty
to the entire world of SGML, provided a tag normalizer such as
.BR sgmlnorm (1)
or
.BR spam (1)
is available to supply omitted tags, and expand abbreviated ones.
However, since SGML tag names depend on the specific DTD, and DTDs
tend to be proprietary,
.B html-pretty
is not packaged with pre-written style files for SGML.
.PP
Contributions of suitable style files for public SGML DTDs, together
with those DTDs, are hereby solicited, and they may be included in
future releases of
.BR html-pretty .
.\"=====================================================================
.SH "PRETTYPRINTER IMPLEMENTATION LIMITS"
As with most computer software, there are certain limitations
in
.B html-pretty
on object sizes, imposed by fixed array dimensions or addressing
limits of the computer hardware and operating system.  Here are the
.I minimum
values that all
.B html-pretty
implementations must provide in order to conform to this
documentation; implementations on some systems may have much more
generous limits.
.IP
2048 characters in single words, tag names, and filenames (this must
be at least as large as the
.I LITLEN
limit set in the SGML parser declaration file
.IR html.decl );
.IP
100 levels of list and environment nesting (this must be at least as
large as the
.I TAGLVL
limit set in the SGML parser declaration file
.IR html.decl );
.IP
6 simultaneously open files
.RI ( stdin ,
.IR stderr ,
and
.IR stdout ,
plus the style catalog file, and two style files, allowing at least
two levels of style file nesting).
.PP
These are ample for any realistic document: they support the longest
legal file paths in all major current operating systems, World-Wide
Web URLs, and HTML tags named after 58-letter Welsh towns like
.\" From the TeXbook (p. 451) source: $TEX/doc/texman.tex, line 25277
Llan\%fair\%pwll\%gwyn\%gyll\%go\%ger\%y\%chwyrn\%dro\%bwll\%llan\%ty\%sil\%i\%o\%go\%go\%goch,
yet will still work on the smallest personal computer operating
systems.
.PP
There is
.I no
limit on the size of input or output files and lines, other than that
imposed by physical storage limits of the host file system and the
computer address space.
.\"=====================================================================
.SH "SEE ALSO"
.BR amaya (1),
.BR arena (1),
.BR chimera (1),
.BR emacs (1),
.BR expand (1),
.BR grail (1),
.BR hotjava (1),
.BR html-check (1),
.BR html-ncheck (1),
.BR html-norm (1),
.BR html-spam (1),
.BR html2latex (1),
.BR htmlchek (1),
.BR jde (1),
.BR latex (1),
.BR latex2html (1),
.BR latex2rtf (1),
.BR lisp (1),
.BR lynx (1),
.BR man2html (1),
.BR netscape (1),
.BR nsgmls (1),
.BR panorama (1),
.BR rman (1),
.BR RosettaMan (1),
.BR rtf2LaTeX (1),
.BR rtf2html (1),
.BR rtf2tex (1),
.BR rtflatex (1),
.BR scribe (1),
.BR sgmlnorm (1),
.BR sgmls (1),
.BR spam (1),
.BR tex (1),
.BR tex-pretty (1),
.BR texi2html (1),
.BR texi2roff (1),
.BR texinfo (1),
.BR unexpand (1),
.BR xmosaic (1).
.PP
The ISO 8879 SGML Standard is contained in the book
.PP
.RS
.nf
Charles F. Goldfarb and Yuri Rubinsky
.I "The SGML Handbook"
Cambridge University Press
1990
xxiv + 663 pp.
ISBN 0-19-853737-9
LCCN Z286.E43 G64 1990
.fi
.RE
.PP
That book serves as the `scriptures' of SGML; it even has long blue
ribbons attached to serve as page marks!
.PP
References to nearly 300 books and over 1000 other publications about
SGML can be found at these World-Wide Web locations:
.PP
.RS
.nf
\&\fCftp://ftp.math.utah.edu/pub/tex/bib/index.html#sgml\fP
\&\fChttp://sgml.sgmlopen.org/\fP
\&\fChttp://www.sil.org/sgml/sgml.html\fP
\&\fChttp://www.falch.no/people/pepper/sgmltool/\fP
.fi
.RE
.PP
SGML software repositories are available at:
.PP
.RS
.nf
\&\fChttp://sgml.sgmlopen.org/\fP
\&\fCftp://ftp.math.utah.edu/pub/sgml\fP
.fi
.RE
.PP
The latter has source and binary distributions for several of the SGML
tools mentioned at the start of this section, including
.BR html-check (1),
.BR html-ncheck (1),
.BR html-pretty ,
.BR html-spam (1),
.BR man2html (1),
.BR nsgmls (1),
.BR sgmlnorm (1),
.BR sgmls (1),
and
.BR spam (1).
.\"=====================================================================
.SH AUTHOR
.nf
Nelson H. F. Beebe, Ph.D.
Center for Scientific Computing
University of Utah
Department of Mathematics, 105 JWB
155 S 1400 E RM 233
Salt Lake City, UT 84112-0090
Tel: +1 801 581 5254
FAX: +1 801 581 4148
Email: \fCbeebe@math.utah.edu\fP, \fCbeebe@acm.org\fP, \fCbeebe@ieee.org\fP (Internet)
WWW URL: \fChttp://www.math.utah.edu/~beebe\fP
.fi
.\"=====================================================================
.SH AVAILABILITY
.B html-pretty
is freely available; its master distribution can be found at
.PP
.RS
.nf
\&\fCftp://ftp.math.utah.edu/pub/sgml/\fP
.fi
.RE
.PP
in the file
.I htmlpty-x.yy.tar.gz
where
.I x.yy
is the current version.  Other distribution formats are usually
available in the same location.  Several other SGML and HTML tools are
available in that same directory.
.PP
That site is mirrored to several other Internet archives, so you may
also be able to find it elsewhere on the Internet; try searching
for the string
.I htmlpty
at one or more of the popular Web search sites, such as
.PP
.RS
.nf
\&\fChttp://altavista.digital.com/
http://www.hotbot.com/
http://www.stpt.com/
http://www.yahoo.com/\fP
.fi
.RE
.\"==============================[The End]==============================
